# Language Features for JSON files

**Notice:** This extension is bundled with Visual Studio Code. It can be disabled but not uninstalled.

## Features

See [JSON in Visual Studio Code](https://code.visualstudio.com/docs/languages/json) to learn about the features of this extension.

<h1><p align="center"><img alt="protobuf.js" src="https://github.com/dcodeIO/protobuf.js/raw/master/pbjs.png" width="120" height="104" /></p></h1>
<p align="center"><a href="https://npmjs.org/package/protobufjs"><img src="https://img.shields.io/npm/v/protobufjs.svg" alt=""></a> <a href="https://travis-ci.org/dcodeIO/protobuf.js"><img src="https://travis-ci.org/dcodeIO/protobuf.js.svg?branch=master" alt=""></a> <a href="https://npmjs.org/package/protobufjs"><img src="https://img.shields.io/npm/dm/protobufjs.svg" alt=""></a> <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=dcode%40dcode.io&item_name=Open%20Source%20Software%20Donation&item_number=dcodeIO%2Fprotobuf.js"><img alt="donate ❤" src="https://img.shields.io/badge/donate-❤-ff2244.svg"></a></p>

**Protocol Buffers** are a language-neutral, platform-neutral, extensible way of serializing structured data for use in communications protocols, data storage, and more, originally designed at Google ([see](https://developers.google.com/protocol-buffers/)).

**protobuf.js** is a pure JavaScript implementation with [TypeScript](https://www.typescriptlang.org) support for [node.js](https://nodejs.org) and the browser. It's easy to use, blazingly fast and works out of the box with [.proto](https://developers.google.com/protocol-buffers/docs/proto) files!

Contents
--------

* [Installation](#installation)<br />
  How to include protobuf.js in your project.

* [Usage](#usage)<br />
  A brief introduction to using the toolset.

  * [Valid Message](#valid-message)
  * [Toolset](#toolset)<br />

* [Examples](#examples)<br />
  A few examples to get you started.

  * [Using .proto files](#using-proto-files)
  * [Using JSON descriptors](#using-json-descriptors)
  * [Using reflection only](#using-reflection-only)
  * [Using custom classes](#using-custom-classes)
  * [Using services](#using-services)
  * [Usage with TypeScript](#usage-with-typescript)<br />

* [Command line](#command-line)<br />
  How to use the command line utility.

  * [pbjs for JavaScript](#pbjs-for-javascript)
  * [pbts for TypeScript](#pbts-for-typescript)
  * [Reflection vs. static code](#reflection-vs-static-code)
  * [Command line API](#command-line-api)<br />

* [Additional documentation](#additional-documentation)<br />
  A list of available documentation resources.

* [Performance](#performance)<br />
  A few internals and a benchmark on performance.

* [Compatibility](#compatibility)<br />
  Notes on compatibility regarding browsers and optional libraries.

* [Building](#building)<br />
  How to build the library and its components yourself.

Installation
---------------

### node.js

```
$> npm install protobufjs [--save --save-prefix=~]
```

```js
var protobuf = require("protobufjs");
```

**Note** that this library's versioning scheme is not semver-compatible for historical reasons. For guaranteed backward compatibility, always depend on `~6.A.B` instead of `^6.A.B` (hence the `--save-prefix` above).

### Browsers

Development:

```
<script src="//cdn.rawgit.com/dcodeIO/protobuf.js/6.X.X/dist/protobuf.js"></script>
```

Production:

```
<script src="//cdn.rawgit.com/dcodeIO/protobuf.js/6.X.X/dist/protobuf.min.js"></script>
```

**Remember** to replace the version tag with the exact [release](https://github.com/dcodeIO/protobuf.js/tags) your project depends upon.

The library supports CommonJS and AMD loaders and also exports globally as `protobuf`.

### Distributions

Where bundle size is a factor, there are additional stripped-down versions of the [full library][dist-full] (~19kb gzipped) available that exclude certain functionality:

* When working with JSON descriptors (i.e. generated by [pbjs](#pbjs-for-javascript)) and/or reflection only, see the [light library][dist-light] (~16kb gzipped) that excludes the parser. CommonJS entry point is:

  ```js
  var protobuf = require("protobufjs/light");
  ```

* When working with statically generated code only, see the [minimal library][dist-minimal] (~6.5kb gzipped) that also excludes reflection. CommonJS entry point is:

  ```js
  var protobuf = require("protobufjs/minimal");
  ```

[dist-full]: https://github.com/dcodeIO/protobuf.js/tree/master/dist
[dist-light]: https://github.com/dcodeIO/protobuf.js/tree/master/dist/light
[dist-minimal]: https://github.com/dcodeIO/protobuf.js/tree/master/dist/minimal

Usage
-----

Because JavaScript is a dynamically typed language, protobuf.js introduces the concept of a **valid message** in order to provide the best possible [performance](#performance) (and, as a side product, proper typings):

### Valid message

> A valid message is an object (1) not missing any required fields and (2) exclusively composed of JS types understood by the wire format writer.

There are two possible types of valid messages and the encoder is able to work with both of these for convenience:

* **Message instances** (explicit instances of message classes with default values on their prototype) always (have to) satisfy the requirements of a valid message by design and
* **Plain JavaScript objects** that just so happen to be composed in a way satisfying the requirements of a valid message as well.

In a nutshell, the wire format writer understands the following types:

| Field type | Expected JS type (create, encode) | Conversion (fromObject)
|------------|-----------------------------------|------------------------
| s-/u-/int32<br />s-/fixed32 | `number` (32 bit integer) | <code>value &#124; 0</code> if signed<br />`value >>> 0` if unsigned
| s-/u-/int64<br />s-/fixed64 | `Long`-like (optimal)<br />`number` (53 bit integer) | `Long.fromValue(value)` with long.js<br />`parseInt(value, 10)` otherwise
| float<br />double | `number` | `Number(value)`
| bool | `boolean` | `Boolean(value)`
| string | `string` | `String(value)`
| bytes | `Uint8Array` (optimal)<br />`Buffer` (optimal under node)<br />`Array.<number>` (8 bit integers) | `base64.decode(value)` if a `string`<br />`Object` with non-zero `.length` is assumed to be buffer-like
| enum | `number` (32 bit integer) | Looks up the numeric id if a `string`
| message | Valid message | `Message.fromObject(value)`

* Explicit `undefined` and `null` are considered as not set if the field is optional.
* Repeated fields are `Array.<T>`.
* Map fields are `Object.<string,T>` with the key being the string representation of the respective value or an 8 characters long binary hash string for `Long`-likes.
* Types marked as *optimal* provide the best performance because no conversion step (i.e. number to low and high bits or base64 string to buffer) is required.

### Toolset

With that in mind and again for performance reasons, each message class provides a distinct set of methods with each method doing just one thing. This avoids unnecessary assertions / redundant operations where performance is a concern but also forces a user to perform verification (of plain JavaScript objects that *might* just so happen to be a valid message) explicitly where necessary - for example when dealing with user input.

**Note** that `Message` below refers to any message class.

* **Message.verify**(message: `Object`): `null|string`<br />
  verifies that a **plain JavaScript object** satisfies the requirements of a valid message and thus can be encoded without issues. Instead of throwing, it returns the error message as a string, if any.

  ```js
  var payload = "invalid (not an object)";
  var err = AwesomeMessage.verify(payload);
  if (err)
    throw Error(err);
  ```

* **Message.encode**(message: `Message|Object` [, writer: `Writer`]): `Writer`<br />
  encodes a **message instance** or valid **plain JavaScript object**. This method does not implicitly verify the message and it's up to the user to make sure that the payload is a valid message.

  ```js
  var buffer = AwesomeMessage.encode(message).finish();
  ```

* **Message.encodeDelimited**(message: `Message|Object` [, writer: `Writer`]): `Writer`<br />
  works like `Message.encode` but additionally prepends the length of the message as a varint.

* **Message.decode**(reader: `Reader|Uint8Array`): `Message`<br />
  decodes a buffer to a **message instance**. If required fields are missing, it throws a `util.ProtocolError` with an `instance` property set to the so far decoded message. If the wire format is invalid, it throws an `Error`.

  ```js
  try {
    var decodedMessage = AwesomeMessage.decode(buffer);
  } catch (e) {
      if (e instanceof protobuf.util.ProtocolError) {
        // e.instance holds the so far decoded message with missing required fields
      } else {
        // wire format is invalid
      }
  }
  ```

* **Message.decodeDelimited**(reader: `Reader|Uint8Array`): `Message`<br />
  works like `Message.decode` but additionally reads the length of the message prepended as a varint.

* **Message.create**(properties: `Object`): `Message`<br />
  creates a new **message instance** from a set of properties that satisfy the requirements of a valid message. Where applicable, it is recommended to prefer `Message.create` over `Message.fromObject` because it doesn't perform possibly redundant conversion.

  ```js
  var message = AwesomeMessage.create({ awesomeField: "AwesomeString" });
  ```

* **Message.fromObject**(object: `Object`): `Message`<br />
  converts any non-valid **plain JavaScript object** to a **message instance** using the conversion steps outlined within the table above.

  ```js
  var message = AwesomeMessage.fromObject({ awesomeField: 42 });
  // converts awesomeField to a string
  ```

* **Message.toObject**(message: `Message` [, options: `ConversionOptions`]): `Object`<br />
  converts a **message instance** to an arbitrary **plain JavaScript object** for interoperability with other libraries or storage. The resulting plain JavaScript object *might* still satisfy the requirements of a valid message depending on the actual conversion options specified, but most of the time it does not.

  ```js
  var object = AwesomeMessage.toObject(message, {
    enums: String,  // enums as string names
    longs: String,  // longs as strings (requires long.js)
    bytes: String,  // bytes as base64 encoded strings
    defaults: true, // includes default values
    arrays: true,   // populates empty arrays (repeated fields) even if defaults=false
    objects: true,  // populates empty objects (map fields) even if defaults=false
    oneofs: true    // includes virtual oneof fields set to the present field's name
  });
  ```

For reference, the following diagram aims to display relationships between the different methods and the concept of a valid message:

<p align="center"><img alt="Toolset Diagram" src="https://protobufjs.github.io/protobuf.js/toolset.svg" /></p>

> In other words: `verify` indicates that calling `create` or `encode` directly on the plain object will [result in a valid message respectively] succeed. `fromObject`, on the other hand, does conversion from a broader range of plain objects to create valid messages. ([ref](https://github.com/dcodeIO/protobuf.js/issues/748#issuecomment-291925749))

Examples
--------

### Using .proto files

It is possible to load existing .proto files using the full library, which parses and compiles the definitions to ready to use (reflection-based) message classes:

```protobuf
// awesome.proto
package awesomepackage;
syntax = "proto3";

message AwesomeMessage {
    string awesome_field = 1; // becomes awesomeField
}
```

```js
protobuf.load("awesome.proto", function(err, root) {
    if (err)
        throw err;

    // Obtain a message type
    var AwesomeMessage = root.lookupType("awesomepackage.AwesomeMessage");

    // Exemplary payload
    var payload = { awesomeField: "AwesomeString" };

    // Verify the payload if necessary (i.e. when possibly incomplete or invalid)
    var errMsg = AwesomeMessage.verify(payload);
    if (errMsg)
        throw Error(errMsg);

    // Create a new message
    var message = AwesomeMessage.create(payload); // or use .fromObject if conversion is necessary

    // Encode a message to an Uint8Array (browser) or Buffer (node)
    var buffer = AwesomeMessage.encode(message).finish();
    // ... do something with buffer

    // Decode an Uint8Array (browser) or Buffer (node) to a message
    var message = AwesomeMessage.decode(buffer);
    // ... do something with message

    // If the application uses length-delimited buffers, there is also encodeDelimited and decodeDelimited.

    // Maybe convert the message back to a plain object
    var object = AwesomeMessage.toObject(message, {
        longs: String,
        enums: String,
        bytes: String,
        // see ConversionOptions
    });
});
```

Additionally, promise syntax can be used by omitting the callback, if preferred:

```js
protobuf.load("awesome.proto")
    .then(function(root) {
       ...
    });
```

### Using JSON descriptors

The library utilizes JSON descriptors that are equivalent to a .proto definition. For example, the following is identical to the .proto definition seen above:

```json
// awesome.json
{
  "nested": {
    "awesomepackage": {
      "nested": {
        "AwesomeMessage": {
          "fields": {
            "awesomeField": {
              "type": "string",
              "id": 1
            }
          }
        }
      }
    }
  }
}
```

JSON descriptors closely resemble the internal reflection structure:

| Type (T)           | Extends            | Type-specific properties
|--------------------|--------------------|-------------------------
| *ReflectionObject* |                    | options
| *Namespace*        | *ReflectionObject* | nested
| Root               | *Namespace*        | **nested**
| Type               | *Namespace*        | **fields**
| Enum               | *ReflectionObject* | **values**
| Field              | *ReflectionObject* | rule, **type**, **id**
| MapField           | Field              | **keyType**
| OneOf              | *ReflectionObject* | **oneof** (array of field names)
| Service            | *Namespace*        | **methods**
| Method             | *ReflectionObject* | type, **requestType**, **responseType**, requestStream, responseStream

* **Bold properties** are required. *Italic types* are abstract.
* `T.fromJSON(name, json)` creates the respective reflection object from a JSON descriptor
* `T#toJSON()` creates a JSON descriptor from the respective reflection object (its name is used as the key within the parent)

Exclusively using JSON descriptors instead of .proto files enables the use of just the light library (the parser isn't required in this case).

A JSON descriptor can either be loaded the usual way:

```js
protobuf.load("awesome.json", function(err, root) {
    if (err) throw err;

    // Continue at "Obtain a message type" above
});
```

Or it can be loaded inline:

```js
var jsonDescriptor = require("./awesome.json"); // exemplary for node

var root = protobuf.Root.fromJSON(jsonDescriptor);

// Continue at "Obtain a message type" above
```

### Using reflection only

Both the full and the light library include full reflection support. One could, for example, define the .proto definitions seen in the examples above using just reflection:

```js
...
var Root  = protobuf.Root,
    Type  = protobuf.Type,
    Field = protobuf.Field;

var AwesomeMessage = new Type("AwesomeMessage").add(new Field("awesomeField", 1, "string"));

var root = new Root().define("awesomepackage").add(AwesomeMessage);

// Continue at "Create a new message" above
...
```

Detailed information on the reflection structure is available within the [API documentation](#additional-documentation).

### Using custom classes

Message classes can also be extended with custom functionality and it is also possible to register a custom constructor with a reflected message type:

```js
...

// Define a custom constructor
function AwesomeMessage(properties) {
    // custom initialization code
    ...
}

// Register the custom constructor with its reflected type (*)
root.lookupType("awesomepackage.AwesomeMessage").ctor = AwesomeMessage;

// Define custom functionality
AwesomeMessage.customStaticMethod = function() { ... };
AwesomeMessage.prototype.customInstanceMethod = function() { ... };

// Continue at "Create a new message" above
```

(*) Besides referencing its reflected type through `AwesomeMessage.$type` and `AwesomeMesage#$type`, the respective custom class is automatically populated with:

* `AwesomeMessage.create`
* `AwesomeMessage.encode` and `AwesomeMessage.encodeDelimited`
* `AwesomeMessage.decode` and `AwesomeMessage.decodeDelimited`
* `AwesomeMessage.verify`
* `AwesomeMessage.fromObject`, `AwesomeMessage.toObject` and `AwesomeMessage#toJSON`

Afterwards, decoded messages of this type are `instanceof AwesomeMessage`.

Alternatively, it is also possible to reuse and extend the internal constructor if custom initialization code is not required:

```js
...

// Reuse the internal constructor
var AwesomeMessage = root.lookupType("awesomepackage.AwesomeMessage").ctor;

// Define custom functionality
AwesomeMessage.customStaticMethod = function() { ... };
AwesomeMessage.prototype.customInstanceMethod = function() { ... };

// Continue at "Create a new message" above
```

### Using services

The library also supports consuming services but it doesn't make any assumptions about the actual transport channel. Instead, a user must provide a suitable RPC implementation, which is an asynchronous function that takes the reflected service method, the binary request and a node-style callback as its parameters:

```js
function rpcImpl(method, requestData, callback) {
    // perform the request using an HTTP request or a WebSocket for example
    var responseData = ...;
    // and call the callback with the binary response afterwards:
    callback(null, responseData);
}
```

Below is a working example with a typescript implementation using grpc npm package.
```ts
const grpc = require('grpc')

const Client = grpc.makeGenericClientConstructor({})
const client = new Client(
  grpcServerUrl,
  grpc.credentials.createInsecure()
)

const rpcImpl = function(method, requestData, callback) {
  client.makeUnaryRequest(
    method.name,
    arg => arg,
    arg => arg,
    requestData,
    callback
  )
}
```

Example:

```protobuf
// greeter.proto
syntax = "proto3";

service Greeter {
    rpc SayHello (HelloRequest) returns (HelloReply) {}
}

message HelloRequest {
    string name = 1;
}

message HelloReply {
    string message = 1;
}
```

```js
...
var Greeter = root.lookup("Greeter");
var greeter = Greeter.create(/* see above */ rpcImpl, /* request delimited? */ false, /* response delimited? */ false);

greeter.sayHello({ name: 'you' }, function(err, response) {
    console.log('Greeting:', response.message);
});
```

Services also support promises:

```js
greeter.sayHello({ name: 'you' })
    .then(function(response) {
        console.log('Greeting:', response.message);
    });
```

There is also an [example for streaming RPC](https://github.com/dcodeIO/protobuf.js/blob/master/examples/streaming-rpc.js).

Note that the service API is meant for clients. Implementing a server-side endpoint pretty much always requires transport channel (i.e. http, websocket, etc.) specific code with the only common denominator being that it decodes and encodes messages.

### Usage with TypeScript

The library ships with its own [type definitions](https://github.com/dcodeIO/protobuf.js/blob/master/index.d.ts) and modern editors like [Visual Studio Code](https://code.visualstudio.com/) will automatically detect and use them for code completion.

The npm package depends on [@types/node](https://www.npmjs.com/package/@types/node) because of `Buffer` and [@types/long](https://www.npmjs.com/package/@types/long) because of `Long`. If you are not building for node and/or not using long.js, it should be safe to exclude them manually.

#### Using the JS API

The API shown above works pretty much the same with TypeScript. However, because everything is typed, accessing fields on instances of dynamically generated message classes requires either using bracket-notation (i.e. `message["awesomeField"]`) or explicit casts. Alternatively, it is possible to use a [typings file generated for its static counterpart](#pbts-for-typescript).

```ts
import { load } from "protobufjs"; // respectively "./node_modules/protobufjs"

load("awesome.proto", function(err, root) {
  if (err)
    throw err;

  // example code
  const AwesomeMessage = root.lookupType("awesomepackage.AwesomeMessage");

  let message = AwesomeMessage.create({ awesomeField: "hello" });
  console.log(`message = ${JSON.stringify(message)}`);

  let buffer = AwesomeMessage.encode(message).finish();
  console.log(`buffer = ${Array.prototype.toString.call(buffer)}`);

  let decoded = AwesomeMessage.decode(buffer);
  console.log(`decoded = ${JSON.stringify(decoded)}`);
});
```

#### Using generated static code

If you generated static code to `bundle.js` using the CLI and its type definitions to `bundle.d.ts`, then you can just do:

```ts
import { AwesomeMessage } from "./bundle.js";

// example code
let message = AwesomeMessage.create({ awesomeField: "hello" });
let buffer  = AwesomeMessage.encode(message).finish();
let decoded = AwesomeMessage.decode(buffer);
```

#### Using decorators

The library also includes an early implementation of [decorators](https://www.typescriptlang.org/docs/handbook/decorators.html).

**Note** that decorators are an experimental feature in TypeScript and that declaration order is important depending on the JS target. For example, `@Field.d(2, AwesomeArrayMessage)` requires that `AwesomeArrayMessage` has been defined earlier when targeting `ES5`.

```ts
import { Message, Type, Field, OneOf } from "protobufjs/light"; // respectively "./node_modules/protobufjs/light.js"

export class AwesomeSubMessage extends Message<AwesomeSubMessage> {

  @Field.d(1, "string")
  public awesomeString: string;

}

export enum AwesomeEnum {
  ONE = 1,
  TWO = 2
}

@Type.d("SuperAwesomeMessage")
export class AwesomeMessage extends Message<AwesomeMessage> {

  @Field.d(1, "string", "optional", "awesome default string")
  public awesomeField: string;

  @Field.d(2, AwesomeSubMessage)
  public awesomeSubMessage: AwesomeSubMessage;

  @Field.d(3, AwesomeEnum, "optional", AwesomeEnum.ONE)
  public awesomeEnum: AwesomeEnum;

  @OneOf.d("awesomeSubMessage", "awesomeEnum")
  public which: string;

}

// example code
let message = new AwesomeMessage({ awesomeField: "hello" });
let buffer  = AwesomeMessage.encode(message).finish();
let decoded = AwesomeMessage.decode(buffer);
```

Supported decorators are:

* **Type.d(typeName?: `string`)** &nbsp; *(optional)*<br />
  annotates a class as a protobuf message type. If `typeName` is not specified, the constructor's runtime function name is used for the reflected type.

* **Field.d&lt;T>(fieldId: `number`, fieldType: `string | Constructor<T>`, fieldRule?: `"optional" | "required" | "repeated"`, defaultValue?: `T`)**<br />
  annotates a property as a protobuf field with the specified id and protobuf type.

* **MapField.d&lt;T extends { [key: string]: any }>(fieldId: `number`, fieldKeyType: `string`, fieldValueType. `string | Constructor<{}>`)**<br />
  annotates a property as a protobuf map field with the specified id, protobuf key and value type.

* **OneOf.d&lt;T extends string>(...fieldNames: `string[]`)**<br />
  annotates a property as a protobuf oneof covering the specified fields.

Other notes:

* Decorated types reside in `protobuf.roots["decorated"]` using a flat structure, so no duplicate names.
* Enums are copied to a reflected enum with a generic name on decorator evaluation because referenced enum objects have no runtime name the decorator could use.
* Default values must be specified as arguments to the decorator instead of using a property initializer for proper prototype behavior.
* Property names on decorated classes must not be renamed on compile time (i.e. by a minifier) because decorators just receive the original field name as a string.

**ProTip!** Not as pretty, but you can [use decorators in plain JavaScript](https://github.com/dcodeIO/protobuf.js/blob/master/examples/js-decorators.js) as well.

Command line
------------

**Note** that moving the CLI to [its own package](./cli) is a work in progress. At the moment, it's still part of the main package.

The command line interface (CLI) can be used to translate between file formats and to generate static code as well as TypeScript definitions.

### pbjs for JavaScript

```
Translates between file formats and generates static code.

  -t, --target     Specifies the target format. Also accepts a path to require a custom target.

                   json          JSON representation
                   json-module   JSON representation as a module
                   proto2        Protocol Buffers, Version 2
                   proto3        Protocol Buffers, Version 3
                   static        Static code without reflection (non-functional on its own)
                   static-module Static code without reflection as a module

  -p, --path       Adds a directory to the include path.

  -o, --out        Saves to a file instead of writing to stdout.

  --sparse         Exports only those types referenced from a main file (experimental).

  Module targets only:

  -w, --wrap       Specifies the wrapper to use. Also accepts a path to require a custom wrapper.

                   default   Default wrapper supporting both CommonJS and AMD
                   commonjs  CommonJS wrapper
                   amd       AMD wrapper
                   es6       ES6 wrapper (implies --es6)
                   closure   A closure adding to protobuf.roots where protobuf is a global

  -r, --root       Specifies an alternative protobuf.roots name.

  -l, --lint       Linter configuration. Defaults to protobuf.js-compatible rules:

                   eslint-disable block-scoped-var, no-redeclare, no-control-regex, no-prototype-builtins

  --es6            Enables ES6 syntax (const/let instead of var)

  Proto sources only:

  --keep-case      Keeps field casing instead of converting to camel case.

  Static targets only:

  --no-create      Does not generate create functions used for reflection compatibility.
  --no-encode      Does not generate encode functions.
  --no-decode      Does not generate decode functions.
  --no-verify      Does not generate verify functions.
  --no-convert     Does not generate convert functions like from/toObject
  --no-delimited   Does not generate delimited encode/decode functions.
  --no-beautify    Does not beautify generated code.
  --no-comments    Does not output any JSDoc comments.

  --force-long     Enforces the use of 'Long' for s-/u-/int64 and s-/fixed64 fields.
  --force-number   Enforces the use of 'number' for s-/u-/int64 and s-/fixed64 fields.
  --force-message  Enforces the use of message instances instead of plain objects.

usage: pbjs [options] file1.proto file2.json ...  (or pipe)  other | pbjs [options] -
```

For production environments it is recommended to bundle all your .proto files to a single .json file, which minimizes the number of network requests and avoids any parser overhead (hint: works with just the **light** library):

```
$> pbjs -t json file1.proto file2.proto > bundle.json
```

Now, either include this file in your final bundle:

```js
var root = protobuf.Root.fromJSON(require("./bundle.json"));
```

or load it the usual way:

```js
protobuf.load("bundle.json", function(err, root) {
    ...
});
```

Generated static code, on the other hand, works with just the **minimal** library. For example

```
$> pbjs -t static-module -w commonjs -o compiled.js file1.proto file2.proto
```

will generate static code for definitions within `file1.proto` and `file2.proto` to a CommonJS module `compiled.js`.

**ProTip!** Documenting your .proto files with `/** ... */`-blocks or (trailing) `/// ...` lines translates to generated static code.


### pbts for TypeScript

```
Generates TypeScript definitions from annotated JavaScript files.

  -o, --out       Saves to a file instead of writing to stdout.

  -g, --global    Name of the global object in browser environments, if any.

  --no-comments   Does not output any JSDoc comments.

  Internal flags:

  -n, --name      Wraps everything in a module of the specified name.

  -m, --main      Whether building the main library without any imports.

usage: pbts [options] file1.js file2.js ...  (or)  other | pbts [options] -
```

Picking up on the example above, the following not only generates static code to a CommonJS module `compiled.js` but also its respective TypeScript definitions to `compiled.d.ts`:

```
$> pbjs -t static-module -w commonjs -o compiled.js file1.proto file2.proto
$> pbts -o compiled.d.ts compiled.js
```

Additionally, TypeScript definitions of static modules are compatible with their reflection-based counterparts (i.e. as exported by JSON modules), as long as the following conditions are met:

1. Instead of using `new SomeMessage(...)`, always use `SomeMessage.create(...)` because reflection objects do not provide a constructor.
2. Types, services and enums must start with an uppercase letter to become available as properties of the reflected types as well (i.e. to be able to use `MyMessage.MyEnum` instead of `root.lookup("MyMessage.MyEnum")`).

For example, the following generates a JSON module `bundle.js` and a `bundle.d.ts`, but no static code:

```
$> pbjs -t json-module -w commonjs -o bundle.js file1.proto file2.proto
$> pbjs -t static-module file1.proto file2.proto | pbts -o bundle.d.ts -
```

### Reflection vs. static code

While using .proto files directly requires the full library respectively pure reflection/JSON the light library, pretty much all code but the relatively short descriptors is shared.

Static code, on the other hand, requires just the minimal library, but generates additional source code without any reflection features. This also implies that there is a break-even point where statically generated code becomes larger than descriptor-based code once the amount of code generated exceeds the size of the full respectively light library.

There is no significant difference performance-wise as the code generated statically is pretty much the same as generated at runtime and both are largely interchangeable as seen in the previous section.

| Source | Library | Advantages | Tradeoffs
|--------|---------|------------|-----------
| .proto | full    | Easily editable<br />Interoperability with other libraries<br />No compile step | Some parsing and possibly network overhead
| JSON   | light   | Easily editable<br />No parsing overhead<br />Single bundle (no network overhead) | protobuf.js specific<br />Has a compile step
| static | minimal | Works where `eval` access is restricted<br />Fully documented<br />Small footprint for small protos | Can be hard to edit<br />No reflection<br />Has a compile step

### Command line API

Both utilities can be used programmatically by providing command line arguments and a callback to their respective `main` functions:

```js
var pbjs = require("protobufjs/cli/pbjs"); // or require("protobufjs/cli").pbjs / .pbts

pbjs.main([ "--target", "json-module", "path/to/myproto.proto" ], function(err, output) {
    if (err)
        throw err;
    // do something with output
});
```

Additional documentation
------------------------

#### Protocol Buffers
* [Google's Developer Guide](https://developers.google.com/protocol-buffers/docs/overview)

#### protobuf.js
* [API Documentation](https://protobufjs.github.io/protobuf.js)
* [CHANGELOG](https://github.com/dcodeIO/protobuf.js/blob/master/CHANGELOG.md)
* [Frequently asked questions](https://github.com/dcodeIO/protobuf.js/wiki) on our wiki

#### Community
* [Questions and answers](http://stackoverflow.com/search?tab=newest&q=protobuf.js) on StackOverflow

Performance
-----------
The package includes a benchmark that compares protobuf.js performance to native JSON (as far as this is possible) and [Google's JS implementation](https://github.com/google/protobuf/tree/master/js). On an i7-2600K running node 6.9.1 it yields:

```
benchmarking encoding performance ...

protobuf.js (reflect) x 541,707 ops/sec ±1.13% (87 runs sampled)
protobuf.js (static) x 548,134 ops/sec ±1.38% (89 runs sampled)
JSON (string) x 318,076 ops/sec ±0.63% (93 runs sampled)
JSON (buffer) x 179,165 ops/sec ±2.26% (91 runs sampled)
google-protobuf x 74,406 ops/sec ±0.85% (86 runs sampled)

   protobuf.js (static) was fastest
  protobuf.js (reflect) was 0.9% ops/sec slower (factor 1.0)
          JSON (string) was 41.5% ops/sec slower (factor 1.7)
          JSON (buffer) was 67.6% ops/sec slower (factor 3.1)
        google-protobuf was 86.4% ops/sec slower (factor 7.3)

benchmarking decoding performance ...

protobuf.js (reflect) x 1,383,981 ops/sec ±0.88% (93 runs sampled)
protobuf.js (static) x 1,378,925 ops/sec ±0.81% (93 runs sampled)
JSON (string) x 302,444 ops/sec ±0.81% (93 runs sampled)
JSON (buffer) x 264,882 ops/sec ±0.81% (93 runs sampled)
google-protobuf x 179,180 ops/sec ±0.64% (94 runs sampled)

  protobuf.js (reflect) was fastest
   protobuf.js (static) was 0.3% ops/sec slower (factor 1.0)
          JSON (string) was 78.1% ops/sec slower (factor 4.6)
          JSON (buffer) was 80.8% ops/sec slower (factor 5.2)
        google-protobuf was 87.0% ops/sec slower (factor 7.7)

benchmarking combined performance ...

protobuf.js (reflect) x 275,900 ops/sec ±0.78% (90 runs sampled)
protobuf.js (static) x 290,096 ops/sec ±0.96% (90 runs sampled)
JSON (string) x 129,381 ops/sec ±0.77% (90 runs sampled)
JSON (buffer) x 91,051 ops/sec ±0.94% (90 runs sampled)
google-protobuf x 42,050 ops/sec ±0.85% (91 runs sampled)

   protobuf.js (static) was fastest
  protobuf.js (reflect) was 4.7% ops/sec slower (factor 1.0)
          JSON (string) was 55.3% ops/sec slower (factor 2.2)
          JSON (buffer) was 68.6% ops/sec slower (factor 3.2)
        google-protobuf was 85.5% ops/sec slower (factor 6.9)
```

These results are achieved by

* generating type-specific encoders, decoders, verifiers and converters at runtime
* configuring the reader/writer interface according to the environment
* using node-specific functionality where beneficial and, of course
* avoiding unnecessary operations through splitting up [the toolset](#toolset).

You can also run [the benchmark](https://github.com/dcodeIO/protobuf.js/blob/master/bench/index.js) ...

```
$> npm run bench
```

and [the profiler](https://github.com/dcodeIO/protobuf.js/blob/master/bench/prof.js) yourself (the latter requires a recent version of node):

```
$> npm run prof <encode|decode|encode-browser|decode-browser> [iterations=10000000]
```

Note that as of this writing, the benchmark suite performs significantly slower on node 7.2.0 compared to 6.9.1 because moths.

Compatibility
-------------

* Works in all modern and not-so-modern browsers except IE8.
* Because the internals of this package do not rely on `google/protobuf/descriptor.proto`, options are parsed and presented literally.
* If typed arrays are not supported by the environment, plain arrays will be used instead.
* Support for pre-ES5 environments (except IE8) can be achieved by [using a polyfill](https://github.com/dcodeIO/protobuf.js/blob/master/scripts/polyfill.js).
* Support for [Content Security Policy](https://w3c.github.io/webappsec-csp/)-restricted environments (like Chrome extensions without [unsafe-eval](https://developer.chrome.com/extensions/contentSecurityPolicy#relaxing-eval)) can be achieved by generating and using static code instead.
* If a proper way to work with 64 bit values (uint64, int64 etc.) is required, just install [long.js](https://github.com/dcodeIO/long.js) alongside this library. All 64 bit numbers will then be returned as a `Long` instance instead of a possibly unsafe JavaScript number ([see](https://github.com/dcodeIO/long.js)).
* For descriptor.proto interoperability, see [ext/descriptor](https://github.com/dcodeIO/protobuf.js/tree/master/ext/descriptor)

Building
--------

To build the library or its components yourself, clone it from GitHub and install the development dependencies:

```
$> git clone https://github.com/dcodeIO/protobuf.js.git
$> cd protobuf.js
$> npm install
```

Building the respective development and production versions with their respective source maps to `dist/`:

```
$> npm run build
```

Building the documentation to `docs/`:

```
$> npm run docs
```

Building the TypeScript definition to `index.d.ts`:

```
$> npm run types
```

### Browserify integration

By default, protobuf.js integrates into any browserify build-process without requiring any optional modules. Hence:

* If int64 support is required, explicitly require the `long` module somewhere in your project as it will be excluded otherwise. This assumes that a global `require` function is present that protobuf.js can call to obtain the long module.

  If there is no global `require` function present after bundling, it's also possible to assign the long module programmatically:

  ```js
  var Long = ...;

  protobuf.util.Long = Long;
  protobuf.configure();
  ```

* If you have any special requirements, there is [the bundler](https://github.com/dcodeIO/protobuf.js/blob/master/scripts/bundle.js) for reference.

**License:** [BSD 3-Clause License](https://opensource.org/licenses/BSD-3-Clause)

#
# SessionUserPrefValues.R
#
# Copyright (C) 2024 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

#
# This file was automatically generated -- please do not modify it by hand.
#

.rs.setVar("uiPrefs", new.env(parent = emptyenv()))

# Run .Rprofile on resume
#
# Whether to run .Rprofile again after resuming a suspended R session.
.rs.uiPrefs$runRprofileOnResume <- list(
   get = function() { .rs.getUserPref("run_rprofile_on_resume") },
   set = function(value) { .rs.setUserPref("run_rprofile_on_resume", value) },
   clear = function() { .rs.clearUserPref("run_rprofile_on_resume") }
)

# Save workspace on quit
#
# Whether to save the workspace to an .Rdata file after the R session ends.
.rs.uiPrefs$saveWorkspace <- list(
   get = function() { .rs.getUserPref("save_workspace") },
   set = function(value) { .rs.setUserPref("save_workspace", value) },
   clear = function() { .rs.clearUserPref("save_workspace") }
)

# Load workspace on start
#
# Whether to load the workspace when the R session begins.
.rs.uiPrefs$loadWorkspace <- list(
   get = function() { .rs.getUserPref("load_workspace") },
   set = function(value) { .rs.setUserPref("load_workspace", value) },
   clear = function() { .rs.clearUserPref("load_workspace") }
)

# Initial working directory
#
# The initial working directory for new R sessions.
.rs.uiPrefs$initialWorkingDirectory <- list(
   get = function() { .rs.getUserPref("initial_working_directory") },
   set = function(value) { .rs.setUserPref("initial_working_directory", value) },
   clear = function() { .rs.clearUserPref("initial_working_directory") }
)

# 
#
# The CRAN mirror to use.
.rs.uiPrefs$cranMirror <- list(
   get = function() { .rs.getUserPref("cran_mirror") },
   set = function(value) { .rs.setUserPref("cran_mirror", value) },
   clear = function() { .rs.clearUserPref("cran_mirror") }
)

# 
#
# The name of the default Bioconductor mirror.
.rs.uiPrefs$bioconductorMirrorName <- list(
   get = function() { .rs.getUserPref("bioconductor_mirror_name") },
   set = function(value) { .rs.setUserPref("bioconductor_mirror_name", value) },
   clear = function() { .rs.clearUserPref("bioconductor_mirror_name") }
)

# 
#
# The URL of the default Bioconductor mirror.
.rs.uiPrefs$bioconductorMirrorUrl <- list(
   get = function() { .rs.getUserPref("bioconductor_mirror_url") },
   set = function(value) { .rs.setUserPref("bioconductor_mirror_url", value) },
   clear = function() { .rs.clearUserPref("bioconductor_mirror_url") }
)

# Save R console history
#
# Whether to always save the R console history.
.rs.uiPrefs$alwaysSaveHistory <- list(
   get = function() { .rs.getUserPref("always_save_history") },
   set = function(value) { .rs.setUserPref("always_save_history", value) },
   clear = function() { .rs.clearUserPref("always_save_history") }
)

# Remove duplicates from console history
#
# Whether to remove duplicate entries from the R console history.
.rs.uiPrefs$removeHistoryDuplicates <- list(
   get = function() { .rs.getUserPref("remove_history_duplicates") },
   set = function(value) { .rs.setUserPref("remove_history_duplicates", value) },
   clear = function() { .rs.clearUserPref("remove_history_duplicates") }
)

# Show .Last.value in Environment pane
#
# Show the result of the last expression (.Last.value) in the Environment pane.
.rs.uiPrefs$showLastDotValue <- list(
   get = function() { .rs.getUserPref("show_last_dot_value") },
   set = function(value) { .rs.setUserPref("show_last_dot_value", value) },
   clear = function() { .rs.clearUserPref("show_last_dot_value") }
)

# Line ending format
#
# The line ending format to use when saving files.
.rs.uiPrefs$lineEndingConversion <- list(
   get = function() { .rs.getUserPref("line_ending_conversion") },
   set = function(value) { .rs.setUserPref("line_ending_conversion", value) },
   clear = function() { .rs.clearUserPref("line_ending_conversion") }
)

# Use newlines in Makefiles
#
# Whether to use newlines when saving Makefiles.
.rs.uiPrefs$useNewlinesInMakefiles <- list(
   get = function() { .rs.getUserPref("use_newlines_in_makefiles") },
   set = function(value) { .rs.setUserPref("use_newlines_in_makefiles", value) },
   clear = function() { .rs.clearUserPref("use_newlines_in_makefiles") }
)

# 
#
# The terminal shell to use on Windows.
.rs.uiPrefs$windowsTerminalShell <- list(
   get = function() { .rs.getUserPref("windows_terminal_shell") },
   set = function(value) { .rs.setUserPref("windows_terminal_shell", value) },
   clear = function() { .rs.clearUserPref("windows_terminal_shell") }
)

# 
#
# The terminal shell to use on POSIX operating systems (MacOS and Linux).
.rs.uiPrefs$posixTerminalShell <- list(
   get = function() { .rs.getUserPref("posix_terminal_shell") },
   set = function(value) { .rs.setUserPref("posix_terminal_shell", value) },
   clear = function() { .rs.clearUserPref("posix_terminal_shell") }
)

# 
#
# The fully qualified path to the custom shell command to use in the Terminal
# tab.
.rs.uiPrefs$customShellCommand <- list(
   get = function() { .rs.getUserPref("custom_shell_command") },
   set = function(value) { .rs.setUserPref("custom_shell_command", value) },
   clear = function() { .rs.clearUserPref("custom_shell_command") }
)

# 
#
# The command-line options to pass to the custom shell command.
.rs.uiPrefs$customShellOptions <- list(
   get = function() { .rs.getUserPref("custom_shell_options") },
   set = function(value) { .rs.setUserPref("custom_shell_options", value) },
   clear = function() { .rs.clearUserPref("custom_shell_options") }
)

# Show line numbers in editor
#
# Show line numbers in RStudio's code editor.
.rs.uiPrefs$showLineNumbers <- list(
   get = function() { .rs.getUserPref("show_line_numbers") },
   set = function(value) { .rs.setUserPref("show_line_numbers", value) },
   clear = function() { .rs.clearUserPref("show_line_numbers") }
)

# Use relative line numbers in editor
#
# Show relative, rather than absolute, line numbers in RStudio's code editor.
.rs.uiPrefs$relativeLineNumbers <- list(
   get = function() { .rs.getUserPref("relative_line_numbers") },
   set = function(value) { .rs.setUserPref("relative_line_numbers", value) },
   clear = function() { .rs.clearUserPref("relative_line_numbers") }
)

# Highlight selected word in editor
#
# Highlight the selected word in RStudio's code editor.
.rs.uiPrefs$highlightSelectedWord <- list(
   get = function() { .rs.getUserPref("highlight_selected_word") },
   set = function(value) { .rs.setUserPref("highlight_selected_word", value) },
   clear = function() { .rs.clearUserPref("highlight_selected_word") }
)

# Highlight selected line in editor
#
# Highlight the selected line in RStudio's code editor.
.rs.uiPrefs$highlightSelectedLine <- list(
   get = function() { .rs.getUserPref("highlight_selected_line") },
   set = function(value) { .rs.setUserPref("highlight_selected_line", value) },
   clear = function() { .rs.clearUserPref("highlight_selected_line") }
)

# 
#
# Layout of panes in the RStudio workbench.
.rs.uiPrefs$panes <- list(
   get = function() { .rs.getUserPref("panes") },
   set = function(value) { .rs.setUserPref("panes", value) },
   clear = function() { .rs.clearUserPref("panes") }
)

# Allow source columns
#
# Whether to enable the ability to add source columns to display.
.rs.uiPrefs$allowSourceColumns <- list(
   get = function() { .rs.getUserPref("allow_source_columns") },
   set = function(value) { .rs.setUserPref("allow_source_columns", value) },
   clear = function() { .rs.clearUserPref("allow_source_columns") }
)

# Insert spaces for Tab
#
# Whether to insert spaces when pressing the Tab key.
.rs.uiPrefs$useSpacesForTab <- list(
   get = function() { .rs.getUserPref("use_spaces_for_tab") },
   set = function(value) { .rs.setUserPref("use_spaces_for_tab", value) },
   clear = function() { .rs.clearUserPref("use_spaces_for_tab") }
)

# Number of spaces for Tab
#
# The number of spaces to insert when pressing the Tab key.
.rs.uiPrefs$numSpacesForTab <- list(
   get = function() { .rs.getUserPref("num_spaces_for_tab") },
   set = function(value) { .rs.setUserPref("num_spaces_for_tab", value) },
   clear = function() { .rs.clearUserPref("num_spaces_for_tab") }
)

# Auto-detect indentation in files
#
# Whether to automatically detect indentation settings from file contents.
.rs.uiPrefs$autoDetectIndentation <- list(
   get = function() { .rs.getUserPref("auto_detect_indentation") },
   set = function(value) { .rs.setUserPref("auto_detect_indentation", value) },
   clear = function() { .rs.clearUserPref("auto_detect_indentation") }
)

# Show margin in editor
#
# Whether to show the margin guide in the RStudio code editor.
.rs.uiPrefs$showMargin <- list(
   get = function() { .rs.getUserPref("show_margin") },
   set = function(value) { .rs.setUserPref("show_margin", value) },
   clear = function() { .rs.clearUserPref("show_margin") }
)

# Use a blinking cursor
#
# Whether to flash the cursor off and on.
.rs.uiPrefs$blinkingCursor <- list(
   get = function() { .rs.getUserPref("blinking_cursor") },
   set = function(value) { .rs.setUserPref("blinking_cursor", value) },
   clear = function() { .rs.clearUserPref("blinking_cursor") }
)

# Margin column
#
# The number of columns of text after which the margin is shown.
.rs.uiPrefs$marginColumn <- list(
   get = function() { .rs.getUserPref("margin_column") },
   set = function(value) { .rs.setUserPref("margin_column", value) },
   clear = function() { .rs.clearUserPref("margin_column") }
)

# Show invisible characters in editor
#
# Whether to show invisible characters, such as spaces and tabs, in the RStudio
# code editor.
.rs.uiPrefs$showInvisibles <- list(
   get = function() { .rs.getUserPref("show_invisibles") },
   set = function(value) { .rs.setUserPref("show_invisibles", value) },
   clear = function() { .rs.clearUserPref("show_invisibles") }
)

# Indentation guides
#
# Style for indentation guides in the RStudio code editor.
.rs.uiPrefs$indentGuides <- list(
   get = function() { .rs.getUserPref("indent_guides") },
   set = function(value) { .rs.setUserPref("indent_guides", value) },
   clear = function() { .rs.clearUserPref("indent_guides") }
)

# Continue comments after adding new line
#
# Whether to continue comments (by inserting the comment character) after adding
# a new line.
.rs.uiPrefs$continueCommentsOnNewline <- list(
   get = function() { .rs.getUserPref("continue_comments_on_newline") },
   set = function(value) { .rs.setUserPref("continue_comments_on_newline", value) },
   clear = function() { .rs.clearUserPref("continue_comments_on_newline") }
)

# Whether web links in comments are clickable
#
# Whether web links in comments are clickable.
.rs.uiPrefs$highlightWebLink <- list(
   get = function() { .rs.getUserPref("highlight_web_link") },
   set = function(value) { .rs.setUserPref("highlight_web_link", value) },
   clear = function() { .rs.clearUserPref("highlight_web_link") }
)

# Keybinding set for editor
#
# The keybindings to use in the RStudio code editor.
.rs.uiPrefs$editorKeybindings <- list(
   get = function() { .rs.getUserPref("editor_keybindings") },
   set = function(value) { .rs.setUserPref("editor_keybindings", value) },
   clear = function() { .rs.clearUserPref("editor_keybindings") }
)

# Auto-insert matching parentheses and brackets
#
# Whether to insert matching pairs, such as () and [], when the first is typed.
.rs.uiPrefs$insertMatching <- list(
   get = function() { .rs.getUserPref("insert_matching") },
   set = function(value) { .rs.setUserPref("insert_matching", value) },
   clear = function() { .rs.clearUserPref("insert_matching") }
)

# Insert spaces around = in R code
#
# Whether to insert spaces around the equals sign in R code.
.rs.uiPrefs$insertSpacesAroundEquals <- list(
   get = function() { .rs.getUserPref("insert_spaces_around_equals") },
   set = function(value) { .rs.setUserPref("insert_spaces_around_equals", value) },
   clear = function() { .rs.clearUserPref("insert_spaces_around_equals") }
)

# Insert parentheses after functions
#
# Whether to insert parentheses after function completions.
.rs.uiPrefs$insertParensAfterFunctionCompletion <- list(
   get = function() { .rs.getUserPref("insert_parens_after_function_completion") },
   set = function(value) { .rs.setUserPref("insert_parens_after_function_completion", value) },
   clear = function() { .rs.clearUserPref("insert_parens_after_function_completion") }
)

# Complete multi-line statements with Tab
#
# Whether to attempt completion of multiple-line statements when pressing Tab.
.rs.uiPrefs$tabMultilineCompletion <- list(
   get = function() { .rs.getUserPref("tab_multiline_completion") },
   set = function(value) { .rs.setUserPref("tab_multiline_completion", value) },
   clear = function() { .rs.clearUserPref("tab_multiline_completion") }
)

# Use Tab to trigger autocompletion
#
# Whether to attempt completion of statements when pressing Tab.
.rs.uiPrefs$tabCompletion <- list(
   get = function() { .rs.getUserPref("tab_completion") },
   set = function(value) { .rs.setUserPref("tab_completion", value) },
   clear = function() { .rs.clearUserPref("tab_completion") }
)

# Show function help tooltips on idle
#
# Whether to show help tooltips for functions when the cursor has not been
# recently moved.
.rs.uiPrefs$showHelpTooltipOnIdle <- list(
   get = function() { .rs.getUserPref("show_help_tooltip_on_idle") },
   set = function(value) { .rs.setUserPref("show_help_tooltip_on_idle", value) },
   clear = function() { .rs.clearUserPref("show_help_tooltip_on_idle") }
)

# Surround selections with
#
# Which kinds of delimiters can be used to surround the current selection.
.rs.uiPrefs$surroundSelection <- list(
   get = function() { .rs.getUserPref("surround_selection") },
   set = function(value) { .rs.setUserPref("surround_selection", value) },
   clear = function() { .rs.clearUserPref("surround_selection") }
)

# Enable code snippets
#
# Whether to enable code snippets in the RStudio code editor.
.rs.uiPrefs$enableSnippets <- list(
   get = function() { .rs.getUserPref("enable_snippets") },
   set = function(value) { .rs.setUserPref("enable_snippets", value) },
   clear = function() { .rs.clearUserPref("enable_snippets") }
)

# Use code completion for R
#
# When to use auto-completion for R code in the RStudio code editor.
.rs.uiPrefs$codeCompletion <- list(
   get = function() { .rs.getUserPref("code_completion") },
   set = function(value) { .rs.setUserPref("code_completion", value) },
   clear = function() { .rs.clearUserPref("code_completion") }
)

# Use code completion for other languages
#
# When to use auto-completion for other languages (such as JavaScript and SQL) in
# the RStudio code editor.
.rs.uiPrefs$codeCompletionOther <- list(
   get = function() { .rs.getUserPref("code_completion_other") },
   set = function(value) { .rs.setUserPref("code_completion_other", value) },
   clear = function() { .rs.clearUserPref("code_completion_other") }
)

# Use code completion in the R console
#
# Whether to always use code completion in the R console.
.rs.uiPrefs$consoleCodeCompletion <- list(
   get = function() { .rs.getUserPref("console_code_completion") },
   set = function(value) { .rs.setUserPref("console_code_completion", value) },
   clear = function() { .rs.clearUserPref("console_code_completion") }
)

# Delay before completing code (ms)
#
# The number of milliseconds to wait before offering code suggestions.
.rs.uiPrefs$codeCompletionDelay <- list(
   get = function() { .rs.getUserPref("code_completion_delay") },
   set = function(value) { .rs.setUserPref("code_completion_delay", value) },
   clear = function() { .rs.clearUserPref("code_completion_delay") }
)

# Number of characters for code completion
#
# The number of characters in a symbol that can be entered before completions are
# offered.
.rs.uiPrefs$codeCompletionCharacters <- list(
   get = function() { .rs.getUserPref("code_completion_characters") },
   set = function(value) { .rs.setUserPref("code_completion_characters", value) },
   clear = function() { .rs.clearUserPref("code_completion_characters") }
)

# Include all function arguments in completion list
#
# When set, RStudio will include all function arguments in the completion list,
# even if those arguments have already appeared to be used in the current
# function invocation.
.rs.uiPrefs$codeCompletionIncludeAlreadyUsed <- list(
   get = function() { .rs.getUserPref("code_completion_include_already_used") },
   set = function(value) { .rs.setUserPref("code_completion_include_already_used", value) },
   clear = function() { .rs.clearUserPref("code_completion_include_already_used") }
)

# Show function signature tooltips
#
# Whether to show function signature tooltips during autocompletion.
.rs.uiPrefs$showFunctionSignatureTooltips <- list(
   get = function() { .rs.getUserPref("show_function_signature_tooltips") },
   set = function(value) { .rs.setUserPref("show_function_signature_tooltips", value) },
   clear = function() { .rs.clearUserPref("show_function_signature_tooltips") }
)

# Show data preview in autocompletion help popup
#
# Whether a data preview is shown in the autocompletion help popup for datasets
# and values.
.rs.uiPrefs$showDataPreview <- list(
   get = function() { .rs.getUserPref("show_data_preview") },
   set = function(value) { .rs.setUserPref("show_data_preview", value) },
   clear = function() { .rs.clearUserPref("show_data_preview") }
)

# Show diagnostics in R code
#
# Whether to show diagnostic messages (such as syntax and usage errors) for R
# code as you type.
.rs.uiPrefs$showDiagnosticsR <- list(
   get = function() { .rs.getUserPref("show_diagnostics_r") },
   set = function(value) { .rs.setUserPref("show_diagnostics_r", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_r") }
)

# Show diagnostics in C++ code
#
# Whether to show diagnostic messages for C++ code as you type.
.rs.uiPrefs$showDiagnosticsCpp <- list(
   get = function() { .rs.getUserPref("show_diagnostics_cpp") },
   set = function(value) { .rs.setUserPref("show_diagnostics_cpp", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_cpp") }
)

# Show diagnostics in YAML code
#
# Whether to show diagnostic messages for YAML code as you type.
.rs.uiPrefs$showDiagnosticsYaml <- list(
   get = function() { .rs.getUserPref("show_diagnostics_yaml") },
   set = function(value) { .rs.setUserPref("show_diagnostics_yaml", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_yaml") }
)

# Show diagnostics in other languages
#
# Whether to show diagnostic messages for other types of code (not R, C++, or
# YAML).
.rs.uiPrefs$showDiagnosticsOther <- list(
   get = function() { .rs.getUserPref("show_diagnostics_other") },
   set = function(value) { .rs.setUserPref("show_diagnostics_other", value) },
   clear = function() { .rs.clearUserPref("show_diagnostics_other") }
)

# Show style diagnostics for R code
#
# Whether to show style diagnostics (suggestions for improving R code style)
.rs.uiPrefs$styleDiagnostics <- list(
   get = function() { .rs.getUserPref("style_diagnostics") },
   set = function(value) { .rs.setUserPref("style_diagnostics", value) },
   clear = function() { .rs.clearUserPref("style_diagnostics") }
)

# Check code for problems when saving
#
# Whether to check code for problems after saving it.
.rs.uiPrefs$diagnosticsOnSave <- list(
   get = function() { .rs.getUserPref("diagnostics_on_save") },
   set = function(value) { .rs.setUserPref("diagnostics_on_save", value) },
   clear = function() { .rs.clearUserPref("diagnostics_on_save") }
)

# Run R code diagnostics in the background
#
# Whether to run code diagnostics in the background, as you type.
.rs.uiPrefs$backgroundDiagnostics <- list(
   get = function() { .rs.getUserPref("background_diagnostics") },
   set = function(value) { .rs.setUserPref("background_diagnostics", value) },
   clear = function() { .rs.clearUserPref("background_diagnostics") }
)

# Run R code diagnostics after (ms)
#
# The number of milliseconds to delay before running code diagnostics in the
# background.
.rs.uiPrefs$backgroundDiagnosticsDelayMs <- list(
   get = function() { .rs.getUserPref("background_diagnostics_delay_ms") },
   set = function(value) { .rs.setUserPref("background_diagnostics_delay_ms", value) },
   clear = function() { .rs.clearUserPref("background_diagnostics_delay_ms") }
)

# Run diagnostics on R function calls
#
# Whether to run diagnostics in R function calls.
.rs.uiPrefs$diagnosticsInRFunctionCalls <- list(
   get = function() { .rs.getUserPref("diagnostics_in_r_function_calls") },
   set = function(value) { .rs.setUserPref("diagnostics_in_r_function_calls", value) },
   clear = function() { .rs.clearUserPref("diagnostics_in_r_function_calls") }
)

# Check arguments to R function calls
#
# Whether to check arguments to R function calls.
.rs.uiPrefs$checkArgumentsToRFunctionCalls <- list(
   get = function() { .rs.getUserPref("check_arguments_to_r_function_calls") },
   set = function(value) { .rs.setUserPref("check_arguments_to_r_function_calls", value) },
   clear = function() { .rs.clearUserPref("check_arguments_to_r_function_calls") }
)

# Check for unexpected assignments
#
# Whether to check for unexpected variable assignments inside R function calls.
.rs.uiPrefs$checkUnexpectedAssignmentInFunctionCall <- list(
   get = function() { .rs.getUserPref("check_unexpected_assignment_in_function_call") },
   set = function(value) { .rs.setUserPref("check_unexpected_assignment_in_function_call", value) },
   clear = function() { .rs.clearUserPref("check_unexpected_assignment_in_function_call") }
)

# Warn when R variable used but not defined
#
# Whether to generate a warning if a variable is used without being defined in
# the current scope.
.rs.uiPrefs$warnIfNoSuchVariableInScope <- list(
   get = function() { .rs.getUserPref("warn_if_no_such_variable_in_scope") },
   set = function(value) { .rs.setUserPref("warn_if_no_such_variable_in_scope", value) },
   clear = function() { .rs.clearUserPref("warn_if_no_such_variable_in_scope") }
)

# Warn when R variable defined but not used
#
# Whether to generate a warning if a variable is defined without being used in
# the current scope
.rs.uiPrefs$warnVariableDefinedButNotUsed <- list(
   get = function() { .rs.getUserPref("warn_variable_defined_but_not_used") },
   set = function(value) { .rs.setUserPref("warn_variable_defined_but_not_used", value) },
   clear = function() { .rs.clearUserPref("warn_variable_defined_but_not_used") }
)

# Detect missing R packages in the editor
#
# Whether to automatically discover and offer to install missing R package
# dependencies.
.rs.uiPrefs$autoDiscoverPackageDependencies <- list(
   get = function() { .rs.getUserPref("auto_discover_package_dependencies") },
   set = function(value) { .rs.setUserPref("auto_discover_package_dependencies", value) },
   clear = function() { .rs.clearUserPref("auto_discover_package_dependencies") }
)

# Ensure files end with a newline when saving
#
# Whether to ensure that source files end with a newline character.
.rs.uiPrefs$autoAppendNewline <- list(
   get = function() { .rs.getUserPref("auto_append_newline") },
   set = function(value) { .rs.setUserPref("auto_append_newline", value) },
   clear = function() { .rs.clearUserPref("auto_append_newline") }
)

# Strip trailing whitespace when saving
#
# Whether to strip trailing whitespace from each line when saving.
.rs.uiPrefs$stripTrailingWhitespace <- list(
   get = function() { .rs.getUserPref("strip_trailing_whitespace") },
   set = function(value) { .rs.setUserPref("strip_trailing_whitespace", value) },
   clear = function() { .rs.clearUserPref("strip_trailing_whitespace") }
)

# Restore cursor position when reopening files
#
# Whether to save the position of the cursor when a file is closed, restore it
# when the file is opened.
.rs.uiPrefs$restoreSourceDocumentCursorPosition <- list(
   get = function() { .rs.getUserPref("restore_source_document_cursor_position") },
   set = function(value) { .rs.setUserPref("restore_source_document_cursor_position", value) },
   clear = function() { .rs.clearUserPref("restore_source_document_cursor_position") }
)

# Re-indent code when pasting
#
# Whether to automatically re-indent code when it's pasted into RStudio.
.rs.uiPrefs$reindentOnPaste <- list(
   get = function() { .rs.getUserPref("reindent_on_paste") },
   set = function(value) { .rs.setUserPref("reindent_on_paste", value) },
   clear = function() { .rs.clearUserPref("reindent_on_paste") }
)

# Vertically align function arguments
#
# Whether to vertically align arguments to R function calls during automatic
# indentation.
.rs.uiPrefs$verticallyAlignArgumentsIndent <- list(
   get = function() { .rs.getUserPref("vertically_align_arguments_indent") },
   set = function(value) { .rs.setUserPref("vertically_align_arguments_indent", value) },
   clear = function() { .rs.clearUserPref("vertically_align_arguments_indent") }
)

# Soft-wrap source files
#
# Whether to soft-wrap source files, wrapping the text for display without
# inserting newline characters.
.rs.uiPrefs$softWrapRFiles <- list(
   get = function() { .rs.getUserPref("soft_wrap_r_files") },
   set = function(value) { .rs.setUserPref("soft_wrap_r_files", value) },
   clear = function() { .rs.clearUserPref("soft_wrap_r_files") }
)

# Soft-wrap R Markdown files
#
# Whether to soft-wrap R Markdown files (and similar types such as R HTML and R
# Notebooks)
.rs.uiPrefs$softWrapRmdFiles <- list(
   get = function() { .rs.getUserPref("soft_wrap_rmd_files") },
   set = function(value) { .rs.setUserPref("soft_wrap_rmd_files", value) },
   clear = function() { .rs.clearUserPref("soft_wrap_rmd_files") }
)

# Focus console after executing R code
#
# Whether to focus the R console after executing an R command from a script.
.rs.uiPrefs$focusConsoleAfterExec <- list(
   get = function() { .rs.getUserPref("focus_console_after_exec") },
   set = function(value) { .rs.setUserPref("focus_console_after_exec", value) },
   clear = function() { .rs.clearUserPref("focus_console_after_exec") }
)

# Fold style in editor
#
# The style of folding to use.
.rs.uiPrefs$foldStyle <- list(
   get = function() { .rs.getUserPref("fold_style") },
   set = function(value) { .rs.setUserPref("fold_style", value) },
   clear = function() { .rs.clearUserPref("fold_style") }
)

# Save R scripts before sourcing
#
# Whether to automatically save scripts before executing them.
.rs.uiPrefs$saveBeforeSourcing <- list(
   get = function() { .rs.getUserPref("save_before_sourcing") },
   set = function(value) { .rs.setUserPref("save_before_sourcing", value) },
   clear = function() { .rs.clearUserPref("save_before_sourcing") }
)

# Syntax highlighting in R console
#
# Whether to use syntax highlighting in the R console.
.rs.uiPrefs$syntaxColorConsole <- list(
   get = function() { .rs.getUserPref("syntax_color_console") },
   set = function(value) { .rs.setUserPref("syntax_color_console", value) },
   clear = function() { .rs.clearUserPref("syntax_color_console") }
)

# Different color for error output in R console
#
# Whether to display error, warning, and message output in a different color.
.rs.uiPrefs$highlightConsoleErrors <- list(
   get = function() { .rs.getUserPref("highlight_console_errors") },
   set = function(value) { .rs.setUserPref("highlight_console_errors", value) },
   clear = function() { .rs.clearUserPref("highlight_console_errors") }
)

# Scroll past end of file
#
# Whether to allow scrolling past the end of a file.
.rs.uiPrefs$scrollPastEndOfDocument <- list(
   get = function() { .rs.getUserPref("scroll_past_end_of_document") },
   set = function(value) { .rs.setUserPref("scroll_past_end_of_document", value) },
   clear = function() { .rs.clearUserPref("scroll_past_end_of_document") }
)

# Highlight R function calls
#
# Whether to highlight R function calls in the code editor.
.rs.uiPrefs$highlightRFunctionCalls <- list(
   get = function() { .rs.getUserPref("highlight_r_function_calls") },
   set = function(value) { .rs.setUserPref("highlight_r_function_calls", value) },
   clear = function() { .rs.clearUserPref("highlight_r_function_calls") }
)

# Enable preview of named and hexadecimal colors
#
# Whether to show preview for named and hexadecimal colors.
.rs.uiPrefs$colorPreview <- list(
   get = function() { .rs.getUserPref("color_preview") },
   set = function(value) { .rs.setUserPref("color_preview", value) },
   clear = function() { .rs.clearUserPref("color_preview") }
)

# Use rainbow parentheses
#
# Whether to highlight parentheses in a variety of colors.
.rs.uiPrefs$rainbowParentheses <- list(
   get = function() { .rs.getUserPref("rainbow_parentheses") },
   set = function(value) { .rs.setUserPref("rainbow_parentheses", value) },
   clear = function() { .rs.clearUserPref("rainbow_parentheses") }
)

# Use rainbow fenced divs
#
# Whether to highlight fenced divs in a variety of colors.
.rs.uiPrefs$rainbowFencedDivs <- list(
   get = function() { .rs.getUserPref("rainbow_fenced_divs") },
   set = function(value) { .rs.setUserPref("rainbow_fenced_divs", value) },
   clear = function() { .rs.clearUserPref("rainbow_fenced_divs") }
)

# Maximum characters per line in R console
#
# The maximum number of characters to display in a single line in the R console.
.rs.uiPrefs$consoleLineLengthLimit <- list(
   get = function() { .rs.getUserPref("console_line_length_limit") },
   set = function(value) { .rs.setUserPref("console_line_length_limit", value) },
   clear = function() { .rs.clearUserPref("console_line_length_limit") }
)

# Maximum lines in R console
#
# The maximum number of console actions to store and display in the console
# scrollback buffer.
.rs.uiPrefs$consoleMaxLines <- list(
   get = function() { .rs.getUserPref("console_max_lines") },
   set = function(value) { .rs.setUserPref("console_max_lines", value) },
   clear = function() { .rs.clearUserPref("console_max_lines") }
)

# ANSI escape codes in R console
#
# How to treat ANSI escape codes in the console.
.rs.uiPrefs$ansiConsoleMode <- list(
   get = function() { .rs.getUserPref("ansi_console_mode") },
   set = function(value) { .rs.setUserPref("ansi_console_mode", value) },
   clear = function() { .rs.clearUserPref("ansi_console_mode") }
)

# Limit visible console output
#
# Whether to only show a limited window of the total console output
.rs.uiPrefs$limitVisibleConsole <- list(
   get = function() { .rs.getUserPref("limit_visible_console") },
   set = function(value) { .rs.setUserPref("limit_visible_console", value) },
   clear = function() { .rs.clearUserPref("limit_visible_console") }
)

# Show toolbar on R Markdown chunks
#
# Whether to show a toolbar on code chunks in R Markdown documents.
.rs.uiPrefs$showInlineToolbarForRCodeChunks <- list(
   get = function() { .rs.getUserPref("show_inline_toolbar_for_r_code_chunks") },
   set = function(value) { .rs.setUserPref("show_inline_toolbar_for_r_code_chunks", value) },
   clear = function() { .rs.clearUserPref("show_inline_toolbar_for_r_code_chunks") }
)

# Highlight code chunks in R Markdown files
#
# Whether to highlight code chunks in R Markdown documents with a different
# background color.
.rs.uiPrefs$highlightCodeChunks <- list(
   get = function() { .rs.getUserPref("highlight_code_chunks") },
   set = function(value) { .rs.setUserPref("highlight_code_chunks", value) },
   clear = function() { .rs.clearUserPref("highlight_code_chunks") }
)

# Save files before building
#
# Whether to save all open, unsaved files before building the project.
.rs.uiPrefs$saveFilesBeforeBuild <- list(
   get = function() { .rs.getUserPref("save_files_before_build") },
   set = function(value) { .rs.setUserPref("save_files_before_build", value) },
   clear = function() { .rs.clearUserPref("save_files_before_build") }
)

# Save and reload R workspace on build
#
# Whether RStudio should save and reload the R workspace when building the
# project.
.rs.uiPrefs$saveAndReloadWorkspaceOnBuild <- list(
   get = function() { .rs.getUserPref("save_and_reload_workspace_on_build") },
   set = function(value) { .rs.setUserPref("save_and_reload_workspace_on_build", value) },
   clear = function() { .rs.clearUserPref("save_and_reload_workspace_on_build") }
)

# Editor font size (points)
#
# The default editor font size, in points.
.rs.uiPrefs$fontSizePoints <- list(
   get = function() { .rs.getUserPref("font_size_points") },
   set = function(value) { .rs.setUserPref("font_size_points", value) },
   clear = function() { .rs.clearUserPref("font_size_points") }
)

# Editor line height
#
# The editor line height, as a percentage of the font size.
.rs.uiPrefs$editorLineHeight <- list(
   get = function() { .rs.getUserPref("editor_line_height") },
   set = function(value) { .rs.setUserPref("editor_line_height", value) },
   clear = function() { .rs.clearUserPref("editor_line_height") }
)

# Help panel font size (points)
#
# The help panel font size, in points.
.rs.uiPrefs$helpFontSizePoints <- list(
   get = function() { .rs.getUserPref("help_font_size_points") },
   set = function(value) { .rs.setUserPref("help_font_size_points", value) },
   clear = function() { .rs.clearUserPref("help_font_size_points") }
)

# Theme
#
# The name of the color theme to apply to the text editor in RStudio.
.rs.uiPrefs$editorTheme <- list(
   get = function() { .rs.getUserPref("editor_theme") },
   set = function(value) { .rs.setUserPref("editor_theme", value) },
   clear = function() { .rs.clearUserPref("editor_theme") }
)

# Enable editor fonts on RStudio Server
#
# Whether to use a custom editor font in RStudio Server.
.rs.uiPrefs$serverEditorFontEnabled <- list(
   get = function() { .rs.getUserPref("server_editor_font_enabled") },
   set = function(value) { .rs.setUserPref("server_editor_font_enabled", value) },
   clear = function() { .rs.clearUserPref("server_editor_font_enabled") }
)

# Editor font
#
# The name of the fixed-width editor font to use with RStudio Server.
.rs.uiPrefs$serverEditorFont <- list(
   get = function() { .rs.getUserPref("server_editor_font") },
   set = function(value) { .rs.setUserPref("server_editor_font", value) },
   clear = function() { .rs.clearUserPref("server_editor_font") }
)

# Default character encoding
#
# The default character encoding to use when saving files.
.rs.uiPrefs$defaultEncoding <- list(
   get = function() { .rs.getUserPref("default_encoding") },
   set = function(value) { .rs.setUserPref("default_encoding", value) },
   clear = function() { .rs.clearUserPref("default_encoding") }
)

# Show top toolbar
#
# Whether to show the toolbar at the top of the RStudio workbench.
.rs.uiPrefs$toolbarVisible <- list(
   get = function() { .rs.getUserPref("toolbar_visible") },
   set = function(value) { .rs.setUserPref("toolbar_visible", value) },
   clear = function() { .rs.clearUserPref("toolbar_visible") }
)

# Default new project location
#
# The directory path under which to place new projects by default.
.rs.uiPrefs$defaultProjectLocation <- list(
   get = function() { .rs.getUserPref("default_project_location") },
   set = function(value) { .rs.setUserPref("default_project_location", value) },
   clear = function() { .rs.clearUserPref("default_project_location") }
)

# Default open project location
#
# The default directory to use in file dialogs when opening a project.
.rs.uiPrefs$defaultOpenProjectLocation <- list(
   get = function() { .rs.getUserPref("default_open_project_location") },
   set = function(value) { .rs.setUserPref("default_open_project_location", value) },
   clear = function() { .rs.clearUserPref("default_open_project_location") }
)

# Source with echo by default
#
# Whether to echo R code when sourcing it.
.rs.uiPrefs$sourceWithEcho <- list(
   get = function() { .rs.getUserPref("source_with_echo") },
   set = function(value) { .rs.setUserPref("source_with_echo", value) },
   clear = function() { .rs.clearUserPref("source_with_echo") }
)

# Default Sweave engine
#
# The default engine to use when processing Sweave documents.
.rs.uiPrefs$defaultSweaveEngine <- list(
   get = function() { .rs.getUserPref("default_sweave_engine") },
   set = function(value) { .rs.setUserPref("default_sweave_engine", value) },
   clear = function() { .rs.clearUserPref("default_sweave_engine") }
)

# Default LaTeX program
#
# The default program to use when processing LaTeX documents.
.rs.uiPrefs$defaultLatexProgram <- list(
   get = function() { .rs.getUserPref("default_latex_program") },
   set = function(value) { .rs.setUserPref("default_latex_program", value) },
   clear = function() { .rs.clearUserPref("default_latex_program") }
)

# Use Roxygen for documentation
#
# Whether to use Roxygen for documentation.
.rs.uiPrefs$useRoxygen <- list(
   get = function() { .rs.getUserPref("use_roxygen") },
   set = function(value) { .rs.setUserPref("use_roxygen", value) },
   clear = function() { .rs.clearUserPref("use_roxygen") }
)

# Enable data import
#
# Whether to use RStudio's data import feature.
.rs.uiPrefs$useDataimport <- list(
   get = function() { .rs.getUserPref("use_dataimport") },
   set = function(value) { .rs.setUserPref("use_dataimport", value) },
   clear = function() { .rs.clearUserPref("use_dataimport") }
)

# PDF previewer
#
# The program to use to preview PDF files after generation.
.rs.uiPrefs$pdfPreviewer <- list(
   get = function() { .rs.getUserPref("pdf_previewer") },
   set = function(value) { .rs.setUserPref("pdf_previewer", value) },
   clear = function() { .rs.clearUserPref("pdf_previewer") }
)

# Enable Rnw concordance
#
# Whether to always enable the concordance for RNW files.
.rs.uiPrefs$alwaysEnableRnwConcordance <- list(
   get = function() { .rs.getUserPref("always_enable_rnw_concordance") },
   set = function(value) { .rs.setUserPref("always_enable_rnw_concordance", value) },
   clear = function() { .rs.clearUserPref("always_enable_rnw_concordance") }
)

# Insert numbered LaTeX sections
#
# Whether to insert numbered sections in LaTeX.
.rs.uiPrefs$insertNumberedLatexSections <- list(
   get = function() { .rs.getUserPref("insert_numbered_latex_sections") },
   set = function(value) { .rs.setUserPref("insert_numbered_latex_sections", value) },
   clear = function() { .rs.clearUserPref("insert_numbered_latex_sections") }
)

# Spelling dictionary language
#
# The language of the spelling dictionary to use for spell checking.
.rs.uiPrefs$spellingDictionaryLanguage <- list(
   get = function() { .rs.getUserPref("spelling_dictionary_language") },
   set = function(value) { .rs.setUserPref("spelling_dictionary_language", value) },
   clear = function() { .rs.clearUserPref("spelling_dictionary_language") }
)

# Custom spelling dictionaries
#
# The list of custom dictionaries to use when spell checking.
.rs.uiPrefs$spellingCustomDictionaries <- list(
   get = function() { .rs.getUserPref("spelling_custom_dictionaries") },
   set = function(value) { .rs.setUserPref("spelling_custom_dictionaries", value) },
   clear = function() { .rs.clearUserPref("spelling_custom_dictionaries") }
)

# Lint document after load (ms)
#
# The number of milliseconds to wait before linting a document after it is
# loaded.
.rs.uiPrefs$documentLoadLintDelay <- list(
   get = function() { .rs.getUserPref("document_load_lint_delay") },
   set = function(value) { .rs.setUserPref("document_load_lint_delay", value) },
   clear = function() { .rs.clearUserPref("document_load_lint_delay") }
)

# Ignore uppercase words in spell check
#
# Whether to ignore words in uppercase when spell checking.
.rs.uiPrefs$ignoreUppercaseWords <- list(
   get = function() { .rs.getUserPref("ignore_uppercase_words") },
   set = function(value) { .rs.setUserPref("ignore_uppercase_words", value) },
   clear = function() { .rs.clearUserPref("ignore_uppercase_words") }
)

# Ignore words with numbers in spell check
#
# Whether to ignore words with numbers in them when spell checking.
.rs.uiPrefs$ignoreWordsWithNumbers <- list(
   get = function() { .rs.getUserPref("ignore_words_with_numbers") },
   set = function(value) { .rs.setUserPref("ignore_words_with_numbers", value) },
   clear = function() { .rs.clearUserPref("ignore_words_with_numbers") }
)

# Use real-time spellchecking
#
# Whether to enable real-time spellchecking by default.
.rs.uiPrefs$realTimeSpellchecking <- list(
   get = function() { .rs.getUserPref("real_time_spellchecking") },
   set = function(value) { .rs.setUserPref("real_time_spellchecking", value) },
   clear = function() { .rs.clearUserPref("real_time_spellchecking") }
)

# Navigate to build errors
#
# Whether to navigate to build errors.
.rs.uiPrefs$navigateToBuildError <- list(
   get = function() { .rs.getUserPref("navigate_to_build_error") },
   set = function(value) { .rs.setUserPref("navigate_to_build_error", value) },
   clear = function() { .rs.clearUserPref("navigate_to_build_error") }
)

# Enable the Packages pane
#
# Whether to enable RStudio's Packages pane.
.rs.uiPrefs$packagesPaneEnabled <- list(
   get = function() { .rs.getUserPref("packages_pane_enabled") },
   set = function(value) { .rs.setUserPref("packages_pane_enabled", value) },
   clear = function() { .rs.clearUserPref("packages_pane_enabled") }
)

# C++ template
#
# C++ template.
.rs.uiPrefs$cppTemplate <- list(
   get = function() { .rs.getUserPref("cpp_template") },
   set = function(value) { .rs.setUserPref("cpp_template", value) },
   clear = function() { .rs.clearUserPref("cpp_template") }
)

# Restore last opened documents on startup
#
# Whether to restore the last opened source documents when RStudio starts up.
.rs.uiPrefs$restoreSourceDocuments <- list(
   get = function() { .rs.getUserPref("restore_source_documents") },
   set = function(value) { .rs.setUserPref("restore_source_documents", value) },
   clear = function() { .rs.clearUserPref("restore_source_documents") }
)

# Handle errors only when user code present
#
# Whether to handle errors only when user code is on the stack.
.rs.uiPrefs$handleErrorsInUserCodeOnly <- list(
   get = function() { .rs.getUserPref("handle_errors_in_user_code_only") },
   set = function(value) { .rs.setUserPref("handle_errors_in_user_code_only", value) },
   clear = function() { .rs.clearUserPref("handle_errors_in_user_code_only") }
)

# Auto-expand error tracebacks
#
# Whether to automatically expand tracebacks when an error occurs.
.rs.uiPrefs$autoExpandErrorTracebacks <- list(
   get = function() { .rs.getUserPref("auto_expand_error_tracebacks") },
   set = function(value) { .rs.setUserPref("auto_expand_error_tracebacks", value) },
   clear = function() { .rs.clearUserPref("auto_expand_error_tracebacks") }
)

# Check for new version at startup
#
# Whether to check for new versions of RStudio when RStudio starts.
.rs.uiPrefs$checkForUpdates <- list(
   get = function() { .rs.getUserPref("check_for_updates") },
   set = function(value) { .rs.setUserPref("check_for_updates", value) },
   clear = function() { .rs.clearUserPref("check_for_updates") }
)

# Show internal functions when debugging
#
# Whether to show functions without source references in the Traceback pane while
# debugging.
.rs.uiPrefs$showInternalFunctions <- list(
   get = function() { .rs.getUserPref("show_internal_functions") },
   set = function(value) { .rs.setUserPref("show_internal_functions", value) },
   clear = function() { .rs.clearUserPref("show_internal_functions") }
)

# Run Shiny applications in
#
# Where to display Shiny applications when they are run.
.rs.uiPrefs$shinyViewerType <- list(
   get = function() { .rs.getUserPref("shiny_viewer_type") },
   set = function(value) { .rs.setUserPref("shiny_viewer_type", value) },
   clear = function() { .rs.clearUserPref("shiny_viewer_type") }
)

# Run Shiny applications in the background
#
# Whether to run Shiny applications as background jobs.
.rs.uiPrefs$shinyBackgroundJobs <- list(
   get = function() { .rs.getUserPref("shiny_background_jobs") },
   set = function(value) { .rs.setUserPref("shiny_background_jobs", value) },
   clear = function() { .rs.clearUserPref("shiny_background_jobs") }
)

# Run Plumber APIs in
#
# Where to display Shiny applications when they are run.
.rs.uiPrefs$plumberViewerType <- list(
   get = function() { .rs.getUserPref("plumber_viewer_type") },
   set = function(value) { .rs.setUserPref("plumber_viewer_type", value) },
   clear = function() { .rs.clearUserPref("plumber_viewer_type") }
)

# Document author
#
# The default name to use as the document author when creating new documents.
.rs.uiPrefs$documentAuthor <- list(
   get = function() { .rs.getUserPref("document_author") },
   set = function(value) { .rs.setUserPref("document_author", value) },
   clear = function() { .rs.clearUserPref("document_author") }
)

# Use current date when rendering document
#
# Use current date when rendering document
.rs.uiPrefs$rmdAutoDate <- list(
   get = function() { .rs.getUserPref("rmd_auto_date") },
   set = function(value) { .rs.setUserPref("rmd_auto_date", value) },
   clear = function() { .rs.clearUserPref("rmd_auto_date") }
)

# Path to preferred R Markdown template
#
# The path to the preferred R Markdown template.
.rs.uiPrefs$rmdPreferredTemplatePath <- list(
   get = function() { .rs.getUserPref("rmd_preferred_template_path") },
   set = function(value) { .rs.setUserPref("rmd_preferred_template_path", value) },
   clear = function() { .rs.clearUserPref("rmd_preferred_template_path") }
)

# Display R Markdown documents in
#
# Where to display R Markdown documents when they have completed rendering.
.rs.uiPrefs$rmdViewerType <- list(
   get = function() { .rs.getUserPref("rmd_viewer_type") },
   set = function(value) { .rs.setUserPref("rmd_viewer_type", value) },
   clear = function() { .rs.clearUserPref("rmd_viewer_type") }
)

# Show diagnostic info when publishing
#
# Whether to show verbose diagnostic information when publishing content.
.rs.uiPrefs$showPublishDiagnostics <- list(
   get = function() { .rs.getUserPref("show_publish_diagnostics") },
   set = function(value) { .rs.setUserPref("show_publish_diagnostics", value) },
   clear = function() { .rs.clearUserPref("show_publish_diagnostics") }
)

# 
#
# Whether to show UI for publishing content to Posit Cloud.
.rs.uiPrefs$enableCloudPublishUi <- list(
   get = function() { .rs.getUserPref("enable_cloud_publish_ui") },
   set = function(value) { .rs.setUserPref("enable_cloud_publish_ui", value) },
   clear = function() { .rs.clearUserPref("enable_cloud_publish_ui") }
)

# Check SSL certificates when publishing
#
# Whether to check remote server SSL certificates when publishing content.
.rs.uiPrefs$publishCheckCertificates <- list(
   get = function() { .rs.getUserPref("publish_check_certificates") },
   set = function(value) { .rs.setUserPref("publish_check_certificates", value) },
   clear = function() { .rs.clearUserPref("publish_check_certificates") }
)

# Use custom CA bundle when publishing
#
# Whether to use a custom certificate authority (CA) bundle when publishing
# content.
.rs.uiPrefs$usePublishCaBundle <- list(
   get = function() { .rs.getUserPref("use_publish_ca_bundle") },
   set = function(value) { .rs.setUserPref("use_publish_ca_bundle", value) },
   clear = function() { .rs.clearUserPref("use_publish_ca_bundle") }
)

# Path to custom CA bundle for publishing
#
# The path to the custom certificate authority (CA) bundle to use when publishing
# content.
.rs.uiPrefs$publishCaBundle <- list(
   get = function() { .rs.getUserPref("publish_ca_bundle") },
   set = function(value) { .rs.setUserPref("publish_ca_bundle", value) },
   clear = function() { .rs.clearUserPref("publish_ca_bundle") }
)

# Show chunk output inline in all documents
#
# Whether to show chunk output inline for ordinary R Markdown documents.
.rs.uiPrefs$rmdChunkOutputInline <- list(
   get = function() { .rs.getUserPref("rmd_chunk_output_inline") },
   set = function(value) { .rs.setUserPref("rmd_chunk_output_inline", value) },
   clear = function() { .rs.clearUserPref("rmd_chunk_output_inline") }
)

# Open document outline by default
#
# Whether to show the document outline by default when opening R Markdown
# documents.
.rs.uiPrefs$showDocOutlineRmd <- list(
   get = function() { .rs.getUserPref("show_doc_outline_rmd") },
   set = function(value) { .rs.setUserPref("show_doc_outline_rmd", value) },
   clear = function() { .rs.clearUserPref("show_doc_outline_rmd") }
)

# Document outline font size
#
# The font size to use for items in the document outline.
.rs.uiPrefs$documentOutlineFontSize <- list(
   get = function() { .rs.getUserPref("document_outline_font_size") },
   set = function(value) { .rs.setUserPref("document_outline_font_size", value) },
   clear = function() { .rs.clearUserPref("document_outline_font_size") }
)

# Automatically run Setup chunk when needed
#
# Whether to automatically run an R Markdown document's Setup chunk before
# running other chunks.
.rs.uiPrefs$autoRunSetupChunk <- list(
   get = function() { .rs.getUserPref("auto_run_setup_chunk") },
   set = function(value) { .rs.setUserPref("auto_run_setup_chunk", value) },
   clear = function() { .rs.clearUserPref("auto_run_setup_chunk") }
)

# Hide console when running R Markdown chunks
#
# Whether to hide the R console when executing inline R Markdown chunks.
.rs.uiPrefs$hideConsoleOnChunkExecute <- list(
   get = function() { .rs.getUserPref("hide_console_on_chunk_execute") },
   set = function(value) { .rs.setUserPref("hide_console_on_chunk_execute", value) },
   clear = function() { .rs.clearUserPref("hide_console_on_chunk_execute") }
)

# Unit of R code execution
#
# The unit of R code to execute when the Execute command is invoked.
.rs.uiPrefs$executionBehavior <- list(
   get = function() { .rs.getUserPref("execution_behavior") },
   set = function(value) { .rs.setUserPref("execution_behavior", value) },
   clear = function() { .rs.clearUserPref("execution_behavior") }
)

# Show the Terminal tab
#
# Whether to show the Terminal tab.
.rs.uiPrefs$showTerminalTab <- list(
   get = function() { .rs.getUserPref("show_terminal_tab") },
   set = function(value) { .rs.setUserPref("show_terminal_tab", value) },
   clear = function() { .rs.clearUserPref("show_terminal_tab") }
)

# Use local echo in the Terminal
#
# Whether to use local echo in the Terminal.
.rs.uiPrefs$terminalLocalEcho <- list(
   get = function() { .rs.getUserPref("terminal_local_echo") },
   set = function(value) { .rs.setUserPref("terminal_local_echo", value) },
   clear = function() { .rs.clearUserPref("terminal_local_echo") }
)

# Use websockets in the Terminal
#
# Whether to use websockets to communicate with the shell in the Terminal tab.
.rs.uiPrefs$terminalWebsockets <- list(
   get = function() { .rs.getUserPref("terminal_websockets") },
   set = function(value) { .rs.setUserPref("terminal_websockets", value) },
   clear = function() { .rs.clearUserPref("terminal_websockets") }
)

# Close Terminal pane after shell exit
#
# Whether to close the terminal pane after the shell exits.
.rs.uiPrefs$terminalCloseBehavior <- list(
   get = function() { .rs.getUserPref("terminal_close_behavior") },
   set = function(value) { .rs.setUserPref("terminal_close_behavior", value) },
   clear = function() { .rs.clearUserPref("terminal_close_behavior") }
)

# Save and restore system environment in Terminal tab
#
# Whether to track and save changes to system environment variables in the
# Terminal.
.rs.uiPrefs$terminalTrackEnvironment <- list(
   get = function() { .rs.getUserPref("terminal_track_environment") },
   set = function(value) { .rs.setUserPref("terminal_track_environment", value) },
   clear = function() { .rs.clearUserPref("terminal_track_environment") }
)

# Ignored environment variables
#
# Environment variables which should be ignored when tracking changed to
# environment variables within a Terminal. Environment variables in this list
# will not be saved when a Terminal instance is saved and restored.
.rs.uiPrefs$terminalIgnoredEnvironmentVariables <- list(
   get = function() { .rs.getUserPref("terminal_ignored_environment_variables") },
   set = function(value) { .rs.setUserPref("terminal_ignored_environment_variables", value) },
   clear = function() { .rs.clearUserPref("terminal_ignored_environment_variables") }
)

# Enable Terminal hooks
#
# Enabled Terminal hooks? Required for Python terminal integration, which places
# the active version of Python on the PATH in new Terminal sessions.
.rs.uiPrefs$terminalHooks <- list(
   get = function() { .rs.getUserPref("terminal_hooks") },
   set = function(value) { .rs.setUserPref("terminal_hooks", value) },
   clear = function() { .rs.clearUserPref("terminal_hooks") }
)

# Terminal bell style
#
# Terminal bell style
.rs.uiPrefs$terminalBellStyle <- list(
   get = function() { .rs.getUserPref("terminal_bell_style") },
   set = function(value) { .rs.setUserPref("terminal_bell_style", value) },
   clear = function() { .rs.clearUserPref("terminal_bell_style") }
)

# Terminal tab rendering engine
#
# Terminal rendering engine: canvas is faster, dom may be needed for some
# browsers or graphics cards
.rs.uiPrefs$terminalRenderer <- list(
   get = function() { .rs.getUserPref("terminal_renderer") },
   set = function(value) { .rs.setUserPref("terminal_renderer", value) },
   clear = function() { .rs.clearUserPref("terminal_renderer") }
)

# Make links in Terminal clickable
#
# Whether web links displayed in the Terminal tab are made clickable.
.rs.uiPrefs$terminalWeblinks <- list(
   get = function() { .rs.getUserPref("terminal_weblinks") },
   set = function(value) { .rs.setUserPref("terminal_weblinks", value) },
   clear = function() { .rs.clearUserPref("terminal_weblinks") }
)

# Show R Markdown render command
#
# Whether to print the render command use to knit R Markdown documents in the R
# Markdown tab.
.rs.uiPrefs$showRmdRenderCommand <- list(
   get = function() { .rs.getUserPref("show_rmd_render_command") },
   set = function(value) { .rs.setUserPref("show_rmd_render_command", value) },
   clear = function() { .rs.clearUserPref("show_rmd_render_command") }
)

# Enable dragging text in code editor
#
# Whether to enable moving text on the editing surface by clicking and dragging
# it.
.rs.uiPrefs$enableTextDrag <- list(
   get = function() { .rs.getUserPref("enable_text_drag") },
   set = function(value) { .rs.setUserPref("enable_text_drag", value) },
   clear = function() { .rs.clearUserPref("enable_text_drag") }
)

# Show hidden files in Files pane
#
# Whether to show hidden files in the Files pane.
.rs.uiPrefs$showHiddenFiles <- list(
   get = function() { .rs.getUserPref("show_hidden_files") },
   set = function(value) { .rs.setUserPref("show_hidden_files", value) },
   clear = function() { .rs.clearUserPref("show_hidden_files") }
)

# Files always shown in the Files Pane
#
# List of file names (case sensitive) that are always shown in the Files Pane,
# regardless of whether hidden files are shown
.rs.uiPrefs$alwaysShownFiles <- list(
   get = function() { .rs.getUserPref("always_shown_files") },
   set = function(value) { .rs.setUserPref("always_shown_files", value) },
   clear = function() { .rs.clearUserPref("always_shown_files") }
)

# Extensions always shown in the Files Pane
#
# List of file extensions (beginning with ., not case sensitive) that are always
# shown in the Files Pane, regardless of whether hidden files are shown
.rs.uiPrefs$alwaysShownExtensions <- list(
   get = function() { .rs.getUserPref("always_shown_extensions") },
   set = function(value) { .rs.setUserPref("always_shown_extensions", value) },
   clear = function() { .rs.clearUserPref("always_shown_extensions") }
)

# Sort file names naturally in Files pane
#
# Whether to sort file names naturally, so that e.g., file10.R comes after
# file9.R
.rs.uiPrefs$sortFileNamesNaturally <- list(
   get = function() { .rs.getUserPref("sort_file_names_naturally") },
   set = function(value) { .rs.setUserPref("sort_file_names_naturally", value) },
   clear = function() { .rs.clearUserPref("sort_file_names_naturally") }
)

# Synchronize the Files pane with the current working directory
#
# Whether to change the directory in the Files pane automatically when the
# working directory in R changes.
.rs.uiPrefs$syncFilesPaneWorkingDir <- list(
   get = function() { .rs.getUserPref("sync_files_pane_working_dir") },
   set = function(value) { .rs.setUserPref("sync_files_pane_working_dir", value) },
   clear = function() { .rs.clearUserPref("sync_files_pane_working_dir") }
)

# Jobs tab visibility
#
# The visibility of the Jobs tab.
.rs.uiPrefs$jobsTabVisibility <- list(
   get = function() { .rs.getUserPref("jobs_tab_visibility") },
   set = function(value) { .rs.setUserPref("jobs_tab_visibility", value) },
   clear = function() { .rs.clearUserPref("jobs_tab_visibility") }
)

# 
#
# Whether to show the Workbench Jobs tab in RStudio Pro and RStudio Workbench.
.rs.uiPrefs$showLauncherJobsTab <- list(
   get = function() { .rs.getUserPref("show_launcher_jobs_tab") },
   set = function(value) { .rs.setUserPref("show_launcher_jobs_tab", value) },
   clear = function() { .rs.clearUserPref("show_launcher_jobs_tab") }
)

# 
#
# How to sort jobs in the Workbench Jobs tab in RStudio Pro and RStudio
# Workbench.
.rs.uiPrefs$launcherJobsSort <- list(
   get = function() { .rs.getUserPref("launcher_jobs_sort") },
   set = function(value) { .rs.setUserPref("launcher_jobs_sort", value) },
   clear = function() { .rs.clearUserPref("launcher_jobs_sort") }
)

# 
#
# How to detect busy status in the Terminal.
.rs.uiPrefs$busyDetection <- list(
   get = function() { .rs.getUserPref("busy_detection") },
   set = function(value) { .rs.setUserPref("busy_detection", value) },
   clear = function() { .rs.clearUserPref("busy_detection") }
)

# 
#
# A list of apps that should not be considered busy in the Terminal.
.rs.uiPrefs$busyExclusionList <- list(
   get = function() { .rs.getUserPref("busy_exclusion_list") },
   set = function(value) { .rs.setUserPref("busy_exclusion_list", value) },
   clear = function() { .rs.clearUserPref("busy_exclusion_list") }
)

# Working directory for knitting
#
# The working directory to use when knitting R Markdown documents.
.rs.uiPrefs$knitWorkingDir <- list(
   get = function() { .rs.getUserPref("knit_working_dir") },
   set = function(value) { .rs.setUserPref("knit_working_dir", value) },
   clear = function() { .rs.clearUserPref("knit_working_dir") }
)

# Show in Document Outline
#
# Which objects to show in the document outline pane.
.rs.uiPrefs$docOutlineShow <- list(
   get = function() { .rs.getUserPref("doc_outline_show") },
   set = function(value) { .rs.setUserPref("doc_outline_show", value) },
   clear = function() { .rs.clearUserPref("doc_outline_show") }
)

# Preview LaTeX equations on idle
#
# When to preview LaTeX mathematical equations when cursor has not moved
# recently.
.rs.uiPrefs$latexPreviewOnCursorIdle <- list(
   get = function() { .rs.getUserPref("latex_preview_on_cursor_idle") },
   set = function(value) { .rs.setUserPref("latex_preview_on_cursor_idle", value) },
   clear = function() { .rs.clearUserPref("latex_preview_on_cursor_idle") }
)

# Wrap around when going to previous/next tab
#
# Whether to wrap around when going to the previous or next editor tab.
.rs.uiPrefs$wrapTabNavigation <- list(
   get = function() { .rs.getUserPref("wrap_tab_navigation") },
   set = function(value) { .rs.setUserPref("wrap_tab_navigation", value) },
   clear = function() { .rs.clearUserPref("wrap_tab_navigation") }
)

# Global theme
#
# The theme to use for the main RStudio user interface.
.rs.uiPrefs$globalTheme <- list(
   get = function() { .rs.getUserPref("global_theme") },
   set = function(value) { .rs.setUserPref("global_theme", value) },
   clear = function() { .rs.clearUserPref("global_theme") }
)

# Ignore whitespace in VCS diffs
#
# Whether to ignore whitespace when generating diffs of version controlled files.
.rs.uiPrefs$gitDiffIgnoreWhitespace <- list(
   get = function() { .rs.getUserPref("git_diff_ignore_whitespace") },
   set = function(value) { .rs.setUserPref("git_diff_ignore_whitespace", value) },
   clear = function() { .rs.clearUserPref("git_diff_ignore_whitespace") }
)

# Sign git commits
#
# Whether to sign git commits.
.rs.uiPrefs$gitSignedCommits <- list(
   get = function() { .rs.getUserPref("git_signed_commits") },
   set = function(value) { .rs.setUserPref("git_signed_commits", value) },
   clear = function() { .rs.clearUserPref("git_signed_commits") }
)

# Double click to select in the Console
#
# Whether double-clicking should select a word in the Console pane.
.rs.uiPrefs$consoleDoubleClickSelect <- list(
   get = function() { .rs.getUserPref("console_double_click_select") },
   set = function(value) { .rs.setUserPref("console_double_click_select", value) },
   clear = function() { .rs.clearUserPref("console_double_click_select") }
)

# Warn when automatic session suspension is paused
#
# Whether the 'Auto Suspension Blocked' icon should appear in the R Console
# toolbar.
.rs.uiPrefs$consoleSuspendBlockedNotice <- list(
   get = function() { .rs.getUserPref("console_suspend_blocked_notice") },
   set = function(value) { .rs.setUserPref("console_suspend_blocked_notice", value) },
   clear = function() { .rs.clearUserPref("console_suspend_blocked_notice") }
)

# Number of seconds to delay warning
#
# How long to wait before warning that automatic session suspension has been
# paused. Higher values for less frequent notices.
.rs.uiPrefs$consoleSuspendBlockedNoticeDelay <- list(
   get = function() { .rs.getUserPref("console_suspend_blocked_notice_delay") },
   set = function(value) { .rs.setUserPref("console_suspend_blocked_notice_delay", value) },
   clear = function() { .rs.clearUserPref("console_suspend_blocked_notice_delay") }
)

# Create a Git repo in new projects
#
# Whether a git repo should be initialized inside new projects by default.
.rs.uiPrefs$newProjGitInit <- list(
   get = function() { .rs.getUserPref("new_proj_git_init") },
   set = function(value) { .rs.setUserPref("new_proj_git_init", value) },
   clear = function() { .rs.clearUserPref("new_proj_git_init") }
)

# Create an renv environment in new projects
#
# Whether an renv environment should be created inside new projects by default.
.rs.uiPrefs$newProjUseRenv <- list(
   get = function() { .rs.getUserPref("new_proj_use_renv") },
   set = function(value) { .rs.setUserPref("new_proj_use_renv", value) },
   clear = function() { .rs.clearUserPref("new_proj_use_renv") }
)

# Root document for PDF compilation
#
# The root document to use when compiling PDF documents.
.rs.uiPrefs$rootDocument <- list(
   get = function() { .rs.getUserPref("root_document") },
   set = function(value) { .rs.setUserPref("root_document", value) },
   clear = function() { .rs.clearUserPref("root_document") }
)

# Show user home page in RStudio Workbench
#
# When to show the server home page in RStudio Workbench.
.rs.uiPrefs$showUserHomePage <- list(
   get = function() { .rs.getUserPref("show_user_home_page") },
   set = function(value) { .rs.setUserPref("show_user_home_page", value) },
   clear = function() { .rs.clearUserPref("show_user_home_page") }
)

# 
#
# Whether to reuse sessions when opening projects in RStudio Workbench.
.rs.uiPrefs$reuseSessionsForProjectLinks <- list(
   get = function() { .rs.getUserPref("reuse_sessions_for_project_links") },
   set = function(value) { .rs.setUserPref("reuse_sessions_for_project_links", value) },
   clear = function() { .rs.clearUserPref("reuse_sessions_for_project_links") }
)

# Enable version control if available
#
# Whether to enable RStudio's version control system interface.
.rs.uiPrefs$vcsEnabled <- list(
   get = function() { .rs.getUserPref("vcs_enabled") },
   set = function(value) { .rs.setUserPref("vcs_enabled", value) },
   clear = function() { .rs.clearUserPref("vcs_enabled") }
)

# Auto-refresh state from version control
#
# Automatically refresh VCS status?
.rs.uiPrefs$vcsAutorefresh <- list(
   get = function() { .rs.getUserPref("vcs_autorefresh") },
   set = function(value) { .rs.setUserPref("vcs_autorefresh", value) },
   clear = function() { .rs.clearUserPref("vcs_autorefresh") }
)

# Path to Git executable
#
# The path to the Git executable to use.
.rs.uiPrefs$gitExePath <- list(
   get = function() { .rs.getUserPref("git_exe_path") },
   set = function(value) { .rs.setUserPref("git_exe_path", value) },
   clear = function() { .rs.clearUserPref("git_exe_path") }
)

# Path to Subversion executable
#
# The path to the Subversion executable to use.
.rs.uiPrefs$svnExePath <- list(
   get = function() { .rs.getUserPref("svn_exe_path") },
   set = function(value) { .rs.setUserPref("svn_exe_path", value) },
   clear = function() { .rs.clearUserPref("svn_exe_path") }
)

# 
#
# The path to the terminal executable to use.
.rs.uiPrefs$terminalPath <- list(
   get = function() { .rs.getUserPref("terminal_path") },
   set = function(value) { .rs.setUserPref("terminal_path", value) },
   clear = function() { .rs.clearUserPref("terminal_path") }
)

# 
#
# The path to the SSH key file to use.
.rs.uiPrefs$rsaKeyPath <- list(
   get = function() { .rs.getUserPref("rsa_key_path") },
   set = function(value) { .rs.setUserPref("rsa_key_path", value) },
   clear = function() { .rs.clearUserPref("rsa_key_path") }
)

# 
#
# The encryption type to use for the SSH key file.
.rs.uiPrefs$sshKeyType <- list(
   get = function() { .rs.getUserPref("ssh_key_type") },
   set = function(value) { .rs.setUserPref("ssh_key_type", value) },
   clear = function() { .rs.clearUserPref("ssh_key_type") }
)

# Use the devtools R package if available
#
# Whether to use the devtools R package.
.rs.uiPrefs$useDevtools <- list(
   get = function() { .rs.getUserPref("use_devtools") },
   set = function(value) { .rs.setUserPref("use_devtools", value) },
   clear = function() { .rs.clearUserPref("use_devtools") }
)

# Always use --preclean when installing package
#
# Always use --preclean when installing package.
.rs.uiPrefs$cleanBeforeInstall <- list(
   get = function() { .rs.getUserPref("clean_before_install") },
   set = function(value) { .rs.setUserPref("clean_before_install", value) },
   clear = function() { .rs.clearUserPref("clean_before_install") }
)

# Use alternate library path when building package
#
# When set, RStudio will build your package in a '_build' sub-directory of your
# current library paths.
.rs.uiPrefs$useBuildSubdirectory <- list(
   get = function() { .rs.getUserPref("use_build_subdirectory") },
   set = function(value) { .rs.setUserPref("use_build_subdirectory", value) },
   clear = function() { .rs.clearUserPref("use_build_subdirectory") }
)

# Download R packages securely
#
# Whether to use secure downloads when fetching R packages.
.rs.uiPrefs$useSecureDownload <- list(
   get = function() { .rs.getUserPref("use_secure_download") },
   set = function(value) { .rs.setUserPref("use_secure_download", value) },
   clear = function() { .rs.clearUserPref("use_secure_download") }
)

# Clean up temporary files after R CMD CHECK
#
# Whether to clean up temporary files after running R CMD CHECK.
.rs.uiPrefs$cleanupAfterRCmdCheck <- list(
   get = function() { .rs.getUserPref("cleanup_after_r_cmd_check") },
   set = function(value) { .rs.setUserPref("cleanup_after_r_cmd_check", value) },
   clear = function() { .rs.clearUserPref("cleanup_after_r_cmd_check") }
)

# View directory after R CMD CHECK
#
# Whether to view the directory after running R CMD CHECK.
.rs.uiPrefs$viewDirAfterRCmdCheck <- list(
   get = function() { .rs.getUserPref("view_dir_after_r_cmd_check") },
   set = function(value) { .rs.setUserPref("view_dir_after_r_cmd_check", value) },
   clear = function() { .rs.clearUserPref("view_dir_after_r_cmd_check") }
)

# Hide object files in the Files pane
#
# Whether to hide object files in the Files pane.
.rs.uiPrefs$hideObjectFiles <- list(
   get = function() { .rs.getUserPref("hide_object_files") },
   set = function(value) { .rs.setUserPref("hide_object_files", value) },
   clear = function() { .rs.clearUserPref("hide_object_files") }
)

# Restore last project when starting RStudio
#
# Whether to restore the last project when starting RStudio.
.rs.uiPrefs$restoreLastProject <- list(
   get = function() { .rs.getUserPref("restore_last_project") },
   set = function(value) { .rs.setUserPref("restore_last_project", value) },
   clear = function() { .rs.clearUserPref("restore_last_project") }
)

# Number of seconds for safe project startup
#
# The number of seconds after which a project is deemed to have successfully
# started.
.rs.uiPrefs$projectSafeStartupSeconds <- list(
   get = function() { .rs.getUserPref("project_safe_startup_seconds") },
   set = function(value) { .rs.setUserPref("project_safe_startup_seconds", value) },
   clear = function() { .rs.clearUserPref("project_safe_startup_seconds") }
)

# Use tinytex to compile .tex files
#
# Use tinytex to compile .tex files.
.rs.uiPrefs$useTinytex <- list(
   get = function() { .rs.getUserPref("use_tinytex") },
   set = function(value) { .rs.setUserPref("use_tinytex", value) },
   clear = function() { .rs.clearUserPref("use_tinytex") }
)

# Clean output after running Texi2Dvi
#
# Whether to clean output after running Texi2Dvi.
.rs.uiPrefs$cleanTexi2dviOutput <- list(
   get = function() { .rs.getUserPref("clean_texi2dvi_output") },
   set = function(value) { .rs.setUserPref("clean_texi2dvi_output", value) },
   clear = function() { .rs.clearUserPref("clean_texi2dvi_output") }
)

# Shell escape LaTeX documents
#
# Whether to enable shell escaping with LaTeX documents.
.rs.uiPrefs$latexShellEscape <- list(
   get = function() { .rs.getUserPref("latex_shell_escape") },
   set = function(value) { .rs.setUserPref("latex_shell_escape", value) },
   clear = function() { .rs.clearUserPref("latex_shell_escape") }
)

# Restore project R version in RStudio Pro and RStudio Workbench
#
# Whether to restore the last version of R used by the project in RStudio Pro and
# RStudio Workbench.
.rs.uiPrefs$restoreProjectRVersion <- list(
   get = function() { .rs.getUserPref("restore_project_r_version") },
   set = function(value) { .rs.setUserPref("restore_project_r_version", value) },
   clear = function() { .rs.clearUserPref("restore_project_r_version") }
)

# Clang verbosity level (0 - 2)
#
# The verbosity level to use with Clang (0 - 2)
.rs.uiPrefs$clangVerbose <- list(
   get = function() { .rs.getUserPref("clang_verbose") },
   set = function(value) { .rs.setUserPref("clang_verbose", value) },
   clear = function() { .rs.clearUserPref("clang_verbose") }
)

# Submit crash reports to Posit
#
# Whether to automatically submit crash reports to Posit.
.rs.uiPrefs$submitCrashReports <- list(
   get = function() { .rs.getUserPref("submit_crash_reports") },
   set = function(value) { .rs.setUserPref("submit_crash_reports", value) },
   clear = function() { .rs.clearUserPref("submit_crash_reports") }
)

# 
#
# The R version to use by default.
.rs.uiPrefs$defaultRVersion <- list(
   get = function() { .rs.getUserPref("default_r_version") },
   set = function(value) { .rs.setUserPref("default_r_version", value) },
   clear = function() { .rs.clearUserPref("default_r_version") }
)

# Maximum number of columns in data viewer
#
# The maximum number of columns to show at once in the data viewer.
.rs.uiPrefs$dataViewerMaxColumns <- list(
   get = function() { .rs.getUserPref("data_viewer_max_columns") },
   set = function(value) { .rs.setUserPref("data_viewer_max_columns", value) },
   clear = function() { .rs.clearUserPref("data_viewer_max_columns") }
)

# Maximum number of character in data viewer cells
#
# The maximum number of characters to show in a data viewer cell.
.rs.uiPrefs$dataViewerMaxCellSize <- list(
   get = function() { .rs.getUserPref("data_viewer_max_cell_size") },
   set = function(value) { .rs.setUserPref("data_viewer_max_cell_size", value) },
   clear = function() { .rs.clearUserPref("data_viewer_max_cell_size") }
)

# Enable support for screen readers
#
# Support accessibility aids such as screen readers.
.rs.uiPrefs$enableScreenReader <- list(
   get = function() { .rs.getUserPref("enable_screen_reader") },
   set = function(value) { .rs.setUserPref("enable_screen_reader", value) },
   clear = function() { .rs.clearUserPref("enable_screen_reader") }
)

# Seconds to wait before updating ARIA live region
#
# Number of milliseconds to wait after last keystroke before updating live
# region.
.rs.uiPrefs$typingStatusDelayMs <- list(
   get = function() { .rs.getUserPref("typing_status_delay_ms") },
   set = function(value) { .rs.setUserPref("typing_status_delay_ms", value) },
   clear = function() { .rs.clearUserPref("typing_status_delay_ms") }
)

# Reduced animation/motion mode
#
# Reduce use of animations in the user interface.
.rs.uiPrefs$reducedMotion <- list(
   get = function() { .rs.getUserPref("reduced_motion") },
   set = function(value) { .rs.setUserPref("reduced_motion", value) },
   clear = function() { .rs.clearUserPref("reduced_motion") }
)

# Tab key always moves focus
#
# Tab key moves focus out of text editing controls instead of inserting tabs.
.rs.uiPrefs$tabKeyMoveFocus <- list(
   get = function() { .rs.getUserPref("tab_key_move_focus") },
   set = function(value) { .rs.setUserPref("tab_key_move_focus", value) },
   clear = function() { .rs.clearUserPref("tab_key_move_focus") }
)

# Tab key moves focus directly from find text to replace text in find panel
#
# In source editor find panel, tab key moves focus directly from find text to
# replace text.
.rs.uiPrefs$findPanelLegacyTabSequence <- list(
   get = function() { .rs.getUserPref("find_panel_legacy_tab_sequence") },
   set = function(value) { .rs.setUserPref("find_panel_legacy_tab_sequence", value) },
   clear = function() { .rs.clearUserPref("find_panel_legacy_tab_sequence") }
)

# Show focus outline around focused panel
#
# Show which panel contains keyboard focus.
.rs.uiPrefs$showPanelFocusRectangle <- list(
   get = function() { .rs.getUserPref("show_panel_focus_rectangle") },
   set = function(value) { .rs.setUserPref("show_panel_focus_rectangle", value) },
   clear = function() { .rs.clearUserPref("show_panel_focus_rectangle") }
)

# Autosave mode on idle
#
# How to deal with changes to documents on idle.
.rs.uiPrefs$autoSaveOnIdle <- list(
   get = function() { .rs.getUserPref("auto_save_on_idle") },
   set = function(value) { .rs.setUserPref("auto_save_on_idle", value) },
   clear = function() { .rs.clearUserPref("auto_save_on_idle") }
)

# Idle period for document autosave (ms)
#
# The idle period, in milliseconds, after which documents should be auto-saved.
.rs.uiPrefs$autoSaveIdleMs <- list(
   get = function() { .rs.getUserPref("auto_save_idle_ms") },
   set = function(value) { .rs.setUserPref("auto_save_idle_ms", value) },
   clear = function() { .rs.clearUserPref("auto_save_idle_ms") }
)

# Save documents when editor loses input focus
#
# Whether to automatically save when the editor loses focus.
.rs.uiPrefs$autoSaveOnBlur <- list(
   get = function() { .rs.getUserPref("auto_save_on_blur") },
   set = function(value) { .rs.setUserPref("auto_save_on_blur", value) },
   clear = function() { .rs.clearUserPref("auto_save_on_blur") }
)

# Initial working directory for new terminals
#
# Initial directory for new terminals.
.rs.uiPrefs$terminalInitialDirectory <- list(
   get = function() { .rs.getUserPref("terminal_initial_directory") },
   set = function(value) { .rs.setUserPref("terminal_initial_directory", value) },
   clear = function() { .rs.clearUserPref("terminal_initial_directory") }
)

# Show full path to project in RStudio Desktop windows
#
# Whether to show the full path to project in desktop window title.
.rs.uiPrefs$fullProjectPathInWindowTitle <- list(
   get = function() { .rs.getUserPref("full_project_path_in_window_title") },
   set = function(value) { .rs.setUserPref("full_project_path_in_window_title", value) },
   clear = function() { .rs.clearUserPref("full_project_path_in_window_title") }
)

# Use visual editing by default for new markdown documents
#
# Whether to enable visual editing by default for new markdown documents
.rs.uiPrefs$visualMarkdownEditingIsDefault <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_is_default") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_is_default", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_is_default") }
)

# Default list spacing in visual markdown editing mode
#
# Default spacing for lists created in the visual editor
.rs.uiPrefs$visualMarkdownEditingListSpacing <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_list_spacing") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_list_spacing", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_list_spacing") }
)

# Wrap text in visual markdown editing mode
#
# Whether to automatically wrap text when writing markdown
.rs.uiPrefs$visualMarkdownEditingWrap <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_wrap") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_wrap", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_wrap") }
)

# Wrap column for visual markdown editing mode
#
# The column to wrap text at when writing markdown
.rs.uiPrefs$visualMarkdownEditingWrapAtColumn <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_wrap_at_column") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_wrap_at_column", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_wrap_at_column") }
)

# Place visual markdown footnotes in
#
# Placement of footnotes within markdown output.
.rs.uiPrefs$visualMarkdownEditingReferencesLocation <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_references_location") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_references_location", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_references_location") }
)

# Write canonical visual mode markdown in source mode
#
# Whether to write canonical visual mode markdown when saving from source mode.
.rs.uiPrefs$visualMarkdownEditingCanonical <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_canonical") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_canonical", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_canonical") }
)

# Max content width for visual markdown editor (px)
#
# Maximum content width for visual editing mode, in pixels
.rs.uiPrefs$visualMarkdownEditingMaxContentWidth <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_max_content_width") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_max_content_width", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_max_content_width") }
)

# Show document outline in visual markdown editing mode
#
# Whether to show the document outline by default when opening R Markdown
# documents in visual mode.
.rs.uiPrefs$visualMarkdownEditingShowDocOutline <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_show_doc_outline") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_show_doc_outline", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_show_doc_outline") }
)

# Show margin in visual mode code blocks
#
# Whether to show the margin guide in the visual mode code blocks.
.rs.uiPrefs$visualMarkdownEditingShowMargin <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_show_margin") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_show_margin", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_show_margin") }
)

# Show line numbers in visual mode code blocks
#
# Whether to show line numbers in the code editors used in visual mode
.rs.uiPrefs$visualMarkdownCodeEditorLineNumbers <- list(
   get = function() { .rs.getUserPref("visual_markdown_code_editor_line_numbers") },
   set = function(value) { .rs.setUserPref("visual_markdown_code_editor_line_numbers", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_code_editor_line_numbers") }
)

# Font size for visual editing mode
#
# The default visual editing mode font size, in points
.rs.uiPrefs$visualMarkdownEditingFontSizePoints <- list(
   get = function() { .rs.getUserPref("visual_markdown_editing_font_size_points") },
   set = function(value) { .rs.setUserPref("visual_markdown_editing_font_size_points", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_editing_font_size_points") }
)

# Editor for code chunks in visual editing mode
#
# The name of the editor to use to provide code editing in visual mode
.rs.uiPrefs$visualMarkdownCodeEditor <- list(
   get = function() { .rs.getUserPref("visual_markdown_code_editor") },
   set = function(value) { .rs.setUserPref("visual_markdown_code_editor", value) },
   clear = function() { .rs.clearUserPref("visual_markdown_code_editor") }
)

# Zotero libraries
#
# Zotero libraries to insert citations from.
.rs.uiPrefs$zoteroLibraries <- list(
   get = function() { .rs.getUserPref("zotero_libraries") },
   set = function(value) { .rs.setUserPref("zotero_libraries", value) },
   clear = function() { .rs.clearUserPref("zotero_libraries") }
)

# 
#
# Preferred emoji skintone
.rs.uiPrefs$emojiSkintone <- list(
   get = function() { .rs.getUserPref("emoji_skintone") },
   set = function(value) { .rs.setUserPref("emoji_skintone", value) },
   clear = function() { .rs.clearUserPref("emoji_skintone") }
)

# Disabled aria-live announcements
#
# List of aria-live announcements to disable.
.rs.uiPrefs$disabledAriaLiveAnnouncements <- list(
   get = function() { .rs.getUserPref("disabled_aria_live_announcements") },
   set = function(value) { .rs.setUserPref("disabled_aria_live_announcements", value) },
   clear = function() { .rs.clearUserPref("disabled_aria_live_announcements") }
)

# Maximum number of console lines to announce
#
# Maximum number of lines of console output announced after a command.
.rs.uiPrefs$screenreaderConsoleAnnounceLimit <- list(
   get = function() { .rs.getUserPref("screenreader_console_announce_limit") },
   set = function(value) { .rs.setUserPref("screenreader_console_announce_limit", value) },
   clear = function() { .rs.clearUserPref("screenreader_console_announce_limit") }
)

# List of path components ignored by file monitor
#
# List of path components; file monitor will ignore paths containing one or more
# of these components.
.rs.uiPrefs$fileMonitorIgnoredComponents <- list(
   get = function() { .rs.getUserPref("file_monitor_ignored_components") },
   set = function(value) { .rs.setUserPref("file_monitor_ignored_components", value) },
   clear = function() { .rs.clearUserPref("file_monitor_ignored_components") }
)

# Install R package dependencies one at a time
#
# Whether to install R package dependencies one at a time.
.rs.uiPrefs$installPkgDepsIndividually <- list(
   get = function() { .rs.getUserPref("install_pkg_deps_individually") },
   set = function(value) { .rs.setUserPref("install_pkg_deps_individually", value) },
   clear = function() { .rs.clearUserPref("install_pkg_deps_individually") }
)

# R graphics backend
#
# R graphics backend.
.rs.uiPrefs$graphicsBackend <- list(
   get = function() { .rs.getUserPref("graphics_backend") },
   set = function(value) { .rs.setUserPref("graphics_backend", value) },
   clear = function() { .rs.clearUserPref("graphics_backend") }
)

# R graphics antialiasing method
#
# Type of anti-aliasing to be used for generated R plots.
.rs.uiPrefs$graphicsAntialiasing <- list(
   get = function() { .rs.getUserPref("graphics_antialiasing") },
   set = function(value) { .rs.setUserPref("graphics_antialiasing", value) },
   clear = function() { .rs.clearUserPref("graphics_antialiasing") }
)

# Fixed-width font list for RStudio Server
#
# List of fixed-width fonts to check for browser support.
.rs.uiPrefs$browserFixedWidthFonts <- list(
   get = function() { .rs.getUserPref("browser_fixed_width_fonts") },
   set = function(value) { .rs.setUserPref("browser_fixed_width_fonts", value) },
   clear = function() { .rs.clearUserPref("browser_fixed_width_fonts") }
)

# 
#
# The Python type.
.rs.uiPrefs$pythonType <- list(
   get = function() { .rs.getUserPref("python_type") },
   set = function(value) { .rs.setUserPref("python_type", value) },
   clear = function() { .rs.clearUserPref("python_type") }
)

# 
#
# The Python version.
.rs.uiPrefs$pythonVersion <- list(
   get = function() { .rs.getUserPref("python_version") },
   set = function(value) { .rs.setUserPref("python_version", value) },
   clear = function() { .rs.clearUserPref("python_version") }
)

# 
#
# The path to the default Python interpreter.
.rs.uiPrefs$pythonPath <- list(
   get = function() { .rs.getUserPref("python_path") },
   set = function(value) { .rs.setUserPref("python_path", value) },
   clear = function() { .rs.clearUserPref("python_path") }
)

# Save Retry Timeout
#
# The maximum amount of seconds of retry for save operations.
.rs.uiPrefs$saveRetryTimeout <- list(
   get = function() { .rs.getUserPref("save_retry_timeout") },
   set = function(value) { .rs.setUserPref("save_retry_timeout", value) },
   clear = function() { .rs.clearUserPref("save_retry_timeout") }
)

# Use R's native pipe operator, |>
#
# Whether the Insert Pipe Operator command should use the native R pipe operator,
# |>
.rs.uiPrefs$insertNativePipeOperator <- list(
   get = function() { .rs.getUserPref("insert_native_pipe_operator") },
   set = function(value) { .rs.setUserPref("insert_native_pipe_operator", value) },
   clear = function() { .rs.clearUserPref("insert_native_pipe_operator") }
)

# Remember recently used items in Command Palette
#
# Whether to keep track of recently used commands in the Command Palette
.rs.uiPrefs$commandPaletteMru <- list(
   get = function() { .rs.getUserPref("command_palette_mru") },
   set = function(value) { .rs.setUserPref("command_palette_mru", value) },
   clear = function() { .rs.clearUserPref("command_palette_mru") }
)

# Show memory usage in Environment Pane
#
# Whether to compute and show memory usage in the Environment Pane
.rs.uiPrefs$showMemoryUsage <- list(
   get = function() { .rs.getUserPref("show_memory_usage") },
   set = function(value) { .rs.setUserPref("show_memory_usage", value) },
   clear = function() { .rs.clearUserPref("show_memory_usage") }
)

# Interval for requerying memory stats (seconds)
#
# How many seconds to wait between automatic requeries of memory statistics (0 to
# disable)
.rs.uiPrefs$memoryQueryIntervalSeconds <- list(
   get = function() { .rs.getUserPref("memory_query_interval_seconds") },
   set = function(value) { .rs.setUserPref("memory_query_interval_seconds", value) },
   clear = function() { .rs.clearUserPref("memory_query_interval_seconds") }
)

# Enable terminal Python integration
#
# Enable Python terminal hooks. When enabled, the RStudio-configured version of
# Python will be placed on the PATH.
.rs.uiPrefs$terminalPythonIntegration <- list(
   get = function() { .rs.getUserPref("terminal_python_integration") },
   set = function(value) { .rs.setUserPref("terminal_python_integration", value) },
   clear = function() { .rs.clearUserPref("terminal_python_integration") }
)

# Session protocol debug logging
#
# Enable session protocol debug logging showing all session requests and events
.rs.uiPrefs$sessionProtocolDebug <- list(
   get = function() { .rs.getUserPref("session_protocol_debug") },
   set = function(value) { .rs.setUserPref("session_protocol_debug", value) },
   clear = function() { .rs.clearUserPref("session_protocol_debug") }
)

# Automatically activate project Python environments
#
# When enabled, if the active project contains a Python virtual environment, then
# RStudio will automatically activate this environment on startup.
.rs.uiPrefs$pythonProjectEnvironmentAutomaticActivate <- list(
   get = function() { .rs.getUserPref("python_project_environment_automatic_activate") },
   set = function(value) { .rs.setUserPref("python_project_environment_automatic_activate", value) },
   clear = function() { .rs.clearUserPref("python_project_environment_automatic_activate") }
)

# Check values in the Environment pane for null external pointers
#
# When enabled, RStudio will detect R objects containing null external pointers
# when building the Environment pane, and avoid introspecting their contents
# further.
.rs.uiPrefs$checkNullExternalPointers <- list(
   get = function() { .rs.getUserPref("check_null_external_pointers") },
   set = function(value) { .rs.setUserPref("check_null_external_pointers", value) },
   clear = function() { .rs.clearUserPref("check_null_external_pointers") }
)

# User Interface Language:
#
# The IDE's user-interface language.
.rs.uiPrefs$uiLanguage <- list(
   get = function() { .rs.getUserPref("ui_language") },
   set = function(value) { .rs.setUserPref("ui_language", value) },
   clear = function() { .rs.clearUserPref("ui_language") }
)

# Auto hide menu bar
#
# Hide desktop menu bar until Alt key is pressed.
.rs.uiPrefs$autohideMenubar <- list(
   get = function() { .rs.getUserPref("autohide_menubar") },
   set = function(value) { .rs.setUserPref("autohide_menubar", value) },
   clear = function() { .rs.clearUserPref("autohide_menubar") }
)

# Use native file and message dialog boxes
#
# Whether RStudio Desktop will use the operating system's native File and Message
# dialog boxes.
.rs.uiPrefs$nativeFileDialogs <- list(
   get = function() { .rs.getUserPref("native_file_dialogs") },
   set = function(value) { .rs.setUserPref("native_file_dialogs", value) },
   clear = function() { .rs.clearUserPref("native_file_dialogs") }
)

# Discard pending console input on error
#
# When enabled, any pending console input will be discarded when an (uncaught) R
# error occurs.
.rs.uiPrefs$discardPendingConsoleInputOnError <- list(
   get = function() { .rs.getUserPref("discard_pending_console_input_on_error") },
   set = function(value) { .rs.setUserPref("discard_pending_console_input_on_error", value) },
   clear = function() { .rs.clearUserPref("discard_pending_console_input_on_error") }
)

# Editor scroll speed sensitivity
#
# An integer value, 1-200, to set the editor scroll multiplier. The higher the
# value, the faster the scrolling.
.rs.uiPrefs$editorScrollMultiplier <- list(
   get = function() { .rs.getUserPref("editor_scroll_multiplier") },
   set = function(value) { .rs.setUserPref("editor_scroll_multiplier", value) },
   clear = function() { .rs.clearUserPref("editor_scroll_multiplier") }
)

# Text rendering
#
# Control how text is rendered within the IDE surface.
.rs.uiPrefs$textRendering <- list(
   get = function() { .rs.getUserPref("text_rendering") },
   set = function(value) { .rs.setUserPref("text_rendering", value) },
   clear = function() { .rs.clearUserPref("text_rendering") }
)

# Disable Electron accessibility support
#
# Disable Electron accessibility support.
.rs.uiPrefs$disableRendererAccessibility <- list(
   get = function() { .rs.getUserPref("disable_renderer_accessibility") },
   set = function(value) { .rs.setUserPref("disable_renderer_accessibility", value) },
   clear = function() { .rs.clearUserPref("disable_renderer_accessibility") }
)

# Enable GitHub Copilot
#
# When enabled, RStudio will use GitHub Copilot to provide code suggestions.
.rs.uiPrefs$copilotEnabled <- list(
   get = function() { .rs.getUserPref("copilot_enabled") },
   set = function(value) { .rs.setUserPref("copilot_enabled", value) },
   clear = function() { .rs.clearUserPref("copilot_enabled") }
)

# Show Copilot code suggestions:
#
# Control when Copilot code suggestions are displayed in the editor.
.rs.uiPrefs$copilotCompletionsTrigger <- list(
   get = function() { .rs.getUserPref("copilot_completions_trigger") },
   set = function(value) { .rs.setUserPref("copilot_completions_trigger", value) },
   clear = function() { .rs.clearUserPref("copilot_completions_trigger") }
)

# GitHub Copilot completions delay
#
# The delay (in milliseconds) before GitHub Copilot completions are requested
# after the cursor position has changed.
.rs.uiPrefs$copilotCompletionsDelay <- list(
   get = function() { .rs.getUserPref("copilot_completions_delay") },
   set = function(value) { .rs.setUserPref("copilot_completions_delay", value) },
   clear = function() { .rs.clearUserPref("copilot_completions_delay") }
)

# Pressing Tab key will prefer inserting:
#
# Control the behavior of the Tab key when both Copilot code suggestions and
# RStudio code completions are visible.
.rs.uiPrefs$copilotTabKeyBehavior <- list(
   get = function() { .rs.getUserPref("copilot_tab_key_behavior") },
   set = function(value) { .rs.setUserPref("copilot_tab_key_behavior", value) },
   clear = function() { .rs.clearUserPref("copilot_tab_key_behavior") }
)

# Index project files with GitHub Copilot
#
# When enabled, RStudio will index project files with GitHub Copilot.
.rs.uiPrefs$copilotIndexingEnabled <- list(
   get = function() { .rs.getUserPref("copilot_indexing_enabled") },
   set = function(value) { .rs.setUserPref("copilot_indexing_enabled", value) },
   clear = function() { .rs.clearUserPref("copilot_indexing_enabled") }
)

# 
#
# User-provided name for the currently opened R project.
.rs.uiPrefs$projectName <- list(
   get = function() { .rs.getUserPref("project_name") },
   set = function(value) { .rs.setUserPref("project_name", value) },
   clear = function() { .rs.clearUserPref("project_name") }
)

# Default working directory for background jobs
#
# Default working directory in background job dialog.
.rs.uiPrefs$runBackgroundJobDefaultWorkingDir <- list(
   get = function() { .rs.getUserPref("run_background_job_default_working_dir") },
   set = function(value) { .rs.setUserPref("run_background_job_default_working_dir", value) },
   clear = function() { .rs.clearUserPref("run_background_job_default_working_dir") }
)

# Code formatter
#
# The formatter to use when reformatting code.
.rs.uiPrefs$codeFormatter <- list(
   get = function() { .rs.getUserPref("code_formatter") },
   set = function(value) { .rs.setUserPref("code_formatter", value) },
   clear = function() { .rs.clearUserPref("code_formatter") }
)

# Use strict transformers when formatting code
#
# When set, strict transformers will be used when formatting code. See the
# `styler` package documentation for more details.
.rs.uiPrefs$codeFormatterStylerStrict <- list(
   get = function() { .rs.getUserPref("code_formatter_styler_strict") },
   set = function(value) { .rs.setUserPref("code_formatter_styler_strict", value) },
   clear = function() { .rs.clearUserPref("code_formatter_styler_strict") }
)

# 
#
# The external command to be used when reformatting code.
.rs.uiPrefs$codeFormatterExternalCommand <- list(
   get = function() { .rs.getUserPref("code_formatter_external_command") },
   set = function(value) { .rs.setUserPref("code_formatter_external_command", value) },
   clear = function() { .rs.clearUserPref("code_formatter_external_command") }
)

# Reformat documents on save
#
# When set, the selected formatter will be used to reformat documents on save.
.rs.uiPrefs$reformatOnSave <- list(
   get = function() { .rs.getUserPref("reformat_on_save") },
   set = function(value) { .rs.setUserPref("reformat_on_save", value) },
   clear = function() { .rs.clearUserPref("reformat_on_save") }
)

# Default project user data directory
#
# The folder in which RStudio should store project .Rproj.user data.
.rs.uiPrefs$projectUserDataDirectory <- list(
   get = function() { .rs.getUserPref("project_user_data_directory") },
   set = function(value) { .rs.setUserPref("project_user_data_directory", value) },
   clear = function() { .rs.clearUserPref("project_user_data_directory") }
)

#
# AppCommands.R
#
# Copyright (C) 2024 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

#
# This file was automatically generated -- please do not modify it by hand.
# Generator: src/cpp/generate-commands-accessor.R
#

.rs.setVar("appCommands", list(
   setWorkingDir = "setWorkingDir",
   switchFocusSourceConsole = "switchFocusSourceConsole",
   reformatCode = "reformatCode",
   reformatDocument = "reformatDocument",
   newSourceDoc = "newSourceDoc",
   newRNotebook = "newRNotebook",
   newTextDoc = "newTextDoc",
   newCDoc = "newCDoc",
   newCppDoc = "newCppDoc",
   newHeaderDoc = "newHeaderDoc",
   newMarkdownDoc = "newMarkdownDoc",
   newPythonDoc = "newPythonDoc",
   newShellDoc = "newShellDoc",
   newStanDoc = "newStanDoc",
   newHtmlDoc = "newHtmlDoc",
   newJavaScriptDoc = "newJavaScriptDoc",
   newCssDoc = "newCssDoc",
   newD3Doc = "newD3Doc",
   newSweaveDoc = "newSweaveDoc",
   newRMarkdownDoc = "newRMarkdownDoc",
   newQuartoDoc = "newQuartoDoc",
   newQuartoPres = "newQuartoPres",
   newRShinyApp = "newRShinyApp",
   newRHTMLDoc = "newRHTMLDoc",
   newRDocumentationDoc = "newRDocumentationDoc",
   newRPresentationDoc = "newRPresentationDoc",
   newSqlDoc = "newSqlDoc",
   newRPlumberDoc = "newRPlumberDoc",
   openSourceDoc = "openSourceDoc",
   openSourceDocNewColumn = "openSourceDocNewColumn",
   reopenSourceDocWithEncoding = "reopenSourceDocWithEncoding",
   saveSourceDoc = "saveSourceDoc",
   saveSourceDocAs = "saveSourceDocAs",
   saveSourceDocWithEncoding = "saveSourceDocWithEncoding",
   saveAllSourceDocs = "saveAllSourceDocs",
   renameSourceDoc = "renameSourceDoc",
   copySourceDocPath = "copySourceDocPath",
   closeSourceDoc = "closeSourceDoc",
   closeOtherSourceDocs = "closeOtherSourceDocs",
   closeAllSourceDocs = "closeAllSourceDocs",
   executeAllCode = "executeAllCode",
   sourceFile = "sourceFile",
   previewJS = "previewJS",
   previewSql = "previewSql",
   sourceActiveDocument = "sourceActiveDocument",
   sourceActiveDocumentWithEcho = "sourceActiveDocumentWithEcho",
   runDocumentFromServerDotR = "runDocumentFromServerDotR",
   executeCode = "executeCode",
   executeCodeWithoutMovingCursor = "executeCodeWithoutMovingCursor",
   executeCodeWithoutFocus = "executeCodeWithoutFocus",
   executeToCurrentLine = "executeToCurrentLine",
   executeFromCurrentLine = "executeFromCurrentLine",
   executeCurrentFunction = "executeCurrentFunction",
   executeCurrentSection = "executeCurrentSection",
   executeLastCode = "executeLastCode",
   executeCurrentLine = "executeCurrentLine",
   executeCurrentStatement = "executeCurrentStatement",
   executeCurrentParagraph = "executeCurrentParagraph",
   insertChunk = "insertChunk",
   insertChunkR = "insertChunkR",
   insertChunkBash = "insertChunkBash",
   insertChunkD3 = "insertChunkD3",
   insertChunkGraphViz = "insertChunkGraphViz",
   insertChunkJulia = "insertChunkJulia",
   insertChunkMermaid = "insertChunkMermaid",
   insertChunkPython = "insertChunkPython",
   insertChunkRCPP = "insertChunkRCPP",
   insertChunkStan = "insertChunkStan",
   insertChunkSQL = "insertChunkSQL",
   switchToChunkR = "switchToChunkR",
   switchToChunkBash = "switchToChunkBash",
   switchToChunkPython = "switchToChunkPython",
   switchToChunkRCPP = "switchToChunkRCPP",
   switchToChunkStan = "switchToChunkStan",
   switchToChunkSQL = "switchToChunkSQL",
   insertSection = "insertSection",
   executePreviousChunks = "executePreviousChunks",
   executeSubsequentChunks = "executeSubsequentChunks",
   executeCurrentChunk = "executeCurrentChunk",
   executeNextChunk = "executeNextChunk",
   executeSetupChunk = "executeSetupChunk",
   goToHelp = "goToHelp",
   goToDefinition = "goToDefinition",
   sourceNavigateBack = "sourceNavigateBack",
   sourceNavigateForward = "sourceNavigateForward",
   markdownHelp = "markdownHelp",
   openRStudioIDECheatSheet = "openRStudioIDECheatSheet",
   openDataVisualizationCheatSheet = "openDataVisualizationCheatSheet",
   openDataImportCheatSheet = "openDataImportCheatSheet",
   openPackageDevelopmentCheatSheet = "openPackageDevelopmentCheatSheet",
   openDataWranglingCheatSheet = "openDataWranglingCheatSheet",
   openDataTransformationCheatSheet = "openDataTransformationCheatSheet",
   openRMarkdownCheatSheet = "openRMarkdownCheatSheet",
   openRMarkdownReferenceGuide = "openRMarkdownReferenceGuide",
   openShinyCheatSheet = "openShinyCheatSheet",
   openRoxygenQuickReference = "openRoxygenQuickReference",
   openSparklyrCheatSheet = "openSparklyrCheatSheet",
   openPurrrCheatSheet = "openPurrrCheatSheet",
   browseCheatSheets = "browseCheatSheets",
   toggleRmdVisualMode = "toggleRmdVisualMode",
   enableProsemirrorDevTools = "enableProsemirrorDevTools",
   quartoRenderDocument = "quartoRenderDocument",
   knitDocument = "knitDocument",
   previewHTML = "previewHTML",
   publishHTML = "publishHTML",
   compilePDF = "compilePDF",
   compileNotebook = "compileNotebook",
   synctexSearch = "synctexSearch",
   activateSource = "activateSource",
   layoutZoomSource = "layoutZoomSource",
   printSourceDoc = "printSourceDoc",
   vcsFileLog = "vcsFileLog",
   vcsFileDiff = "vcsFileDiff",
   vcsFileRevert = "vcsFileRevert",
   popoutDoc = "popoutDoc",
   returnDocToMain = "returnDocToMain",
   quickAddNext = "quickAddNext",
   findReplace = "findReplace",
   findNext = "findNext",
   findPrevious = "findPrevious",
   findSelectAll = "findSelectAll",
   findFromSelection = "findFromSelection",
   findAll = "findAll",
   replaceAndFind = "replaceAndFind",
   findInFiles = "findInFiles",
   refreshFindInFiles = "refreshFindInFiles",
   newSourceColumn = "newSourceColumn",
   fold = "fold",
   unfold = "unfold",
   foldAll = "foldAll",
   unfoldAll = "unfoldAll",
   jumpToMatching = "jumpToMatching",
   selectToMatching = "selectToMatching",
   expandToMatching = "expandToMatching",
   addCursorAbove = "addCursorAbove",
   addCursorBelow = "addCursorBelow",
   moveLinesUp = "moveLinesUp",
   moveLinesDown = "moveLinesDown",
   expandToLine = "expandToLine",
   copyLinesDown = "copyLinesDown",
   joinLines = "joinLines",
   removeLine = "removeLine",
   splitIntoLines = "splitIntoLines",
   editLinesFromStart = "editLinesFromStart",
   toggleDocumentOutline = "toggleDocumentOutline",
   expandSelection = "expandSelection",
   shrinkSelection = "shrinkSelection",
   goToNextSection = "goToNextSection",
   goToPrevSection = "goToPrevSection",
   goToNextChunk = "goToNextChunk",
   goToPrevChunk = "goToPrevChunk",
   goToStartOfCurrentScope = "goToStartOfCurrentScope",
   goToEndOfCurrentScope = "goToEndOfCurrentScope",
   expandRaggedSelection = "expandRaggedSelection",
   extractFunction = "extractFunction",
   extractLocalVariable = "extractLocalVariable",
   commentUncomment = "commentUncomment",
   blockIndent = "blockIndent",
   blockOutdent = "blockOutdent",
   reindent = "reindent",
   reflowComment = "reflowComment",
   setWorkingDirToActiveDoc = "setWorkingDirToActiveDoc",
   codeCompletion = "codeCompletion",
   findUsages = "findUsages",
   editRmdFormatOptions = "editRmdFormatOptions",
   knitWithParameters = "knitWithParameters",
   clearKnitrCache = "clearKnitrCache",
   clearPrerenderedOutput = "clearPrerenderedOutput",
   notebookExpandAllOutput = "notebookExpandAllOutput",
   notebookCollapseAllOutput = "notebookCollapseAllOutput",
   notebookClearOutput = "notebookClearOutput",
   notebookClearAllOutput = "notebookClearAllOutput",
   notebookToggleExpansion = "notebookToggleExpansion",
   renameInScope = "renameInScope",
   insertRoxygenSkeleton = "insertRoxygenSkeleton",
   insertSnippet = "insertSnippet",
   yankRegion = "yankRegion",
   yankBeforeCursor = "yankBeforeCursor",
   yankAfterCursor = "yankAfterCursor",
   pasteLastYank = "pasteLastYank",
   insertAssignmentOperator = "insertAssignmentOperator",
   insertPipeOperator = "insertPipeOperator",
   openNextFileOnFilesystem = "openNextFileOnFilesystem",
   openPreviousFileOnFilesystem = "openPreviousFileOnFilesystem",
   toggleSoftWrapMode = "toggleSoftWrapMode",
   toggleRainbowParens = "toggleRainbowParens",
   toggleRainbowFencedDivs = "toggleRainbowFencedDivs",
   newProject = "newProject",
   newProjectFromTemplate = "newProjectFromTemplate",
   openProject = "openProject",
   openProjectInNewWindow = "openProjectInNewWindow",
   shareProject = "shareProject",
   openSharedProject = "openSharedProject",
   projectMru0 = "projectMru0",
   projectMru1 = "projectMru1",
   projectMru2 = "projectMru2",
   projectMru3 = "projectMru3",
   projectMru4 = "projectMru4",
   projectMru5 = "projectMru5",
   projectMru6 = "projectMru6",
   projectMru7 = "projectMru7",
   projectMru8 = "projectMru8",
   projectMru9 = "projectMru9",
   projectMru10 = "projectMru10",
   projectMru11 = "projectMru11",
   projectMru12 = "projectMru12",
   projectMru13 = "projectMru13",
   projectMru14 = "projectMru14",
   clearRecentProjects = "clearRecentProjects",
   closeProject = "closeProject",
   projectOptions = "projectOptions",
   projectSweaveOptions = "projectSweaveOptions",
   setWorkingDirToProjectDir = "setWorkingDirToProjectDir",
   consoleClear = "consoleClear",
   interruptR = "interruptR",
   restartR = "restartR",
   restartRClearOutput = "restartRClearOutput",
   restartRRunAllChunks = "restartRRunAllChunks",
   terminateR = "terminateR",
   activateConsole = "activateConsole",
   activateConsolePane = "activateConsolePane",
   layoutZoomConsole = "layoutZoomConsole",
   layoutZoomConsolePane = "layoutZoomConsolePane",
   activateConsolePanePane = "activateConsolePanePane",
   consoleActivateR = "consoleActivateR",
   consoleActivatePython = "consoleActivatePython",
   newFolder = "newFolder",
   touchSourceDoc = "touchSourceDoc",
   touchTextDoc = "touchTextDoc",
   touchCDoc = "touchCDoc",
   touchCppDoc = "touchCppDoc",
   touchHeaderDoc = "touchHeaderDoc",
   touchMarkdownDoc = "touchMarkdownDoc",
   touchPythonDoc = "touchPythonDoc",
   touchShellDoc = "touchShellDoc",
   touchStanDoc = "touchStanDoc",
   touchHtmlDoc = "touchHtmlDoc",
   touchJavaScriptDoc = "touchJavaScriptDoc",
   touchCssDoc = "touchCssDoc",
   touchD3Doc = "touchD3Doc",
   touchSweaveDoc = "touchSweaveDoc",
   touchRMarkdownDoc = "touchRMarkdownDoc",
   touchQuartoDoc = "touchQuartoDoc",
   touchRShinyApp = "touchRShinyApp",
   touchRHTMLDoc = "touchRHTMLDoc",
   touchSqlDoc = "touchSqlDoc",
   uploadFile = "uploadFile",
   copyFile = "copyFile",
   copyFileTo = "copyFileTo",
   moveFiles = "moveFiles",
   exportFiles = "exportFiles",
   renameFile = "renameFile",
   deleteFiles = "deleteFiles",
   refreshFiles = "refreshFiles",
   activateFiles = "activateFiles",
   layoutZoomFiles = "layoutZoomFiles",
   goToWorkingDir = "goToWorkingDir",
   setAsWorkingDir = "setAsWorkingDir",
   copyFilesPaneCurrentDirectory = "copyFilesPaneCurrentDirectory",
   openFilesInSinglePane = "openFilesInSinglePane",
   openEachFileInColumns = "openEachFileInColumns",
   setWorkingDirToFilesPane = "setWorkingDirToFilesPane",
   showFolder = "showFolder",
   vcsDiff = "vcsDiff",
   vcsCommit = "vcsCommit",
   vcsRevert = "vcsRevert",
   vcsViewOnGitHub = "vcsViewOnGitHub",
   vcsBlameOnGitHub = "vcsBlameOnGitHub",
   vcsShowHistory = "vcsShowHistory",
   vcsRefresh = "vcsRefresh",
   vcsRefreshNoError = "vcsRefreshNoError",
   vcsOpen = "vcsOpen",
   vcsIgnore = "vcsIgnore",
   vcsPull = "vcsPull",
   vcsPullRebase = "vcsPullRebase",
   vcsPush = "vcsPush",
   vcsCleanup = "vcsCleanup",
   vcsAddFiles = "vcsAddFiles",
   vcsRemoveFiles = "vcsRemoveFiles",
   activateVcs = "activateVcs",
   layoutZoomVcs = "layoutZoomVcs",
   vcsResolve = "vcsResolve",
   showPdfExternal = "showPdfExternal",
   openHtmlExternal = "openHtmlExternal",
   saveHtmlPreviewAsLocalFile = "saveHtmlPreviewAsLocalFile",
   saveHtmlPreviewAs = "saveHtmlPreviewAs",
   refreshHtmlPreview = "refreshHtmlPreview",
   showHtmlPreviewLog = "showHtmlPreviewLog",
   refreshPresentation = "refreshPresentation",
   presentationFullscreen = "presentationFullscreen",
   presentationHome = "presentationHome",
   presentationNext = "presentationNext",
   presentationPrev = "presentationPrev",
   presentationEdit = "presentationEdit",
   presentationViewInBrowser = "presentationViewInBrowser",
   presentationSaveAsStandalone = "presentationSaveAsStandalone",
   clearPresentationCache = "clearPresentationCache",
   activatePresentation2 = "activatePresentation2",
   layoutZoomPresentation2 = "layoutZoomPresentation2",
   presentation2Home = "presentation2Home",
   presentation2Next = "presentation2Next",
   presentation2Prev = "presentation2Prev",
   presentation2Edit = "presentation2Edit",
   presentation2Present = "presentation2Present",
   presentation2PresentFromBeginning = "presentation2PresentFromBeginning",
   presentation2Print = "presentation2Print",
   refreshPresentation2 = "refreshPresentation2",
   showToolbar = "showToolbar",
   hideToolbar = "hideToolbar",
   toggleToolbar = "toggleToolbar",
   zoomActualSize = "zoomActualSize",
   zoomIn = "zoomIn",
   zoomOut = "zoomOut",
   jumpTo = "jumpTo",
   goToFileFunction = "goToFileFunction",
   switchToTab = "switchToTab",
   previousTab = "previousTab",
   nextTab = "nextTab",
   firstTab = "firstTab",
   lastTab = "lastTab",
   goToLine = "goToLine",
   toggleFullScreen = "toggleFullScreen",
   moveTabLeft = "moveTabLeft",
   moveTabRight = "moveTabRight",
   moveTabToFirst = "moveTabToFirst",
   moveTabToLast = "moveTabToLast",
   activatePresentation = "activatePresentation",
   activateCompilePDF = "activateCompilePDF",
   activateFindInFiles = "activateFindInFiles",
   activateSourceCpp = "activateSourceCpp",
   activateRMarkdown = "activateRMarkdown",
   activateDeployContent = "activateDeployContent",
   activateMarkers = "activateMarkers",
   activateSQLResults = "activateSQLResults",
   activateDatabricks = "activateDatabricks",
   historySendToSource = "historySendToSource",
   historySendToConsole = "historySendToConsole",
   searchHistory = "searchHistory",
   loadHistory = "loadHistory",
   saveHistory = "saveHistory",
   historyRemoveEntries = "historyRemoveEntries",
   clearHistory = "clearHistory",
   historyDismissResults = "historyDismissResults",
   historyShowContext = "historyShowContext",
   historyDismissContext = "historyDismissContext",
   activateHistory = "activateHistory",
   layoutZoomHistory = "layoutZoomHistory",
   activateConnections = "activateConnections",
   layoutZoomConnections = "layoutZoomConnections",
   clearWorkspace = "clearWorkspace",
   refreshWorkspace = "refreshWorkspace",
   saveWorkspace = "saveWorkspace",
   loadWorkspace = "loadWorkspace",
   importDatasetFromFile = "importDatasetFromFile",
   importDatasetFromURL = "importDatasetFromURL",
   importDatasetFromCsv = "importDatasetFromCsv",
   importDatasetFromCsvUsingReadr = "importDatasetFromCsvUsingReadr",
   importDatasetFromCsvUsingBase = "importDatasetFromCsvUsingBase",
   importDatasetFromSAV = "importDatasetFromSAV",
   importDatasetFromSAS = "importDatasetFromSAS",
   importDatasetFromStata = "importDatasetFromStata",
   importDatasetFromXLS = "importDatasetFromXLS",
   activateEnvironment = "activateEnvironment",
   layoutZoomEnvironment = "layoutZoomEnvironment",
   refreshEnvironment = "refreshEnvironment",
   freeUnusedMemory = "freeUnusedMemory",
   toggleShowMemoryUsage = "toggleShowMemoryUsage",
   showMemoryUsageReport = "showMemoryUsageReport",
   nextPlot = "nextPlot",
   previousPlot = "previousPlot",
   savePlotAsImage = "savePlotAsImage",
   savePlotAsPdf = "savePlotAsPdf",
   copyPlotToClipboard = "copyPlotToClipboard",
   zoomPlot = "zoomPlot",
   removePlot = "removePlot",
   clearPlots = "clearPlots",
   refreshPlot = "refreshPlot",
   activatePlots = "activatePlots",
   layoutZoomPlots = "layoutZoomPlots",
   showManipulator = "showManipulator",
   installPackage = "installPackage",
   updatePackages = "updatePackages",
   refreshPackages = "refreshPackages",
   activatePackages = "activatePackages",
   layoutZoomPackages = "layoutZoomPackages",
   packratBootstrap = "packratBootstrap",
   packratOptions = "packratOptions",
   packratBundle = "packratBundle",
   packratHelp = "packratHelp",
   packratClean = "packratClean",
   packratCheckStatus = "packratCheckStatus",
   renvHelp = "renvHelp",
   renvSnapshot = "renvSnapshot",
   renvRestore = "renvRestore",
   versionControlHelp = "versionControlHelp",
   versionControlShowRsaKey = "versionControlShowRsaKey",
   versionControlProjectSetup = "versionControlProjectSetup",
   showProfiler = "showProfiler",
   startProfiler = "startProfiler",
   stopProfiler = "stopProfiler",
   profileCode = "profileCode",
   profileCodeWithoutFocus = "profileCodeWithoutFocus",
   saveProfileAs = "saveProfileAs",
   openProfile = "openProfile",
   profileHelp = "profileHelp",
   gotoProfileSource = "gotoProfileSource",
   openProfileInBrowser = "openProfileInBrowser",
   macPreferences = "macPreferences",
   showOptions = "showOptions",
   showCodeOptions = "showCodeOptions",
   showConsoleOptions = "showConsoleOptions",
   showAppearanceOptions = "showAppearanceOptions",
   showPackagesOptions = "showPackagesOptions",
   showRMarkdownOptions = "showRMarkdownOptions",
   showSweaveOptions = "showSweaveOptions",
   showSpellingOptions = "showSpellingOptions",
   showVcsOptions = "showVcsOptions",
   showPublishingOptions = "showPublishingOptions",
   showPythonOptions = "showPythonOptions",
   modifyKeyboardShortcuts = "modifyKeyboardShortcuts",
   editCodeSnippets = "editCodeSnippets",
   showCommandPalette = "showCommandPalette",
   clearCommandPaletteMru = "clearCommandPaletteMru",
   newTerminal = "newTerminal",
   activateTerminal = "activateTerminal",
   renameTerminal = "renameTerminal",
   closeTerminal = "closeTerminal",
   closeAllTerminals = "closeAllTerminals",
   clearTerminalScrollbackBuffer = "clearTerminalScrollbackBuffer",
   previousTerminal = "previousTerminal",
   nextTerminal = "nextTerminal",
   showTerminalInfo = "showTerminalInfo",
   interruptTerminal = "interruptTerminal",
   sendTerminalToEditor = "sendTerminalToEditor",
   sendToTerminal = "sendToTerminal",
   showTerminalOptions = "showTerminalOptions",
   openNewTerminalAtEditorLocation = "openNewTerminalAtEditorLocation",
   openNewTerminalAtFilePaneLocation = "openNewTerminalAtFilePaneLocation",
   sendFilenameToTerminal = "sendFilenameToTerminal",
   setTerminalToCurrentDirectory = "setTerminalToCurrentDirectory",
   helpBack = "helpBack",
   helpForward = "helpForward",
   helpHome = "helpHome",
   helpSearch = "helpSearch",
   printHelp = "printHelp",
   clearHelpHistory = "clearHelpHistory",
   helpPopout = "helpPopout",
   refreshHelp = "refreshHelp",
   raiseException = "raiseException",
   raiseException2 = "raiseException2",
   activateHelp = "activateHelp",
   layoutZoomHelp = "layoutZoomHelp",
   showAboutDialog = "showAboutDialog",
   showSplashScreen = "showSplashScreen",
   copyRStudioVersion = "copyRStudioVersion",
   showLicenseDialog = "showLicenseDialog",
   checkForUpdates = "checkForUpdates",
   helpUsingRStudio = "helpUsingRStudio",
   helpKeyboardShortcuts = "helpKeyboardShortcuts",
   showRequestLog = "showRequestLog",
   logFocusedElement = "logFocusedElement",
   debugDumpContents = "debugDumpContents",
   debugImportDump = "debugImportDump",
   refreshSuperDevMode = "refreshSuperDevMode",
   viewShortcuts = "viewShortcuts",
   editUserPrefs = "editUserPrefs",
   viewAllPrefs = "viewAllPrefs",
   clearUserPrefs = "clearUserPrefs",
   activateTutorial = "activateTutorial",
   layoutZoomTutorial = "layoutZoomTutorial",
   tutorialPopout = "tutorialPopout",
   tutorialBack = "tutorialBack",
   tutorialForward = "tutorialForward",
   tutorialZoom = "tutorialZoom",
   tutorialRefresh = "tutorialRefresh",
   tutorialStop = "tutorialStop",
   tutorialHome = "tutorialHome",
   activateViewer = "activateViewer",
   layoutZoomViewer = "layoutZoomViewer",
   viewerPopout = "viewerPopout",
   viewerBack = "viewerBack",
   viewerForward = "viewerForward",
   viewerZoom = "viewerZoom",
   viewerRefresh = "viewerRefresh",
   viewerSaveAllAndRefresh = "viewerSaveAllAndRefresh",
   viewerStop = "viewerStop",
   viewerClear = "viewerClear",
   viewerClearAll = "viewerClearAll",
   viewerSaveAsImage = "viewerSaveAsImage",
   viewerSaveAsWebPage = "viewerSaveAsWebPage",
   viewerCopyToClipboard = "viewerCopyToClipboard",
   viewerEditSource = "viewerEditSource",
   newSession = "newSession",
   suspendSession = "suspendSession",
   quitSession = "quitSession",
   forceQuitSession = "forceQuitSession",
   updateCredentials = "updateCredentials",
   diagnosticsReport = "diagnosticsReport",
   openDeveloperConsole = "openDeveloperConsole",
   reloadUi = "reloadUi",
   showGpuDiagnostics = "showGpuDiagnostics",
   showA11yDiagnostics = "showA11yDiagnostics",
   showLogFiles = "showLogFiles",
   rstudioSupport = "rstudioSupport",
   rstudioCommunityForum = "rstudioCommunityForum",
   rstudioAgreement = "rstudioAgreement",
   showWarningBar = "showWarningBar",
   signOut = "signOut",
   loadServerHome = "loadServerHome",
   clearBuild = "clearBuild",
   buildAll = "buildAll",
   buildIncremental = "buildIncremental",
   buildFull = "buildFull",
   devtoolsLoadAll = "devtoolsLoadAll",
   serveQuartoSite = "serveQuartoSite",
   cleanAll = "cleanAll",
   buildSourcePackage = "buildSourcePackage",
   buildBinaryPackage = "buildBinaryPackage",
   roxygenizePackage = "roxygenizePackage",
   checkPackage = "checkPackage",
   testPackage = "testPackage",
   testTestthatFile = "testTestthatFile",
   testShinytestFile = "testShinytestFile",
   stopBuild = "stopBuild",
   buildToolsProjectSetup = "buildToolsProjectSetup",
   activateBuild = "activateBuild",
   layoutZoomBuild = "layoutZoomBuild",
   newConnection = "newConnection",
   removeConnection = "removeConnection",
   disconnectConnection = "disconnectConnection",
   refreshConnection = "refreshConnection",
   undoDummy = "undoDummy",
   redoDummy = "redoDummy",
   cutDummy = "cutDummy",
   copyDummy = "copyDummy",
   pasteDummy = "pasteDummy",
   pasteWithIndentDummy = "pasteWithIndentDummy",
   selectAllDummy = "selectAllDummy",
   mru0 = "mru0",
   mru1 = "mru1",
   mru2 = "mru2",
   mru3 = "mru3",
   mru4 = "mru4",
   mru5 = "mru5",
   mru6 = "mru6",
   mru7 = "mru7",
   mru8 = "mru8",
   mru9 = "mru9",
   mru10 = "mru10",
   mru11 = "mru11",
   mru12 = "mru12",
   mru13 = "mru13",
   mru14 = "mru14",
   clearRecentFiles = "clearRecentFiles",
   debugBreakpoint = "debugBreakpoint",
   debugClearBreakpoints = "debugClearBreakpoints",
   debugContinue = "debugContinue",
   debugStop = "debugStop",
   debugStep = "debugStep",
   debugStepInto = "debugStepInto",
   debugFinish = "debugFinish",
   debugHelp = "debugHelp",
   errorsMessage = "errorsMessage",
   errorsTraceback = "errorsTraceback",
   errorsBreak = "errorsBreak",
   showDiagnosticsActiveDocument = "showDiagnosticsActiveDocument",
   showDiagnosticsProject = "showDiagnosticsProject",
   reloadShinyApp = "reloadShinyApp",
   shinyRunInPane = "shinyRunInPane",
   shinyRunInViewer = "shinyRunInViewer",
   shinyRunInBrowser = "shinyRunInBrowser",
   shinyRecordTest = "shinyRecordTest",
   shinyRunAllTests = "shinyRunAllTests",
   shinyCompareTest = "shinyCompareTest",
   reloadPlumberAPI = "reloadPlumberAPI",
   plumberRunInPane = "plumberRunInPane",
   plumberRunInViewer = "plumberRunInViewer",
   plumberRunInBrowser = "plumberRunInBrowser",
   rsconnectDeploy = "rsconnectDeploy",
   rsconnectConfigure = "rsconnectConfigure",
   rsconnectManageAccounts = "rsconnectManageAccounts",
   browseAddins = "browseAddins",
   startJob = "startJob",
   sourceAsJob = "sourceAsJob",
   clearBackgroundJobs = "clearBackgroundJobs",
   activateBackgroundJobs = "activateBackgroundJobs",
   runSelectionAsBackgroundJob = "runSelectionAsBackgroundJob",
   startWorkbenchJob = "startWorkbenchJob",
   sourceAsWorkbenchJob = "sourceAsWorkbenchJob",
   runSelectionAsWorkbenchJob = "runSelectionAsWorkbenchJob",
   activateWorkbenchJobs = "activateWorkbenchJobs",
   sortWorkbenchJobsRecorded = "sortWorkbenchJobsRecorded",
   sortWorkbenchJobsState = "sortWorkbenchJobsState",
   checkSpelling = "checkSpelling",
   wordCount = "wordCount",
   layoutZoomCurrentPane = "layoutZoomCurrentPane",
   layoutEndZoom = "layoutEndZoom",
   layoutConsoleOnLeft = "layoutConsoleOnLeft",
   layoutConsoleOnRight = "layoutConsoleOnRight",
   paneLayout = "paneLayout",
   maximizeConsole = "maximizeConsole",
   maximizeSource = "maximizeSource",
   maximizeTabSet1 = "maximizeTabSet1",
   maximizeTabSet2 = "maximizeTabSet2",
   toggleEditorTokenInfo = "toggleEditorTokenInfo",
   layoutZoomLeftColumn = "layoutZoomLeftColumn",
   layoutZoomRightColumn = "layoutZoomRightColumn",
   focusLeftSeparator = "focusLeftSeparator",
   focusRightSeparator = "focusRightSeparator",
   focusCenterSeparator = "focusCenterSeparator",
   focusSourceColumnSeparator = "focusSourceColumnSeparator",
   showFileMenu = "showFileMenu",
   showEditMenu = "showEditMenu",
   showCodeMenu = "showCodeMenu",
   showViewMenu = "showViewMenu",
   showPlotsMenu = "showPlotsMenu",
   showSessionMenu = "showSessionMenu",
   showBuildMenu = "showBuildMenu",
   showDebugMenu = "showDebugMenu",
   showProfileMenu = "showProfileMenu",
   showToolsMenu = "showToolsMenu",
   showHelpMenu = "showHelpMenu",
   toggleScreenReaderSupport = "toggleScreenReaderSupport",
   toggleTabKeyMovesFocus = "toggleTabKeyMovesFocus",
   showAccessibilityOptions = "showAccessibilityOptions",
   focusMainToolbar = "focusMainToolbar",
   speakEditorLocation = "speakEditorLocation",
   focusConsoleOutputEnd = "focusConsoleOutputEnd",
   focusNextPane = "focusNextPane",
   focusPreviousPane = "focusPreviousPane",
   showAccessibilityHelp = "showAccessibilityHelp",
   copilotInstallAgent = "copilotInstallAgent",
   copilotDiagnostics = "copilotDiagnostics",
   copilotSignIn = "copilotSignIn",
   copilotSignOut = "copilotSignOut",
   copilotStatus = "copilotStatus",
   copilotRequestCompletions = "copilotRequestCompletions",
   copilotAcceptNextWord = "copilotAcceptNextWord",
   copilotToggleAutomaticCompletions = "copilotToggleAutomaticCompletions",
   layoutZoomDatabricks = "layoutZoomDatabricks",
   showDomElements = "showDomElements",
   showShortcutCommand = "showShortcutCommand",
   crashDesktopApplication = "crashDesktopApplication"
))

#
# SessionRSConnect.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("get_deployment_env_vars", function()
{
   # Find active .Renviron file
   environFile <- .rs.findEnvironFile()
   if (!nzchar(environFile) || !file.exists(environFile))
      return(character())
   
   # Read environment variable names from the file
   contents <- readLines(environFile, warn = FALSE)
   pattern <- "^\\s*([\\w_]+)\\s*="
   matchedLines <- grep(pattern, contents, perl = TRUE, value = TRUE)
   envVars <- gsub("\\s*=.*", "", matchedLines)
   
   # Keep only those tokens which would likely have secrets of interest
   pattern <- "(?:^|[\\b_])(?:api|key|pass|pat|secret|token)(?:$|[\\b_])"
   grep(pattern, envVars, perl = TRUE, value = TRUE, ignore.case = TRUE)
})

.rs.addJsonRpcHandler("forget_rsconnect_deployments", function(sourcePath, outputPath)
{
  # for R files, assume that the containing directory is treated as the
  # application path as opposed to the file itself
  ext <- tolower(tools::file_ext(sourcePath))
  if (identical(ext, "r"))
    sourcePath <- dirname(sourcePath)

  rsconnect::forgetDeployment(appPath = sourcePath, force = TRUE)
})

# this is a clone of 'applicationConfigDir' in the rsconnect package; we use it
# to detect the condition in which rsconnect has state but the package itself
# isn't installed.
.rs.addFunction("connectConfigDir", function(appName, subDir = NULL) {

  # get the home directory from the operating system (in case
  # the user has redefined the meaning of ~) but fault back
  # to ~ if there is no HOME variable defined
  homeDir <- Sys.getenv("HOME", unset="~")

  # determine application config dir (platform specific)
  sysName <- Sys.info()[['sysname']]
  if (identical(sysName, "Windows"))
    configDir <- Sys.getenv("APPDATA")
  else if (identical(sysName, "Darwin"))
    configDir <- file.path(homeDir, "Library/Application Support")
  else
    configDir <- Sys.getenv("XDG_CONFIG_HOME", file.path(homeDir, ".config"))

  # append the application name and optional subdir
  configDir <- file.path(configDir, "R", appName)
  if (!is.null(subDir))
    configDir <- file.path(configDir, subDir)

  # normalize path
  configDir <- normalizePath(configDir, mustWork=FALSE)

  # ensure that it exists
  if (!file.exists(configDir))
    dir.create(configDir, recursive=TRUE)

  # return it
  configDir
})

.rs.addFunction("scalarListFromFrame", function(frame)
{
   ret <- list()

   # return an empty list when no entries exist
   if (is.null(frame))
     return(ret)

   cols <- names(frame)

   # take apart the frame and compose a list of scalars from each row
   for (i in seq_len(nrow(frame))) {
      row <- lapply(cols,
                    function(col) { if (is.null(frame[i,col])) NULL
                                    else .rs.scalar(unlist(frame[i,col])) })
      names(row) <- cols
      ret[[i]] <- row
   }
   return(ret)
})

.rs.addFunction("getRSConnectDeployments", function(path, rpubsUploadId) {
   # start with an empty list
   deploymentsFrame <- data.frame(
     name = character(0),
     account = character(0),
     server = character(0),
     bundleId = character(0),
     appId = character(0),
     asStatic = logical(0),
     hostUrl = character(0),
     username = character(0),
     when = numeric(0))
   deployments <- list()
   servers <- data.frame(
     name = character(0),
     url = character(0))
   accounts <- data.frame(
     name = character(0),
     server = character(0))

   # attempt to populate the list from rsconnect; this can throw if e.g. the
   # package is not installed. in the case of any error we'll safely return
   # an empty list, or a stored RPubs upload ID if one was given (below)
   tryCatch({
     # included "orphaned" deployments; we will filter later
     deploymentsFrame <- rsconnect::deployments(appPath = path, excludeOrphaned = FALSE)
     deployments <- .rs.scalarListFromFrame(deploymentsFrame)

     # create the list of servers and accounts (for later filtering)
     servers <- rsconnect::servers()
     accounts <- rsconnect::accounts()
   }, error = function(e) { })

   # cross-reference registered servers against the list of deployments, so the
   # client knows without issuing a separate RPC which deployments don't have
   # registered servers
   if (nrow(deploymentsFrame) > 0) {
     # filter the list of servers by those that actually have accounts
     # registered
     servers <- servers[
         as.character(servers$name) %in% as.character(accounts$server),]

     # extract names and URLs from the remaining servers (include the virtual server rpubs.com)
     urls <- as.character(servers[["url"]])
     names <- c(as.character(servers[["name"]]), "rpubs.com")

     # compute whether the deployment is orphaned; note that this differs from
     # the definition of "orphaned" used by the rsconnect package in that it
     # considers only the server (not the account)
     deploymentsFrame <- cbind(deploymentsFrame, list(
       serverRegistered = as.character(deploymentsFrame[["server"]]) %in% names |
                          as.character(deploymentsFrame[["hostUrl"]]) %in% urls))

     # rebuild list with additional metadata
     deployments <- .rs.scalarListFromFrame(deploymentsFrame)
   }

   # no RPubs upload IDs to consider
   if (!is.character(rpubsUploadId) || nchar(rpubsUploadId) == 0) {
     return(deployments)
   }

   # if there's already a deployment to rpubs.com, ignore legacy deployment
   if ("rpubs.com" %in% deployments$server) {
     return(deployments)
   }

   # create a new list with the same names as the one we're about to return,
   # and populate the fields we know from RPubs. leave all others, including
   # user-defined fields, blank; this allows us to tolerate changes to the
   # deployment frame format.
   rpubsDeployment <- list()
   for (col in colnames(deploymentsFrame)) {
     if (col == "name")
       rpubsDeployment[col] = ""
     else if (col == "account")
       rpubsDeployment[col] = "rpubs"
     else if (col == "server")
       rpubsDeployment[col] = "rpubs.com"
     else if (col == "appId")
       rpubsDeployment[col] = rpubsUploadId
     else if (col == "bundleId")
       rpubsDeployment[col] = rpubsUploadId
     else if (col == "asStatic")
       rpubsDeployment[col] = TRUE
     else if (col == "when")
       rpubsDeployment[col] = 0
     else if (col == "hostUrl")
       rpubsDeployment[col] = "rpubs.com"
     else if (col == "username")
       rpubsDeployment[col] = "rpubs"
     else
       rpubsDeployment[col] = NA
   }

   # combine the deployments rsconnect knows about with the deployments we know
   # about
   c(deployments, list(.rs.scalarListFromList(rpubsDeployment)))
})

.rs.addJsonRpcHandler("get_rsconnect_account_list", function()
{
   accountList <- tryCatch(
     .rs.rsconnect.getAccountList(),
     error = function(e) NULL
   )
   
   .rs.scalarListFromFrame(accountList)
})

.rs.addFunction("rsconnect.getAccountList", function()
{
  accountList <- rsconnect::accounts()
  
  # if raw characters (older rsconnect), presume shinyapps.io
  if (is.character(accountList))
  {
    accountList <- data.frame(
      name   = accountList,
      server = "shinyapps.io"
    )
  }
  
  accountList
  
})

.rs.addJsonRpcHandler("remove_rsconnect_account", function(account, server) {
   rsconnect::removeAccount(name = account, server = server)
})

.rs.addJsonRpcHandler("get_rsconnect_app_list", function(account, server) {
   .rs.scalarListFromFrame(rsconnect::applications(account = account, server = server))
})

.rs.addJsonRpcHandler("get_rsconnect_app", function(id, account, server, hostUrl) {
  
  # retrieve application associated with these parameters
  app <- tryCatch(
    rsconnect:::getAppById(id, account, server, hostUrl),
    error = identity
  )
  
  # check for and return errors
  if (inherits(app, "error")) {
    message <- paste(conditionMessage(app), collapse = "\n")
    return(list(app = NULL, error = .rs.scalar(message)))
  }
  
  # if no such application is available, just return an empty list
  if (length(app) == 0L) {
    return(list(app = NULL, error = NULL))
  }
  
  # infer the configuration URL for this application
  app$config_url <- if (rsconnect:::isConnectServer(server)) {
    prefix <- sub("/__api__", "", hostUrl)
    paste(prefix, "connect/#/apps", app$id, sep = "/")
  } else {
    prefix <- "https://www.shinyapps.io/admin/#/applications"
    paste(prefix, app$id, sep = "/")
  }
  
  # try and get environment variables for this deployment (if available)
  app$envVars <- .rs.rsconnect.getApplicationEnvVars(
    server  = server,
    account = account,
    guid    = app$guid
  )
  
  list(
    app = .rs.scalarListFromList(app),
    error = NULL
  )

})

.rs.addJsonRpcHandler("validate_server_url", function(url) {
   # suppress output when validating server URL
   # (timeouts otherwise emitted to console)
   capture.output(serverInfo <- rsconnect:::validateServerUrl(url = url))
   .rs.scalarListFromList(serverInfo)
})

.rs.addJsonRpcHandler("get_auth_token", function(name) {
   .rs.scalarListFromList(rsconnect:::getAuthToken(server = name))
})

.rs.addJsonRpcHandler("get_user_from_token", function(url, token, privateKey) {
   user <- rsconnect:::getUserFromRawToken(serverUrl = url, token = token, privateKey = privateKey)
   .rs.scalarListFromList(user)
})

.rs.addJsonRpcHandler("register_user_token", function(serverName, accountName,
   userId, token, privateKey) {
  rsconnect:::registerUserToken(serverName = serverName, accountName = accountName, userId = userId,
                                token = token, privateKey = privateKey)
})

.rs.addJsonRpcHandler("get_rsconnect_lint_results", function(target) {
   err <- ""
   results <- NULL
   basePath <- ""

   # validate and lint the requested target
   if (!file.exists(target)) {
     err <- paste("The file or directory ", target, " does not exist.")
   } else {
     tryCatch({
       info <- file.info(target)
       if (info$isdir) {
         # a directory was specified--lint the whole thing
         basePath <- target
         results <- rsconnect::lint(project = basePath)
       } else if (tolower(tools::file_ext(target)) == "r") {
         # a single-file Shiny app--lint the directory (with file hint)
         basePath <- dirname(target)
         results <- rsconnect::lint(project = basePath, appPrimaryDoc = basename(target))
       } else {
         # a single file was specified--lint just that file
         basePath <- dirname(target)
         results <- rsconnect::lint(project = basePath, files = basename(target))
       }
    }, error = function(e) {
      err <<- e$message
    })
  }

  # empty or missing results; no need to do further work
  if (identical(length(results), 0) || !rsconnect:::hasLint(results)) {
    return(list(
      has_lint = .rs.scalar(FALSE),
      error_message = .rs.scalar(err)))
  }

  # we have a list of lint results; convert them to markers and emit them to
  # the Markers pane
  rsconnect:::showRstudioSourceMarkers(basePath = basePath, results)

  # return the result to the client
  list(
    has_lint = .rs.scalar(TRUE),
    error_message = .rs.scalar(err))
})

.rs.addFunction("docDeployList", function(target, asMultipleDoc, quartoSrcFile) {
  file_list <- c()
  target <- normalizePath(target, winslash = "/")

  # if deploying multiple documents, find all the files in the with a matching
  # extension; otherwise, just use the single document we were given
  if (asMultipleDoc) {
    targets <- list.files(path = dirname(target),
      pattern = glob2rx(paste("*", tools::file_ext(target), sep = ".")),
      ignore.case = TRUE, full.names = TRUE)
  } else {
    targets <- target
  }

  yaml <- NULL

  # check for a known encoding
  encoding <- getOption("encoding")
  properties <- .rs.getSourceDocumentProperties(target)
  if (!is.null(properties$encoding))
     encoding <- properties$encoding

  # attempt to parse yaml front matter
  yaml <- tryCatch(
     rmarkdown::yaml_front_matter(target, encoding = encoding),
     error = function(e) NULL
  )

  # if this failed, try again as UTF-8
  if (is.null(yaml) && !identical(encoding, "UTF-8"))
  {
     yaml <- tryCatch(
        rmarkdown::yaml_front_matter(target, encoding = "UTF-8"),
        error = function(e) NULL
     )
  }

  # check to see if the target has "runtime: shiny/prerendred", if so then
  # return a full directory deploy list
  if (is.list(yaml) && (identical(yaml$runtime, "shiny_prerendered") ||
                        identical(yaml$runtime, "shinyrmd") ||
                        identical(yaml$server, "shiny") ||
                        (is.list(yaml$server) && identical(yaml$server$type, "shiny"))
                       )
     )
  {
    return(rsconnect::listBundleFiles(appDir = dirname(target)))
  }

  # find the resources used by each document
  for (t in targets) {
    deploy_frame <- NULL
    tryCatch({
      # this operation can be expensive and could also throw if e.g. the
      # document fails to parse or render
      deploy_frame <- rmarkdown::find_external_resources(t)
    },
    error = function(e) {
      # errors are not fatal here; we just might miss some resources, which
      # the user will have to add manually
    })
    if (!is.null(deploy_frame)) {
      file_list <- c(file_list, deploy_frame$path)
    }
    file_list <- c(file_list, basename(t))
  }

  if (nzchar(quartoSrcFile)) {
    # query quarto for project and resources
    quartoSrcFile <- normalizePath(quartoSrcFile, winslash = "/")
    project <- .rs.quartoFileProject(quartoSrcFile)
    resources <- project$resources
    project <- project$project

    # query quarto for resources
    file_list <- c(file_list, resources)

    # per-directory option may be given in _metadata.yml
    if (file.exists(file.path(dirname(quartoSrcFile), "_metadata.yml"))) {
      file_list <- c(file_list, "_metadata.yml")
    }

    if (length(project)) {
      if (identical(project, "")) {
        file_list <- c(file_list, "_quarto.yml")
      } else {
        file_list <- c(file_list, file.path(project, "_quarto.yml"))
      }
    }
  }

  # discard any duplicates (the same resource may be depended upon by multiple
  # R Markdown documents)
  file_list <- unique(file_list)

  # compose the result
  list(
    contents = file_list,
    totalSize = sum(
       file.info(file.path(dirname(target), file_list))$size))
})

.rs.addFunction("makeDeploymentList", function(target, asMultipleDoc,
                                               quartoSrcFile, max_size) {
   ext <- tolower(tools::file_ext(target))
   if (ext %in% c("qmd", "rmd", "html", "htm", "md"))
     .rs.docDeployList(target, asMultipleDoc, quartoSrcFile)
   else
     rsconnect::listBundleFiles(appDir = target)
})

.rs.addFunction("quartoFileResources", function(target) {
   .Call("rs_quartoFileResources", target)
})

.rs.addFunction("quartoFileProject", function(target) {
   .Call("rs_quartoFileProject", basename(target), dirname(target), PACKAGE = "(embedding)")
})

# Given a list of files of the form:
#
# file2.ext
# dir/file1.ext
# dir/file2.ext
# dir/file3.ext
# dir/subdir/file4.ext
# dir2/file2.ext
#
# and a threshold, collapses all directories that contain more than the threshold
# number of files. For instance, if threshold = 2, the result from the above
# would be:
#
# file2.ext
# dir2/file2.ext
# dir/

.rs.addFunction("summarizeDir", function(files, threshold) {
  # extract the subdir using a regex
  prefixes <- regexec("^([^/])+/", files)

  # extract the matching text to form a list of top-level subdirs; skip files
  # with no prefix
  prefixes <- lapply(regmatches(x = files, m = prefixes), `[`, 1)
  prefixes[is.na(prefixes)] <- ""

  # get a list of top-level directories
  toplevel <- sort(unlist(prefixes))

  # get a count of the number of files in each top-level dir
  counts <- rle(toplevel)

  # for those dirs which have more than the threshold, hide all of the contents
  rollups <- which(counts$lengths > threshold)
  include <- rep_len(TRUE, length(files))
  for (rollup in rollups) {
    if (nzchar(counts$values[rollup]))
       include <- include & prefixes != counts$values[rollup]
  }

  # combine the files to be included with the top-level directories that were
  # rolled up
  toplevel <- counts$values[rollups]
  c(files[include], toplevel[nzchar(toplevel)])
})

.rs.addFunction("rsconnectDeployList", function(target, asMultipleDoc, quartoSrcFile) {
  max_size <- getOption("rsconnect.max.bundle.size", 1048576000)
  dirlist <- .rs.makeDeploymentList(target, asMultipleDoc, quartoSrcFile, max_size)

  list (
    # if the directory is too large, no need to bother sending a potentially
    # large blob of data to the client
    dir_list = if (dirlist$totalSize >= max_size)
                  NULL
               else
                  .rs.summarizeDir(dirlist$contents, 5),
    max_size = .rs.scalar(max_size),
    dir_size = .rs.scalar(dirlist$totalSize))
})

.rs.addFunction("enableRStudioConnectUI", function(enable) {
  .rs.enqueClientEvent("enable_rstudio_connect", enable);
  message("Posit Connect UI ", if (enable) "enabled" else "disabled", ".")
  invisible(enable)
})

.rs.addFunction("hasConnectAccount", function() {
   tryCatch({
      # check for any non-shinyapps.io accounts
      accounts <- rsconnect::accounts()
      subset(accounts, !(server %in% c("shinyapps.io", "rstudio.cloud", "posit.cloud")))
      .rs.scalar(nrow(accounts) > 0)
   }, error = function(e) { FALSE })
})


.rs.addJsonRpcHandler("get_deployment_files", function(target, asMultipleDoc, quartoSrcFile) {
  .rs.rsconnectDeployList(target, asMultipleDoc, quartoSrcFile)
})

# The parameter to this function is a string containing the R command from
# the rsconnect service; we just need to parse and execute it directly.
# The client is responsible for verifying that the statement corresponds to
# a valid ::setAccountInfo command.
.rs.addJsonRpcHandler("connect_rsconnect_account", function(accountCmd) {
   cmd <- parse(text=accountCmd)
   eval(cmd, envir = globalenv())
})


.rs.addFunction("getRmdPublishDetails", function(target, encoding) {

  # read yaml
  lines <- readLines(target, encoding = encoding, warn = FALSE)
  frontMatter <- rmarkdown:::parse_yaml_front_matter(lines)

  # if this is runtime: shiny_prerendered then is_multi_rmd is FALSE
  if (is.list(frontMatter) &&
      (identical(frontMatter$runtime, "shiny_prerendered") ||
       identical(frontMatter$runtime, "shinyrmd") ||
       identical(frontMatter$server, "shiny") ||
       (is.list(frontMatter$server) && identical(frontMatter$server$type, "shiny")))) {
    is_multi_rmd <- FALSE
  } else {
    # check for multiple R Markdown documents in the directory
    rmds <- list.files(path = dirname(target), pattern = glob2rx("*.Rmd"),
                       all.files = FALSE, recursive = FALSE, ignore.case = TRUE,
                       include.dirs = FALSE)
    is_multi_rmd <- length(rmds) > 1
  }

  # see if this format is self-contained (defaults to true for HTML-based
  # formats)
  selfContained <- TRUE
  outputFormat <- rmarkdown:::output_format_from_yaml_front_matter(lines)
  if (is.list(outputFormat$options) &&
      identical(outputFormat$options$self_contained, FALSE)) {
    selfContained <- FALSE
  }

  # extract the document's title
  title <- ""
  if (is.list(frontMatter) && is.character(frontMatter$title)) {
    title <- frontMatter$title
  }

  # check to see if this is an interactive doc (i.e. needs to be run rather
  # rather than rendered)
  renderFunction <- .rs.getCustomRenderFunction(target)

  list(
    is_multi_rmd        = .rs.scalar(is_multi_rmd),
    is_shiny_rmd        = .rs.scalar(renderFunction == "rmarkdown::run"),
    is_self_contained   = .rs.scalar(selfContained),
    title               = .rs.scalar(title),
    has_connect_account = .rs.scalar(.rs.hasConnectAccount()))
})

# indicates whether there appear to be accounts registered on the system that
# cannot be used because the rsconnect package isn't installed
.rs.addJsonRpcHandler("has_orphaned_accounts", function() {
  # get the folder in which we expect account data to exist
  accountDir <- .rs.connectConfigDir("rsconnect", "accounts")

  # if this folder doesn't exist, check the old location
  if (!file.exists(accountDir))
    accountDir <- .rs.connectConfigDir("connect", "accounts")

  # if we found a config folder, list all regular files (not directories) inside
  # it
  if (file.exists(accountDir)) {
    files <- list.files(accountDir, recursive = TRUE, include.dirs = FALSE)

    # if there are files and the rsconnect package isn't installed at all,
    # consider those files to correspond to orphaned accounts
    if (length(files) > 0 && !.rs.isPackageInstalled("rsconnect")) {
      return(.rs.scalar(length(files)))
    }
  }

  return(.rs.scalar(0))
})

.rs.addJsonRpcHandler("get_server_urls", function() {
  servers <- rsconnect::servers()

  # convert from factors if necessary
  for (col in c("name", "url")) {
    if (col %in% colnames(servers)) {
      servers[[col]] <- as.character(servers[[col]])
    }
  }
  .rs.scalarListFromFrame(servers)
})

.rs.addJsonRpcHandler("generate_app_name", function(appTitle, appPath, account) {
  name  <- ""
  valid <- TRUE
  error <- ""

  # attempt to generate a name from the title
  tryCatch({
    name <- rsconnect::generateAppName(appTitle = appTitle,
                                       appPath  = appPath,
                                       account  = account)
  }, error = function(e) {
    valid <<- FALSE
    error <<- e$message
  })

  # report result
  list(name  = .rs.scalar(name),
       valid = .rs.scalar(valid),
       error = .rs.scalar(error))
})

.rs.addFunction("rsconnect.getApplicationEnvVars", function(server, account, guid)
{
  tryCatch(
    .rs.rsconnect.getApplicationEnvVarsImpl(server, account, guid),
    error = function(e) character()
  )
})

.rs.addFunction("rsconnect.getApplicationEnvVarsImpl", function(server, account, guid)
{
  rsconnect <- asNamespace("rsconnect")
  accountDetails <- rsconnect$accountInfo(account, server)
  client <- rsconnect$clientForAccount(accountDetails)
  client$getEnvVars(guid)
})

.rs.addFunction("findEnvironFile", function()
{
   environFile <- Sys.getenv("R_ENVIRON_USER", unset = NA)
   if (!is.na(environFile))
      return(environFile)
   
   project <- .rs.getProjectDirectory()
   if (!is.null(project))
   {
      projectEnviron <- file.path(project, ".Renviron")
      if (file.exists(projectEnviron))
         return(projectEnviron)
   }
   
   userEnviron <- path.expand("~/.Renviron")
   if (file.exists(userEnviron))
      return(userEnviron)
   
   ""
})

#
# SessionCodeTools.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.addJsonRpcHandler("discover_package_dependencies", function(docId, fileType)
{
   available <- .rs.availablePackages()
   ready <- !is.null(available$value)
   packages <- .rs.discoverPackageDependencies(docId, fileType)
   list(ready = .rs.scalar(ready), packages = packages)
})

.rs.addFunction("stopf", function(fmt, ..., call. = FALSE)
{
   msg <- sprintf(fmt, ...)
   stop(msg, call. = call.)
})

.rs.addFunction("error", function(...)
{
   list(
      result  = NULL,
      message = .rs.scalar(paste(..., sep = ""))
   )
})

.rs.addFunction("success", function(result = NULL)
{
   list(
      result  = result,
      message = NULL
   )
})

.rs.addFunction("withTimeLimit", function(seconds,
                                          expr,
                                          fail = NULL)
{
   setTimeLimit(elapsed = seconds, transient = TRUE)
   on.exit(setTimeLimit(), add = TRUE)
   tryCatch(expr, error = function(e) fail)
})

.rs.addFunction("startsWith", function(strings, string)
{
   if (!length(string))
      string <- ""

   n <- nchar(string)
   (nchar(strings) >= n) & (substring(strings, 1, n) == string)
})

.rs.addFunction("selectStartsWith", function(strings, string)
{
   strings[.rs.startsWith(strings, string)]
})

.rs.addFunction("endsWith", function(strings, string)
{
   if (!length(string))
      string <- ""

   nstrings <- nchar(strings)
   nstring <- nchar(string)
   (nstrings >= nstring) &
      (substring(strings, nstrings - nstring + 1, nstrings) == string)
})

.rs.addFunction("selectEndsWith", function(strings, string)
{
   strings[.rs.endsWith(strings, string)]
})

# Return the scope names in which the given names exist
.rs.addFunction("which", function(names) {
   scopes = search()
   sapply(names, function(name) {
      for (scope in scopes) {
         if (exists(name, where=scope, inherits=F))
            return(scope)
      }
      return("")
   })
})

.rs.addFunction("surround", function(string, with)
{
   paste(with, string, with, sep = "")
})

.rs.addFunction("guessToken", function(line, cursorPos)
{
   utils:::.assignLinebuffer(line)
   utils:::.assignEnd(cursorPos)
   utils:::.guessTokenFromLine()
})

.rs.addFunction("findFunctionNamespace", function(name, fromWhere)
{
   if (!identical(fromWhere, ""))
   {
      if ( ! (fromWhere %in% search()) )
         return ("")

      where = as.environment(fromWhere)
   }
   else
   {
      where = globalenv()
   }

   envList <- methods:::findFunction(name, where = where)
   if (length(envList) > 0)
   {
      env <- envList[[1]]
      if (identical(env, baseenv()))
      {
         return ("package:base")
      }
      else if (identical(env, globalenv()))
      {
         return(".GlobalEnv")
      }
      else
      {
         envName = attr(envList[[1]], "name")
         if (!is.null(envName))
            return (envName)
         else
            return ("")
      }
   }
   else
   {
      return ("")
   }
})

.rs.addFunction("getFunction", function(name, envir = globalenv())
{
   tryCatch(
      .rs.getFunctionImpl(name, envir),
      error = function(e) NULL
   )
})

.rs.addFunction("getFunctionImpl", function(name, envir = globalenv())
{
   envir <- .rs.resolveEnvironment(envir)
   parsed <- parse(text = name)[[1L]]

   # for plain symbols, we can attempt lookup of a function object
   # directly; for more complex calls, we try to evaluate it in
   # the requested environment and hope we got a function
   fn <- if (is.symbol(parsed))
      get(name, envir = envir, mode = "function")
   else
      eval(parsed, envir = envir)

   if (!is.function(fn))
      return(NULL)

   fn
})


.rs.addFunction("functionHasSrcRef", function(func)
{
   !is.null(attr(func, "srcref"))
})

.rs.addFunction("parseSrcref", function(srcref)
{
   srcref <- as.list(unclass(srcref))
   
   # From ?srcref:
   #
   # Bytes (elements 2, 4) and columns (elements 5, 6) may be different due to
   # multibyte characters. If only four values are given, the columns and bytes
   # are assumed to match. Lines (elements 1, 3) and parsed lines (elements 7,
   # 8) may differ if a #line directive is used in code: the former will respect
   # the directive, the latter will just count lines. If only 4 or 6 elements
   # are given, the parsed lines will be assumed to match the lines.
   srcref <- if (length(srcref) == 4L)
   {
      c(srcref, srcref[c(2L, 4L, 1L, 3L)])
   }
   else if (length(srcref) == 6L)
   {
      c(srcref, srcref[c(1L, 3L)])
   }
   else
   {
      srcref
   }
   
   names(srcref) <- c(
      "first_line", "first_byte",
      "last_line", "last_byte",
      "first_column", "last_column",
      "first_parsed", "last_parsed"
   )
   
   as.list(srcref)
})

.rs.addFunction("readSrcrefLines", function(srcref, asString)
{
   # Try to retrieve source references from srcfile if available
   srcfile <- attr(srcref, "srcfile", exact = TRUE)
   filename <- srcfile$filename
   if (!is.null(srcfile$original))
      srcfile <- srcfile$original
   
   # It appears the 'lines' variable can either be a single string
   # with embedded newlines, or a character vector already split by newlines.
   # Normalize here so that we're always working with a split-by-newline vector.
   lines <- srcfile$lines
   if (length(lines) == 1L && grepl("\n", lines[[1L]], fixed = TRUE))
      lines <- unlist(strsplit(lines, "\n", fixed = TRUE))
   
   # For packages installed with '--with-keep.source', it appears that
   # the source references for all files within the package are collected
   # into a single file, with each file given a header of the form:
   #
   #    #line 1 "<filename>"
   #
   # The source references are given relative to those file contents,
   # so try to pull out the text content of only that file.
   #
   # In theory, R supports referencing arbitrary lines within a file;
   # in practice, whole files appear to be included?
   #
   # https://github.com/wch/r-source/blob/1bd4a842dac421b68b7a999de8342f131ce8387f/src/library/tools/src/install.c#L158-L159
   #
   if (length(filename) && nzchar(filename))
   {
      header <- sprintf("#line 1 \"%s\"", filename)
      index <- which(lines == header)
      if (length(index))
      {
         lines <- tail(lines, n = -index)
         boundaries <- c(
            grep("^#line 1 \"", lines),
            length(lines) + 1L
         )
         lines <- head(lines, n = boundaries[[1L]] - 1)
      }
   }
   
   if (asString)
      paste(lines, collapse = "\n")
   else
      lines
})

.rs.addFunction("deparseSrcref", function(srcref, asString)
{
   # Try to retrieve source references from srcfile if available
   srcfile <- attr(srcref, "srcfile", exact = TRUE)
   if (!is.null(srcfile$original))
      srcfile <- srcfile$original
   
   # It appears the 'lines' variable can either be a single string
   # with embedded newlines, or a character vector already split by newlines.
   # Normalize here so that we're always working with a split-by-newline vector.
   lines <- srcfile$lines
   if (length(lines) == 1L && grepl("\n", lines[[1L]], fixed = TRUE))
      lines <- unlist(strsplit(lines, "\n", fixed = TRUE))
   
   # We previously used 'as.character(srcref, useSource = TRUE)' by default, but
   # this also trims the leading indent from the function definition. This
   # causes issues when highlighting the first part of a source reference, as
   # the expectation here is that the full line is preserved. For that reason,
   # if we're able to, we keep all relevant lines from the source reference.
   code <- if (is.character(lines))
   {
      srcpos <- .rs.parseSrcref(srcref)
      range <- if (inherits(srcfile, c("srcfilecopy", "srcfilealias")))
      {
         seq(from = srcpos$first_parsed, to = srcpos$last_parsed)
      }
      else
      {
         seq(from = srcpos$first_line, to = srcpos$last_line)
      }

      lines[range]
   }
   else
   {
      as.character(srcref, useSource = TRUE)
   }
   
   if (asString)
   {
      code <- paste(code, collapse = "\n")
   }
   
   code
})

# Returns a function's code as a string. Arguments:
# useSource -- Whether to use the function's source references (if available)
# asString -- Whether to return the result as a single string
#             (otherwise a character vector of lines is returned)
.rs.addFunction("deparseFunction", function(func, useSource, asString)
{
   # If we're being asked to return the source references as-is, read the source
   # references directly instead of going through deparse (which has a known
   # issue that corrupts output with backslashes in R 4.0.0 and perhaps other
   # versions; see R bug 17800).
   if (useSource)
   {
      srcref <- attr(func, "srcref", exact = TRUE)
      if (!is.null(srcref))
         return(.rs.deparseSrcref(srcref, asString))
   }

   control <- c("keepInteger", "keepNA")
   if (useSource)
     control <- append(control, "useSource")

   code <- deparse(func, width.cutoff = 59, control = control)

   # if we were asked not to use source refs, or we were but there wasn't a
   # source ref to use, then format the code according to user pref
   if (!useSource || is.null(attr(func, "srcref", exact = TRUE)))
   {
     replaceText <- "\t"

     # determine the replacement text based on the user's current editing
     # preferences
     if (isTRUE(.rs.readUiPref("use_spaces_for_tab")))
     {
       replaceText <- paste(rep(" ", .rs.readUiPref("num_spaces_for_tab")),
                                collapse = "")
     }

     # split the code into individual lines -- R's immutable strings make it
     # quicker to process these small chunks than on the whole code text
     lines <- unlist(strsplit(code, "\n", fixed = TRUE))
     for (l in seq_along(lines))
     {
       line <- lines[[l]]
       pos <- 1
       # convert up to 20 indentation levels per line
       for (lvl in seq_len(20))
       {
         # NOTE: the 4 spaces comes from the implementation of printtab2buff in
         # deparse.c -- it is hard-coded to use 4 spaces for the first 4 levels
         # of indentation and then 2 spaces for subsequent levels.
         indent <- if (lvl <= 4) "    " else "  "
         if (substring(line, pos, pos + (nchar(indent) - 1)) == indent)
         {
           # convert this indent to the user's preferred indentation
           line <- paste(substring(line, 0, pos - 1),
                         replaceText,
                         substring(line, pos + nchar(indent)),
                         sep = "")
           pos <- pos + nchar(replaceText)
         }
         else
         {
           # no more indents we want to convert on this line
           break
         }
       }
       lines[[l]] <- line
     }

     # if we were asked to return individual lines, we're done now
     if (!asString)
       return(lines)
     else
       code <- lines
   }

   # return (possibly formatted) code
   if (asString)
     paste(code, collapse = "\n")
   else
     code
})

.rs.addFunction("isS3Generic", function(object)
{
   if (!is.function(object))
      return(FALSE)

   if (inherits(object, "groupGenericFunction"))
      return(TRUE)

   .rs.callsUseMethod(body(object))

})

.rs.addFunction("callsUseMethod", function(x)
{
   if (missing(x))
      return(FALSE)

   if (!is.call(x))
      return(FALSE)

   if (identical(x[[1]], quote(UseMethod)))
      return(TRUE)

   if (length(x) == 1)
      return(FALSE)

   for (arg in as.list(x[-1]))
      if (.rs.callsUseMethod(arg))
         return(TRUE)

   FALSE
})

.rs.addFunction("getUseMethodGeneric", function(x)
{
   if (is.function(x))
      x <- body(x)

   if (!is.call(x))
      return(NULL)

   UseMethod <- as.name("UseMethod")
   generic <- NULL
   .rs.recursiveSearch(x, function(node) {

      if (!is.call(node) || length(node) < 2 || length(node) > 3)
         return(FALSE)

      lhs <- node[[1]]
      if (!identical(lhs, UseMethod))
         return(FALSE)

      matched <- tryCatch(
         match.call(function(generic, object) {}, node),
         error = function(e) NULL
      )

      if (is.character(matched[["generic"]]))
      {
         generic <<- matched[["generic"]]
         return(TRUE)
      }

      FALSE
   })

   generic
})

.rs.addFunction("getS3MethodDefinitions", function(generic)
{
   if (is.function(generic))
      generic <- .rs.getUseMethodGeneric(generic)

   if (!is.character(generic))
      return(NULL)

   call <- substitute(
      methods(generic),
      list(generic = generic)
   )

   methods <- .rs.tryCatch(eval(call, envir = globalenv()))
   if (inherits(methods, "error"))
      return(NULL)
      
   info <- attr(methods, "info")
   if (!is.data.frame(info))
      return(NULL)

   defns <- lapply(seq_len(nrow(info)), function(i) {
      method <- rownames(info)[[i]]
      generic <- info$generic[[i]]
      class <- substring(method, nchar(generic) + 2)

      call <- substitute(
         utils::getS3method(generic, class, optional = TRUE),
         list(generic = generic, class = class)
      )

      eval(call, envir = globalenv())
   })

   names(defns) <- rownames(info)
   defns
})

.rs.addFunction("getS3MethodsForFunction", function(func, envir = parent.frame())
{
  tryCatch({
     call <- call("methods", func)
     as.character(suppressWarnings(eval(call, envir = envir)))
  }, error = function(e) character())
})


# Return a list of S4 methods formatted as  functionName {className, className}
# NOTE: should call isGeneric prior to calling this (it will yield an error
# for functions that aren't generic)
.rs.addFunction("getS4MethodsForFunction", function(func)
{
  sigs <- findMethodSignatures(methods = findMethods(func))
  apply(sigs,
        1,
        function(sig)
        {
           paste(func,
                 " {",
                 paste(sig, collapse=", "),
                 "}",
                 sep="",
                 collapse = "")
        })
})

.rs.addFunction("getS4MethodNamespaceName", function(method)
{
  env <- environment(method)
  if (identical(env, baseenv()))
    return ("package:base")
  else if (identical(env, globalenv()))
    return (".GlobalEnv")
  else
  {
    envName <- environmentName(env)
    if (envName %in% search())
      return (envName)
    else
      paste("package:", envName, sep="")
  }
})

.rs.addFunction("getPendingInput", function()
{
   .Call("rs_getPendingInput")
})

.rs.addFunction("doStripSurrounding", function(string, complements)
{
   result <- gsub("^\\s*([`'\"])(.*?)\\1.*", "\\2", string, perl = TRUE)
   for (item in complements)
   {
      result <- sub(
         paste("^\\", item[[1]], "(.*)\\", item[[2]], "$", sep = ""),
         "\\1",
         result,
         perl = TRUE
      )
   }
   result

})

.rs.addFunction("stripSurrounding", function(string)
{
   complements <- list(
      c("(", ")"),
      c("{", "}"),
      c("[", "]"),
      c("<", ">")
   )

   result <- .rs.doStripSurrounding(string, complements)
   while (result != string)
   {
      string <- result
      result <- .rs.doStripSurrounding(string, complements)
   }
   result
})

.rs.addFunction("resolveObjectSource", function(object, envir)
{
   # Try to find the associated namespace of the object
   namespace <- NULL
   if (is.primitive(object))
      namespace <- "base"
   else if (is.function(object))
   {
      envString <- capture.output(environment(object))[1]
      match <- regexpr("<environment: namespace:(.*)>", envString, perl = TRUE)
      if (match == -1L)
         return()

      start <- attr(match, "capture.start")[1]
      end <- start + attr(match, "capture.length")[1]
      namespace <- substring(envString, start, end - 1)
   }
   else if (isS4(object))
      namespace <- attr(class(object), "package")

   if (is.null(namespace))
      return()

   # Get objects from that namespace
   ns <- asNamespace(namespace)
   objectNames <- objects(ns, all.names = TRUE)
   objects <- tryCatch(
      mget(objectNames, envir = ns),
      error = function(e) NULL
   )

   if (is.null(objects))
      return()

   # Find which object is actually identical to the one we have
   success <- FALSE
   for (i in seq_along(objects))
   {
      if (identical(object, objects[[i]], ignore.environment = TRUE))
      {
         success <- TRUE
         break
      }
   }

   # Use that name for the help lookup
   if (success)
      return(list(
         name = objectNames[[i]],
         package = namespace
      ))

})

.rs.addFunction("resolveAliasedSymbol", function(object)
{
   if (!is.function(object))
      return(object)

   if (is.primitive(object))
      return(object)

   body <- body(object)
   if (is.symbol(body))
     return(object)

   env <- environment(object)
   if (length(body) && .rs.isSymbolCalled(body[[1]], ".rs.callAs"))
      return(env$original)

   return(object)
})

.rs.addFunction("getAnywhere", function(name, envir = parent.frame())
{
   result <- NULL

   if (!length(name))
      return(NULL)

   if (is.character(name) && (length(name) != 1 || name == ""))
      return(NULL)

   # Don't evaluate any functions -- skip any 'name' that contains a paren
   if (is.character(name) && regexpr("(", name, fixed = TRUE) > 0)
      return(FALSE)

   # Helper function for evaluating an expression with warnings + messages
   # suppressed, and errors coerced to NULL
   quietly <- function(expr) {
      withCallingHandlers(
         tryCatch(expr, error = function(e) NULL),
         warning = function(e) invokeRestart("muffleWarning"),
         message = function(e) invokeRestart("muffleMessage")
      )
   }

   if (is.character(name) && is.character(envir))
   {
      # If envir is the name of something on the search path, get it from there
      pos <- match(envir, search(), nomatch = -1L)
      if (pos >= 0)
      {
         object <- quietly(get(name, pos = pos))
         if (!is.null(object))
            return(.rs.resolveAliasedSymbol(object))
      }

      # Otherwise, maybe envir is the name of a package -- search there
      if (envir %in% loadedNamespaces())
      {
         object <- quietly(get(name, envir = asNamespace(envir)))
         if (!is.null(object))
            return(.rs.resolveAliasedSymbol(object))
      }
   }

   if (is.character(name))
   {
      name <- quietly(parse(text = .rs.stripSurrounding(name)))
      if (is.null(name))
         return(NULL)
   }

   if (is.language(name))
      result <- quietly(eval(name, envir = envir))

   .rs.resolveAliasedSymbol(result)

})

.rs.addFunction("getFunctionArgumentNames", function(object)
{
   # for primitive objects, 'args()' can be used to extract
   # a function object with compatible prototype -- although
   # primitive functions that power control flow (e.g. `if()`,
   # `return()` can return NULL)
   if (is.primitive(object))
      object <- args(object)

   result <- character()
   if (is.function(object))
      result <- names(formals(object))

   result
})

.rs.addFunction("getNames", function(object)
{
   tryCatch(
      .rs.getNamesImpl(object),
      error = function(e) NULL
   )
})

.rs.addFunction("getNamesImpl", function(object)
{
   names <- if (is.environment(object) && !inherits(object, "R6"))
      ls(object, all.names = TRUE)
   else if (inherits(object, "tbl") && "dplyr" %in% loadedNamespaces())
      dplyr::tbl_vars(object)
   
   # For some reason, `jobjRef` objects (from rJava) return names containing
   # parentheses after the associated function call, which confuses our completion
   # system.
   else if (inherits(object, "jobjRef"))
      return(gsub("[\\(\\)]", "", names(object)))
   else
      names(object)
   
   meta <- if (!inherits(object, "tbl_sql"))
   {
      if (is.environment(object) && is.character(names))
      {
         vapply(names, function(name)
         {
            if (bindingIsActive(name, object))
            {
               ""
            }
            else
            {
               label <- attr(object[[name]], "label", exact = TRUE)
               .rs.nullCoalesce(label, "")
            }
         }, FUN.VALUE = character(1))
      }
      else
      {
         vapply(object, function(value)
         {
            label <- attr(value, "label", exact = TRUE)
            .rs.nullCoalesce(label, "")
         }, FUN.VALUE = character(1))
      }
   }
   
   attr(names, "meta") <- unname(meta)
   names
})

.rs.addJsonRpcHandler("get_help_at_cursor", function(line, cursorPos)
{
   token <- .rs.guessToken(line, cursorPos)
   if (token == '')
      return()

   pieces <- strsplit(token, ':{2,3}')[[1]]

   # use devtools shim for help if available
   if ("devtools_shims" %in% search() &&
       "devtools" %in% loadedNamespaces() &&
       exists("shim_help", envir = asNamespace("devtools")))
   {
      help <- devtools:::shim_help
   }
   else
   {
      help <- utils::help
   }

   capture.output(suppressMessages({
      if (length(pieces) > 1) {
         print(help(pieces[2], package = pieces[1], help_type = 'html'))
      } else {
         # try custom help handler, otherwise fall through to default handler
         helpUrl <- .rs.getCustomHelpUrl(token)
         if (!is.null(helpUrl)) {
            if (nzchar(helpUrl)) # handlers return "" to indicate no help available
               utils::browseURL(helpUrl)
         } else {
            print(help(pieces[1], help_type = 'html', try.all.packages = TRUE))
         }
      }
   }))
})

.rs.addFunction("findCustomHelpContext", function(token, handler) {

   # if the token has a '$' in it then it might have a custom
   # help handler that can field this request
   if (grepl("\\$", token)) {

      # split on $ (it has at least one so components will be > 1)
      components <- strsplit(token, "\\$")[[1]]
      topic <- components[[length(components)]]
      source <- paste(components[1:(length(components)-1)], collapse = "$")

      # evaluate the source
      source <- tryCatch(eval(parse(text = source), envir = globalenv()),
                         error = function(e) NULL)

      # look for a help url handler
      if (!is.null(source)) {
         for (cls in class(source)) {
            res <- utils::getAnywhere(paste(handler, ".", cls, sep=""))
            if (length(res$objs) > 0) {
               return(list(
                  topic = topic,
                  source = source,
                  handler = res$objs[[1]]
               ))
            }
         }
      }
   }

   # default to none found
   NULL

})

# check to see whether there is a custom help handler for this token
.rs.addFunction("getCustomHelpUrl", function(token) {
   custom <- .rs.findCustomHelpContext(token, "help_url_handler")
   if (!is.null(custom))
      custom$handler(custom$topic, custom$source)
   else
      NULL
})

.rs.addJsonRpcHandler("execute_r_code", function(code)
{
   # allow 2 seconds to execute code
   setTimeLimit(elapsed = 2, transient = TRUE)
   on.exit(setTimeLimit(), add = TRUE)

   # evaluate requested code
   envir <- parent.frame(2)
   result <- .rs.tryCatch({

      output <- capture.output(
         evaled <- suppressWarnings(
            eval(parse(text = code), envir = envir)
         )
      )

      object <- if (length(output))
         output
      else
         deparse(evaled)

   })

   if (inherits(result, "error"))
      return(.rs.scalar(""))

   .rs.scalar(paste(as.character(object), collapse = "\n"))
})

.rs.addJsonRpcHandler("is_function", function(nameString, envString)
{
   object <- NULL

   if (envString == "")
   {
      object <- .rs.getAnywhere(nameString, parent.frame())
   }
   else
   {
      envString <- .rs.stripSurrounding(envString)
      if (envString %in% search())
      {
         object <- tryCatch(
            get(nameString, pos = which(envString == search())),
            error = function(e) NULL
         )
      }
      else if (envString %in% loadedNamespaces())
      {
         object <- tryCatch(
            get(nameString, envir = asNamespace(envString)),
            error = function(e) NULL
         )
      }
      else if (!is.null(container <- .rs.getAnywhere(envString, parent.frame())))
      {
         if (isS4(container))
         {
            object <- tryCatch(
               eval(call("@", container, nameString)),
               error = function(e) NULL
            )
         }
         else
         {
            object <- tryCatch(
               eval(call("$", container, nameString)),
               error = function(e) NULL
            )
         }
      }
   }
   .rs.scalar(!is.null(object) && is.function(object))
})

.rs.addFunction("asCaseInsensitiveRegex", function(string)
{
   if (string == "")
      return(string)

   splat <- strsplit(string, "", fixed = TRUE)[[1]]
   lowerSplat <- tolower(splat)
   upperSplat <- toupper(splat)
   result <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         splat[i]
      else
         paste("[", lowerSplat[i], upperSplat[i], "]", sep = "")
   })
   paste(result, collapse = "")
})

.rs.addFunction("asCaseInsensitiveSubsequenceRegex", function(string)
{
   if (string == "")
      return(string)

   splat <- strsplit(string, "", fixed = TRUE)[[1]]
   lowerSplat <- tolower(splat)
   upperSplat <- toupper(splat)

   result <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         splat[i]
      else
         paste("[", lowerSplat[i], upperSplat[i], "]", sep = "")
   })

   negated <- vapply(1:length(splat), FUN.VALUE = character(1), USE.NAMES = FALSE, function(i) {
      if (lowerSplat[i] == upperSplat[i])
         paste("[^", splat[i], "]*", sep = "")
      else
         paste("[^", lowerSplat[i], upperSplat[i], "]*", sep = "")
   })

   negated <- c(negated[-1L], "")
   paste(result, negated, sep = "", collapse = "")
})

.rs.addFunction("isSubsequence", function(strings, string)
{
   .Call("rs_isSubsequence", strings, string)
})

.rs.addFunction("whichIsSubsequence", function(strings, string)
{
   which(.rs.isSubsequence(strings, string))
})

.rs.addFunction("selectIsSubsequence", function(strings, string)
{
   .subset(strings, .rs.isSubsequence(strings, string))
})

.rs.addFunction("escapeForRegex", function(regex)
{
   gsub("([\\-\\[\\]\\{\\}\\(\\)\\*\\+\\?\\.\\,\\\\\\^\\$\\|\\#\\s])", "\\\\\\1", regex, perl = TRUE)
})

# Escapes HTML entities in a character vector (text); "attribute" is a boolean indicating whether
# additional characters specific to HTML attributes should be escaped (newlines).
.rs.addFunction("htmlEscape", function(text, attribute = FALSE)
{
   .Call("rs_htmlEscape", text, attribute, PACKAGE = "(embedding)")
})

.rs.addFunction("objectsOnSearchPath", function(token = "",
                                                caseInsensitive = FALSE,
                                                excludeGlobalEnv = FALSE)
{
   search <- search()
   startIdx <- 1
   range <- 1:length(search)

   if (excludeGlobalEnv)
   {
      startIdx <- 2
      search <- search[-1]
      range <- range[-1]
   }

   if (nzchar(token))
   {
      token <- .rs.escapeForRegex(token)
      if (caseInsensitive)
         token <- .rs.asCaseInsensitiveRegex(token)
      pattern <- paste("^", token, sep = "")

      objects <- lapply(range, function(i) {
         ls(pos = i, all.names = TRUE, pattern = pattern)
      })
   }
   else
   {
      objects <- lapply(range, function(i) {
         ls(pos = i, all.names = TRUE)
      })
   }

   names(objects) <- search
   objects
})

.rs.addFunction("assign", function(x, value)
{
   assign(paste(".rs.cache.", x, sep = ""), value, envir = .rs.toolsEnv())
})

.rs.addFunction("get", function(x)
{
   tryCatch(
      get(paste(".rs.cache.", x, sep = ""), envir = .rs.toolsEnv()),
      error = function(e) NULL
   )
})

.rs.addFunction("mget", function(x = NULL)
{
   tryCatch(
      {
         objects <- if (is.null(x))
            .rs.selectStartsWith(objects(envir = .rs.toolsEnv(), all.names = TRUE), ".rs.cache")
         else
            paste(".rs.cache.", x, sep = "")

         mget(objects, envir = .rs.toolsEnv())
      },

      error = function(e) NULL
   )
})

.rs.addFunction("packageNameForSourceFile", function(filePath)
{
   .Call("rs_packageNameForSourceFile", filePath)
})

.rs.addFunction("isRScriptInPackageBuildTarget", function(filePath)
{
   .Call("rs_isRScriptInPackageBuildTarget", filePath)
})

.rs.addFunction("namedVectorAsList", function(vector)
{
   values <- unlist(vector, use.names = FALSE)
   if (!length(values))
      return(list(names = NULL, values = NULL))
   vectorNames <- names(vector)
   names <- unlist(lapply(seq_along(vector), function(i) {
      rep.int(vectorNames[i], length(vector[[i]]))
   }))

   list(names = names, values = values)
})

.rs.addFunction("getDollarNamesMethod", function(object,
                                                 excludeBaseClasses = FALSE,
                                                 envir = globalenv())
{
   classAndSuper <- function(cl)
   {
      # selectSuperClasses throws an error if the class is unknown
      super <- tryCatch(
         methods::selectSuperClasses(cl),
         error = function(e) NULL
      )

      c(cl, super)
   }

   # interleave super classes after the corresponding original classes
   classes <- unlist(lapply(class(object), classAndSuper), recursive = TRUE)

   # either remove or add an explicit (=non-mode) list/environment class
   classes <- if (excludeBaseClasses)
      setdiff(classes, c("list", "environment"))
   else
      c(classes, mode(object))

   for (class in classes)
   {
      # support older getS3method() definitions (without envir)
      method <- if ("envir" %in% names(formals(utils::getS3method)))
      {
         utils::getS3method(
            f = ".DollarNames",
            class = class,
            optional = TRUE,
            envir = envir
         )
      }
      else
      {
         utils::getS3method(
            f = ".DollarNames",
            class = class,
            optional = TRUE
         )
      }

      if (!is.null(method))
         return(method)
   }

   NULL
})

.rs.addJsonRpcHandler("get_args", function(name, src, helpHandler)
{
   if (grepl("::", name) && identical(src, ""))
   {
      bits <- strsplit(name, "::")[[1L]]
      if (length(bits) == 2L)
      {
         name <- bits[2L]
         src <- bits[1L]
      }
   }

   # call custom help handler if provided
   if (nzchar(helpHandler)) {

      # resolve help handler
      helpHandlerFunc <- tryCatch(
         eval(parse(text = helpHandler)),
         error = function(e) NULL
      )

      if (!is.function(helpHandlerFunc))
         return(NULL)

      # invoke handler function
      help <- tryCatch(
         helpHandlerFunc("completion", name, src),
         error = function(e) NULL
      )

      if (is.null(help))
         return(NULL)

      # attempt to retrieve signature
      signature <- help$signature
      if (!is.null(signature)) {
         paren <- regexpr("\\(", signature)[[1]]
         if (paren != -1)
            signature <- substring(signature, paren)
      }
      return(.rs.scalar(signature))
   }

   # if we're getting arguments for 'write.csv', infer arguments
   # based on 'write.table'
   isUtils <-
      identical(src, "package:utils") ||
      identical(src, "utils")

   if (isUtils)
   {
      if (identical(name, "write.csv") ||
          identical(name, "write.csv2"))
      {
         name <- "write.table"
      }
   }

   # NOTE: 'src' can refer either to a package for usages of the form
   # 'utils::alarm()', or an object for usages of the form 'object$method()'.
   # We need to be careful to handle both types.

   # first, try to resolve as environment
   envir <- .rs.tryCatch(.rs.resolveEnvironment(src))
   if (is.environment(envir))
   {
      method <- .rs.tryCatch(get(name, envir = envir, mode = "function"))
      if (is.function(method))
      {
         signature <- .rs.getSignature(method)
         result <- sub("function ", "", signature)
         return(.rs.scalar(result))
      }
   }

   # next, try to resolve as regular R object
   envir <- .rs.getActiveFrame()
   object <- .rs.getAnywhere(src, envir = envir)
   if (!is.null(object))
   {
      # if the user is calling 'R6$new', try inferring objects from the
      # initialize method instead
      method <- if (inherits(object, "R6ClassGenerator") &&
                    identical(name, "new"))
      {
         object$public_methods$initialize
      }
      else
      {
         .rs.tryCatch(object[[name]])
      }

      if (is.function(method))
      {
         signature <- .rs.getSignature(method)
         result <- sub("function ", "", signature)
         return(.rs.scalar(result))
      }
   }

   .rs.scalar("")
})

.rs.addFunction("getActiveArgument", function(object,
                                              matchedCall)
{
   allArgs <- .rs.getFunctionArgumentNames(object)
   matchedArgs <- names(matchedCall)[-1L]
   qualifiedArgsInCall <- setdiff(matchedArgs, "")
   setdiff(allArgs, qualifiedArgsInCall)[1]
})

.rs.addFunction("swap", function(vector, ..., default)
{
   dotArgs <- list(...)

   nm <- names(dotArgs)

   to <- unlist(lapply(seq_along(dotArgs), function(i)
      rep(nm[i], each = length(dotArgs[[i]]))
   ))

   from <- unlist(dotArgs)

   tmp <- to[match(vector, from)]
   tmp[is.na(tmp)] <- default
   tmp
})

.rs.addFunction("scoreMatches", function(strings, string)
{
   .Call("rs_scoreMatches", strings, string)
})

.rs.addFunction("getProjectDirectory", function()
{
   .Call("rs_getProjectDirectory")
})

.rs.addFunction("hasFileMonitor", function()
{
   .Call("rs_hasFileMonitor")
})

.rs.addFunction("doListIndex", function(routine, term, inDirectory, maxCount)
{
   if (!.rs.hasFileMonitor() || is.null(inDirectory))
      return(NULL)

   inDirectory <- suppressWarnings(.rs.normalizePath(inDirectory))
   inDirectory <- gsub("[/\\\\]+$", "", inDirectory)

   .Call(routine, term, inDirectory, as.integer(maxCount))
})

.rs.addFunction("listIndexedFiles", function(term = "",
                                             inDirectory = .rs.getProjectDirectory(),
                                             maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFiles", term, inDirectory, as.integer(maxCount))
})

.rs.addFunction("listIndexedFolders", function(term = "",
                                               inDirectory = .rs.getProjectDirectory(),
                                               maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFolders", term, inDirectory, maxCount)
})

.rs.addFunction("listIndexedFilesAndFolders", function(term = "",
                                                       inDirectory = .rs.getProjectDirectory(),
                                                       maxCount = 200L)
{
   .rs.doListIndex("rs_listIndexedFilesAndFolders", term, inDirectory, maxCount)
})

.rs.addFunction("doGetIndex", function(term = "",
                                       inDirectory = .rs.getProjectDirectory(),
                                       maxCount = 200L,
                                       getter)
{
   if (is.null(inDirectory))
      return(character())

   inDirectory <- suppressWarnings(
      .rs.normalizePath(inDirectory)
   )

   index <- getter(term, inDirectory, maxCount)

   if (is.null(index))
   {
      return(list(
         paths = character(),
         more_available = FALSE
      ))
   }

   paths <- suppressWarnings(.rs.normalizePath(index$paths, winslash = "/"))
   scores <- .rs.scoreMatches(basename(paths), term)
   index$paths <- paths[order(scores)]
   index

})

.rs.addFunction("getIndexedFiles", function(term = "",
                                            inDirectory = .rs.getProjectDirectory(),
                                            maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFiles)
})

.rs.addFunction("getIndexedFolders", function(term = "",
                                              inDirectory = .rs.getProjectDirectory(),
                                              maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFolders)
})

.rs.addFunction("getIndexedFilesAndFolders", function(term = "",
                                                      inDirectory = .rs.getProjectDirectory(),
                                                      maxCount = 200L)
{
   .rs.doGetIndex(term, inDirectory, maxCount, .rs.listIndexedFilesAndFolders)
})

## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
.rs.addFunction("jsonEscapeString", function(value)
{
   if (is.na(value)) return("null")
   chars <- strsplit(value, "", fixed = TRUE)[[1]]
   chars <- vapply(chars, function(x) {
      if (x %in% c('"', '\\', '/'))
         paste('\\', x, sep = '')
      else if (length(charToRaw(x)) == 1 && charToRaw(x) < 32)
         paste('\\u', toupper(format(as.hexmode(as.integer(charToRaw(x))),
                                     width = 4)),
               sep = '')
      else
         x
   }, character(1))
   paste(chars, sep = "", collapse = "")
})

## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
.rs.addFunction("jsonProperty", function(name, value)
{
   paste(sep = "",
         "\"",
         .rs.jsonEscapeString(enc2utf8(name)),
         "\":\"",
         .rs.jsonEscapeString(enc2utf8(value)),
         "\""
   )
})

## NOTE: Specify that a JSON value should be returned as a scalar by
## giving it the 'AsIs' class; ie, by writing 'foo = I(1)', or otherwise
## by using the '.rs.scalar' function.
##
## NOTE: Function may be used by async R process; must not call back into
## 'rs_' compiled code!
##
## NOTE: lists are considered as objects if they are named, and as arrays if
## they are not. If you have an empty list that you want to treat as an object,
## you must give it a names attribute.
##
## Unbox will automatically unbox any 1-length non-list vectors.
.rs.addFunction("toJSON", function(object, unbox = FALSE)
{
   AsIs <- inherits(object, "AsIs") || inherits(object, ".rs.scalar")
   if (is.list(object))
   {
      if (is.null(names(object)))
      {
         return(paste('[', paste(lapply(seq_along(object), function(i) {
            .rs.toJSON(object[[i]], unbox = unbox)
         }), collapse = ','), ']', sep = '', collapse=','))
      }
      else
      {
         return(paste('{', paste(lapply(seq_along(object), function(i) {
            paste(sep = "",
                  '"',
                  .rs.jsonEscapeString(enc2utf8(names(object)[[i]])),
                  '":',
                  .rs.toJSON(object[[i]], unbox = unbox)
            )
         }), collapse = ','), '}', sep = '', collapse = ','))
      }
   }
   else
   {
      n <- length(object)

      # NOTE: For type safety we cannot unmarshal NULL as '{}' as e.g. jsonlite does.
      if (is.null(object))
      {
         if (unbox)
            return('null')
         else
            return('[]')
      }
      else if (n == 0)
      {
         return('[]')
      }
      else if (is.character(object) || is.factor(object))
      {
         object <- paste(collapse = ",", vapply(as.character(object), FUN.VALUE = character(1), USE.NAMES = FALSE, function(x) {
            if (is.na(x)) "null"
            else paste("\"", .rs.jsonEscapeString(enc2utf8(x)), "\"", sep = "")
         }))
      }
      else if (is.numeric(object))
      {
         object[is.na(object)] <- '\"NA\"'
      }
      else if (is.logical(object))
      {
         object <- ifelse(object, "true", "false")
         object[is.na(object)] <- 'null'
      }

      if (AsIs || (unbox && n == 1))
         return(paste(object))
      else
         return(paste('[', paste(object, collapse = ','), ']', sep = '', collapse = ','))
   }
})

.rs.addFunction("recordFunctionInformation", function(node,
                                                      missingEnv,
                                                      symbolsUsedEnv)
{
   if (is.call(node) && length(node) == 2)
   {
      head <- node[[1]]
      second <- node[[2]]
      if (.rs.isSymbolCalled(head, "missing") &&
          is.symbol(second))
      {
         missingEnv[[as.character(second)]] <- TRUE
      }
   }

   ## TODO: Obviously not perfect because of NSE.
   if (is.symbol(node) && !identical(node, quote(expr = )))
      symbolsUsedEnv[[as.character(node)]] <- TRUE
})

.rs.addFunction("emptyNamedList", function()
{
   `names<-`(list(), character())
})

.rs.addFunction("emptyFunctionInfo", function()
{
   list(
      formal_names = character(),
      formal_info  = list(),
      performs_nse = I(0L)
   )
})

# NOTE: This function is used in asynchronous R processes and so
# cannot call back into any RStudio compiled code! Even further,
# `SessionAsyncPackageInformation.cpp` decodes fields based on
# their names, so if you re-name a field here you must modify the
# extraction implementation there as well.
.rs.addFunction("getPackageInformation", function(...)
{
   # force 'rgl' to use the NULL graphics device (avoid inadvertently
   # opening a graphics device / XQuartz window when retrieving completions)
   rgl.useNULL <- getOption("rgl.useNULL")
   options(rgl.useNULL = TRUE)
   on.exit(options(rgl.useNULL = rgl.useNULL), add = TRUE)

   packages <- list(...)
   lapply(packages, function(package) {
      tryCatch(
         .rs.emitPackageInformation(package),
         error = function(e) .rs.emptyFunctionInfo()
      )
   })
})

.rs.addFunction("emitPackageInformation", function(package)
{
   # Explicitly load the library, and do everything we can to hide any
   # package startup messages (because we don't want to put non-JSON
   # on stdout)
   invisible(capture.output(suppressPackageStartupMessages(suppressWarnings({

      ## Don't load the package if a corresponding 00LOCK directory exists.
      ## This gives partial protection against attempting to load a package
      ## while another R process is attempting to modify the library directory.
      has00LOCK <- FALSE
      for (libPath in .libPaths())
      {
         globalLockPath <- file.path(libPath, "00LOCK")
         pkgLockPath <- file.path(libPath, paste("00LOCK", basename(package), sep = "-"))
         if (file.exists(globalLockPath) || file.exists(pkgLockPath))
         {
            has00LOCK <- TRUE
            break
         }
      }

      success <- if (has00LOCK)
         FALSE
      else
         library(package, character.only = TRUE, quietly = TRUE, logical.return = TRUE)

   }))))

   if (!success)
      return(.rs.emptyFunctionInfo())

   # Get the exported items in the NAMESPACE
   # (for search path + `::` completions).
   ns <- asNamespace(package)
   exports <- getNamespaceExports(ns)
   objects <- mget(exports, ns, inherits = TRUE)
   isFunction <- vapply(objects, FUN.VALUE = logical(1), USE.NAMES = FALSE, is.function)
   functions <- objects[isFunction]

   # Figure out the completion types for these objects
   types <- vapply(objects, FUN.VALUE = numeric(1), USE.NAMES = FALSE, .rs.getCompletionType)

   # Find the functions, and generate information on each formal
   # (does it have a default argument; is missingness handled; etc)
   functionInfo <- lapply(functions, .rs.generateFunctionInformation)

   # List data objects exported by this package
   datasets <- .rs.listDatasetsProvidedByPackage(package)

   # Generate the output
   output <- list(
      package = I(package),
      exports = exports,
      types = types,
      function_info = functionInfo,
      datasets = datasets
   )

   # Write the JSON to stdout; the parent will read and process it
   flush.console()
   json <- paste("#!json:", .rs.toJSON(output))
   writeLines(c("", json, ""))
   flush.console()

   # Return output for debug purposes
   invisible(output)
})

.rs.addFunction("generateFunctionInformation", function(func) {

  formals <- formals(func)
  if (!length(formals))
     return(.rs.emptyFunctionInfo())

  formalNames <- names(formals)
  hasDefault <- vapply(formals, FUN.VALUE = integer(1), USE.NAMES = FALSE, function(x) {
     !identical(x, quote(expr = ))
  })

  # Record which symbols in the function body handle missingness,
  # to check if missingness of default arguments is handled
  missingEnv <- new.env(parent = emptyenv())
  usedSymbolsEnv <- new.env(parent = emptyenv())
  .rs.recursiveWalk(body(func), function(node) {
     .rs.recordFunctionInformation(node, missingEnv, usedSymbolsEnv)
  })

  # Figure out which functions perform NSE.
  # TODO: Figure out which arguments are actually involved in NSE.
  performsNse <- .rs.performsNonstandardEvaluation(func)

  formalInfo <- lapply(seq_along(formalNames), function(i) {
     as.integer(c(
        hasDefault[[i]],
        formalNames[[i]] == "..." || exists(formalNames[[i]], envir = missingEnv),
        exists(formalNames[[i]], envir = usedSymbolsEnv)
     ))
  })

  list(
     formal_names = formalNames,
     formal_info  = formalInfo,
     performs_nse = I(as.integer(performsNse))
  )
 
})

# If a function internally calls out to one of these functions,
# we assume that it may perform non-standard evaluation, and avoid
# attempting certain diagnostics on its usages.
#
# Keep in sync with makeNsePrimitives() in RSexp.cpp
.rs.setVar("nse.primitives", c(
   
   # base R primitives
   "bquote",
   "enquote",
   "eval.parent",
   "evalq",
   "expression",
   "library",
   "match.call",
   "quote",
   "require",
   "subset",
   "substitute",
   "sys.call",
   "sys.calls",
   "sys.frame",
   "sys.frames",
   "sys.function",
   "sys.parent",

   # rlang tidy evaluation
   "enexpr",
   "enexprs",
   "enquo",
   "enquos",
   "eval_tidy",
   "quo",
   "quos",

   # dplyr -- not really primitives
   "dplyr_quosures",
   "group_by",
   "group_by_prepare"
   
))

.rs.addFunction("performsNonstandardEvaluation", function(object)
{
   # For S3 generics, search methods as well as the generic for
   # potential usages of non-standard evaluation.
   methods <- .rs.getS3MethodDefinitions(object)
   for (method in methods)
      if (.rs.performsNonstandardEvaluation(method))
         return(TRUE)

   if (is.function(object))
      object <- body(object)

   nsePrimitives <- .rs.getVar("nse.primitives")
   .rs.recursiveSearch(object,
                       .rs.performsNonstandardEvaluationImpl,
                       nsePrimitives = nsePrimitives)
})

.rs.addFunction("performsNonstandardEvaluationImpl", function(node, nsePrimitives)
{
   # Validate that we have a call.
   if (!is.call(node))
      return(FALSE)
   
   # Check for things that look like tidyr evaluation; that is, `{{}}`.
   isDoubleBracket <-
      length(node) == 2L &&
      is.symbol(node[[1L]]) &&
      as.character(node[[1L]]) == "{" &&
      is.call(node[[2L]]) &&
      length(node[[2L]]) == 2L &&
      is.symbol(node[[2L]][[1L]]) &&
      as.character(node[[2L]][[1L]]) == "{"
   
   if (isDoubleBracket)
      return(TRUE)
   
   # Check if this is a call to an NSE primitive.
   head <- node[[1L]]
   if (!is.symbol(head))
      return(FALSE)
   
   headString <- as.character(head)
   if (headString %in% nsePrimitives)
      return(TRUE)

   # Check if this is a call to an NSE primitive, qualified through
   # `::` or `:::`.
   if (headString %in% c("::", ":::") && length(node) == 3L)
   {
      rhs <- node[[3L]]
      if (is.symbol(rhs) && as.character(rhs) %in% nsePrimitives)
         return(TRUE)
   }
   
   # Doesn't appear to be using NSE.
   FALSE
})

.rs.addFunction("recursiveSearch", function(`_node`, fn, ...)
{
   if (fn(`_node`, ...))
      return(TRUE)

   if (is.recursive(`_node`))
      for (i in seq_along(`_node`))
         if (.rs.recursiveSearch(`_node`[[i]], fn, ...))
            return(TRUE)

   return(FALSE)
})

.rs.addFunction("recursiveWalk", function(`_node`, fn, ...)
{
   fn(`_node`, ...)

   if (is.recursive(`_node`))
      for (i in seq_along(`_node`))
         .rs.recursiveWalk(`_node`[[i]], fn, ...)
})

.rs.addFunction("trimWhitespace", function(x)
{
   gsub("^[\\s\\n]+|[\\s\\n]+$", "", x, perl = TRUE)
})

.rs.addFunction("trimCommonIndent", function(string, ...)
{
   splat <- strsplit(string, "\n", fixed = TRUE)[[1]]
   indents <- regexpr("\\S", splat, perl = TRUE)
   indents[indents == -1] <- Inf
   common <- min(indents)
   result <- paste(substring(splat, common, nchar(string)), collapse = "\n")
   dots <- list(...)
   formatted <- if (length(dots)) sprintf(result, ...) else result
   .rs.trimWhitespace(formatted)
})

.rs.addFunction("parseNamespaceImports", function(path)
{
   output <- list(
      import = character(),
      importFrom = list()
   )

   if (!file.exists(path))
      return(output)

   parsed = tryCatch(
      suppressWarnings(parse(path)),
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(output)

   # Loop over parsed entries and fill 'output'
   for (i in seq_along(parsed))
   {
      directive <- parsed[[i]]
      if (length(directive) < 2) next

      directiveName <- as.character(directive[[1]])
      pkgName <- as.character(directive[[2]])

      if (directiveName == "import")
      {
         output$import <- sort(unique(c(output$import, pkgName)))
         next
      }

      if (directiveName == "importFrom")
      {
         exports <- character(length(directive) - 2)
         for (i in 3:length(directive))
            exports[[i - 2]] <- as.character(directive[[i]])
         output$importFrom[[pkgName]] <- sort(unique(c(output$importFrom[[pkgName]], exports)))
         next
      }
   }

   output

})

.rs.addFunction("isSymbolCalled", function(maybeSymbol, name)
{
   is.symbol(maybeSymbol) && as.character(maybeSymbol) == name
})

.rs.addJsonRpcHandler("get_set_class_slots", function(setClassCallString)
{
   onFail <- list()
   parsed <- tryCatch(
      suppressWarnings(parse(text = setClassCallString))[[1]],
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(onFail)

   matched <- tryCatch(
      match.call(methods::setClass, parsed),
      error = function(e) NULL
   )

   if (is.null(parsed))
      return(onFail)

   # NOTE: Previously, R has used 'representation' to
   # store the information about slots; it is now
   # deprecated (from 3.0.0) and the use of 'slots' is
   # encouraged. We'll check for 'slots' first, then
   # fall back to representation if necessary.
   #
   # NOTE: Okay to define a class with no slots / fields.
   field <- if ("slots" %in% names(matched))
      matched[["slots"]]
   else if ("representation" %in% names(matched))
      matched[["representation"]]
   else
      list()

   if (!("Class" %in% names(matched)))
      return(onFail)

   Class <- matched[["Class"]]

   slots <- if (length(field))
      names(field)[-1]
   else
      character()

   types <- if (length(field))
      unlist(lapply(2:length(field), function(i) {
         tryCatch(as.character(field[[i]]), error = function(e) "")
      }))
   else
      character()

   result <- list(
      Class = Class,
      slots = slots,
      types = types
   )
   return(result)
})

.rs.addFunction("tryParseCall", function(text)
{
   tryCatch(
      suppressWarnings(parse(text = text))[[1]],
      error = function(e) NULL
   )
})

.rs.addFunction("tryMatchCall", function(method, call)
{
   tryCatch(
      suppressWarnings(match.call(method, call)),
      error = function(e) NULL
   )
})

.rs.addFunction("extractElement", function(object,
                                           name,
                                           default = NULL)
{
   if (name %in% names(object))
      object[[name]]
   else
      default
})

.rs.addJsonRpcHandler("get_set_generic_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setGeneric, parsed)
   if (is.null(matched))
      return(list())

   generic <- .rs.extractElement(matched, "name", "")
   parameters <- character()
   if ("def" %in% names(matched))
   {
      def <- matched[["def"]]
      if (as.character(def[[1]]) == "function" &&
          length(def) > 1)
      {
         parameters <- names(def[[2]])
      }
   }

   list(
      generic = generic,
      parameters = parameters
   )
})

.rs.addJsonRpcHandler("get_set_method_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setMethod, parsed)
   if (is.null(matched))
      return(list())

   generic <- .rs.extractElement(matched, "f", "")
   parameter.names <- character()
   parameter.types <- character()

   signature <- .rs.extractElement(matched, "signature")
   if (!is.null(signature))
   {
      if (is.call(signature) &&
          length(signature) > 1)
      {
         parameter.names <- names(signature)[-1]
         parameter.types <- unlist(lapply(2:length(signature), function(i) {
            if (is.character(signature[[i]]))
               signature[[i]]
            else
               ""
         }))
      }
      else if (is.character(signature))
      {
         parameter.names <- signature
      }
   }

   list(
      generic = generic,
      parameter.names = parameter.names,
      parameter.types = parameter.types
   )

})

.rs.addJsonRpcHandler("get_set_ref_class_call", function(call)
{
   parsed <- .rs.tryParseCall(call)
   if (is.null(parsed))
      return(list())

   matched <- .rs.tryMatchCall(methods::setRefClass, parsed)
   if (is.null(matched))
      return(list())

   Class <- .rs.extractElement(matched, "Class", "")

   field.names <- character()
   field.types <- character()
   fields <- .rs.extractElement(matched, "fields")

   if (length(fields) > 1)
   {
      field.names <- names(fields)[-1]
      field.types <- unlist(lapply(2:length(fields), function(i) {
         if (is.character(fields[[i]]))
            fields[[i]]
         else
            ""
      }))
   }

   methods <- .rs.extractElement(matched, "methods")
   method.names <- if (length(methods))
      names(methods)[-1]
   else
      character()

   list(
      Class = Class,
      field.names = field.names,
      field.types = field.types,
      method.names = method.names
   )

})

.rs.addFunction("getSetRefClassSymbols", function(callString)
{
   parsed <- .rs.rpc.get_set_ref_class_call(callString)
   unique(as.character(c(
      ".self",
      parsed$field.names,
      parsed$method.names
   )))
})

.rs.addFunction("getR6ClassSymbols", function(callString)
{
   parsed <- .rs.tryParseCall(callString)
   if (is.null(parsed)) return(character())

   symbols <- c("self", "public", "private", "super")
   public <- .rs.extractElement(parsed, "public")
   if (!is.null(public))
      symbols <- c(symbols, names(public)[-1])

   symbols
})

.rs.addFunction("setEncodingUnknownToUTF8", function(object)
{
   if (is.character(object) && Encoding(object) == "unknown")
      Encoding(object) <- "UTF-8"
   else if (is.list(object))
      return(lapply(object, .rs.setEncodingUnknownToUTF8))

   object
})

.rs.addFunction("makePrimitiveWrapper", function(x)
{
   # from the R documentation, args returns:
   #
   #   For a closure, a closure with identical formal argument list but an empty
   #   (NULL) body.
   #
   #   For a primitive, a closure with the documented usage and NULL body. Note
   #   that some primitives do not make use of named arguments and match by
   #   position rather than name.
   #
   # we just need an R closure with the right formals, so args fits nicely
   args(x)
})

.rs.addFunction("extractNativeSymbols", function(DLL, collapse = TRUE)
{
   info <- getDLLRegisteredRoutines(DLL)
   result <- lapply(info, function(routine) {
      as.character(names(routine))
   })

   if (collapse)
      result <- as.character(unlist(result))

   result
})

.rs.addFunction("getNativeSymbols", function(package)
{
   loadedDLLs <- getLoadedDLLs()
   if (package %in% names(loadedDLLs))
      return(.rs.extractNativeSymbols(loadedDLLs[[package]]))

   # we used to try to load and unload the package library to
   # extract symbol information, but this is not safe to do now
   # loading the DLL also implies running its R_init_* hook, and
   # this can imply loading the package (+ its dependencies) --
   # something we normally want to avoid
   character()
})

.rs.addJsonRpcHandler("extract_chunk_options", function(chunkText)
{
   # Attempt to parse the chunk as R code
   parsed <- try(parse(text = chunkText), silent = TRUE)
   if (inherits(parsed, "try-error"))
      return(list())

   # Iterate through the expression tree, looking for calls to opts_chunk$set and
   # extracting their values. Load them up into an environment (which we then return
   # as a list back to the client)
   chunkOptionsEnv <- new.env(parent = emptyenv())
   lapply(parsed, function(node) {
      .rs.recursiveWalk(node, function(node) {

         if (!is.call(node) || length(node) < 2)
            return()

         # Perhaps not the most efficient, but probably the easiest way to detect
         # appropriate calls to `opts_chunk$set`.
         callName <- as.character(node)[[1L]]
         if (callName == "knitr:::opts_chunk$set" ||
             callName == "knitr::opts_chunk$set" ||
             callName == "opts_chunk$set")
         {
            names <- names(node)
            for (i in 2:length(node))
            {
               key <- names[[i]]
               if (key == "")
                  next

               val <- if (is.character(node[[i]]))
                  .rs.surround(node[[i]], with = "\"")
               else
                  format(node[[i]])
               chunkOptionsEnv[[key]] <- val
            }
         }
      })
   })

   # Convert to a list, and ensure each element is interpreted as a scalar
   # (rather than an array containing a single element)
   result <- as.list(chunkOptionsEnv)
   for (i in seq_along(result))
      result[[i]] <- .rs.scalar(result[[i]])

   return(result)
})

.rs.addFunction("enumerate", function(X, FUN, ...)
{
   keys <- if (is.environment(X)) {
      sort(ls(envir = X))
   } else {
      names(X)
   }

   result <- lapply(keys, function(key) {
      FUN(key, X[[key]], ...)
   })

   names(result) <- keys

   result
})

.rs.addFunction("cutpoints", function(data)
{
   diffed <- diff(c(data[1], data))
   which(diffed != 0)
})

.rs.addFunction("recode", function(data, ..., envir = parent.frame())
{
   dots <- eval(substitute(alist(...)))

   for (expr in dots)
   {
      if (length(expr) != 3)
         stop("malformed recoding in .rs.recode()", call. = FALSE)

      lhs <- eval(expr[[2]], envir = envir)
      rhs <- eval(expr[[3]], envir = envir)
      data[data == lhs] <- rhs
   }

   data
})

.rs.addFunction("evalWithAvailableArguments", function(fn, args)
{
   filtered <- args[names(args) %in% names(formals(fn))]
   call <- c(substitute(fn), filtered)
   mode(call) <- "call"
   eval(call, envir = parent.frame())
})

.rs.addFunction("transposeList", function(list)
{
   do.call(Map, c(c, list, USE.NAMES = FALSE))
})

.rs.addFunction("base64encode", function(data, binary = FALSE)
{
   .Call("rs_base64encode", data, binary)
})

.rs.addFunction("base64encodeFile", function(path)
{
   .Call("rs_base64encodeFile", path)
})

.rs.addFunction("base64decode", function(data, binary = FALSE)
{
   .Call("rs_base64decode", data, binary)
})

.rs.addFunction("CRANDownloadOptionsString", function()
{

   # collect options of interest
   options <- options("repos", "download.file.method", "download.file.extra", "HTTPUserAgent")

   # drop attributes on 'repos'
   options[["repos"]] <- c(options[["repos"]])

   # include extra arguments for 'curl' downloader
   if (identical(options[["download.file.method"]], "curl"))
      options[["download.file.extra"]] <- .rs.downloadFileExtraWithCurlArgs()

   # if there is no repo option set in the R session, read it from preferences
   if (identical(length(options[["repos"]]), 0L)) {
      options[["repos"]]["CRAN"] <- .rs.readUiPref("cran_mirror")$url
   }

   # drop NULL entries
   options <- Filter(Negate(is.null), options)

   # deparse values individually. avoid relying on the format
   # of the deparsed output of the whole expression; see e.g.
   # https://github.com/rstudio/rstudio/issues/4916 for example
   # of where this can fail
   vals <- lapply(options, function(option) {

      # replace single quotes with double quotes, so that
      # deparse automatically escapes the inner quotes
      # see: https://github.com/rstudio/rstudio/issues/6597
      # (note these will be translated to single quotes later)
      if (is.character(option))
         option <- gsub("'", "\"", option)

      .rs.deparse(option)
   })

   # join keys and values
   keyvals <- paste(names(options), vals, sep = " = ")

   # create final options command
   opts <- sprintf("options(%s)", paste(keyvals, collapse = ", "))

   # NOTE: we need to quote arguments with single quotes as the command will be
   # submitted using double quotes, and embedded quotes in the command are not
   # properly escaped.
   #
   # TODO: handle embedded quotes properly
   gsub("\"", "'", opts, fixed = TRUE)

})

.rs.addFunction("slice", function(object,
                                  start = 1,
                                  end = length(object))
{
   n <- length(object)
   if (n == 0)
      return(object)

   if (start < 0) start <- n + start
   if (end < 0)   end <- n + end

   start <- max(1, start)
   end   <- min(n, end)

   if (start > end)
      return(object[0])

   return(object[start:end])
})

.rs.addFunction("slotNames", function(object)
{
   # non-S4 objects don't have slot names
   if (!isS4(object))
      return(character())

   # try using the official API to retrieve slot names
   slots <- methods::slotNames(object)
   if (is.character(slots))
      return(slots)

   # if that fails for some reason (e.g. the package that
   # provides the associated class definition is not loaded)
   # then fall back to using object attributes
   slots <- names(attributes(object))
   setdiff(slots, "class")

})

# like deparse(), but always deparsed to a length-one character vector
.rs.addFunction("deparse", function(object,
                                    width.cutoff = 500L,
                                    nlines       = -1L,
                                    collapse     = " ")
{
   # deparse the call
   deparsed <- deparse(
      expr         = object,
      width.cutoff = width.cutoff,
      nlines       = nlines
   )

   # un-escape our inline R objects
   deparsed <- gsub("`<(.*?)>`", "<\\1>", deparsed, perl = TRUE)

   # paste to return as length-one character vector
   paste(deparsed, collapse = collapse)
})

.rs.addFunction("ensureScalarCharacter", function(object)
{
   if (is.character(object) && length(object) == 1)
      return(object)

   fmt <- "'%s' is not a length-one character vector"
   stop(sprintf(fmt, .rs.deparse(substitute(object))), call. = FALSE)
})

.rs.addFunction("isR6NewMethod", function(object)
{
   if (!is.function(object))
      return(FALSE)

   envir <- environment(object)
   if (!inherits(envir, "R6ClassGenerator"))
      return(FALSE)

   identical(object, envir$new)
})

.rs.addFunction("getR6ClassGeneratorMethod", function(object, method)
{
   if (is.function(object))
      object <- environment(object)

   if (!is.environment(object))
      return(NULL)

   if (!inherits(object, "R6ClassGenerator"))
      return(NULL)

   tryCatch(
      object$public_methods[[method]],
      error = function(e) NULL
   )
})

.rs.addFunction("isExternalPointer", function(object)
{
   identical(typeof(object), "externalptr")
})

.rs.addFunction("fileInfo", function(..., extra_cols = TRUE)
{
   suppressWarnings(file.info(..., extra_cols = extra_cols))
})

.rs.addFunction("listDatasetsProvidedByPackage", function(package)
{
   # verify we have a non-empty length-one string
   if (!is.character(package) || length(package) != 1 || !nzchar(package))
      return(character())

   # find the installed package location (returns empty vector on failure)
   location <- find.package(package, quiet = TRUE)
   if (!length(location) || !file.exists(location))
      return(character())

   # construct path to datalist file
   datalist <- file.path(location, "data/datalist")
   if (!file.exists(datalist))
      return(character())

   # read the names of the provided objects
   readLines(datalist, warn = FALSE)

})

.rs.addFunction("tryCatch", function(expr)
{
   tryCatch(

      withCallingHandlers(
         expr,
         warning = function(w) invokeRestart("muffleWarning"),
         message = function(m) invokeRestart("muffleMessage")
      ),

      error = identity
   )
})

.rs.addFunction("resolveAliasedPath", function(path)
{
   .Call("rs_resolveAliasedPath", path, PACKAGE = "(embedding)")
})

.rs.addFunction("readPackageDescription", function(packagePath)
{
   # if this is an installed package with a package metafile,
   # read from that location
   metapath <- file.path(packagePath, "Meta/package.rds")
   if (file.exists(metapath)) {
      metadata <- readRDS(metapath)
      return(as.list(metadata$DESCRIPTION))
   }

   # otherwise, attempt to read DESCRIPTION directly
   descPath <- file.path(packagePath, "DESCRIPTION")
   read.dcf(descPath, all = TRUE)
})

.rs.addFunction("readSourceDocument", function(id)
{
   contents <- .Call("rs_readSourceDocument", as.character(id), PACKAGE = "(embedding)")
   if (is.character(contents))
      Encoding(contents) <- "UTF-8"
   contents
})

.rs.addFunction("parsePackageDependencies", function(contents, extension)
{
   # NOTE: the following regular expressions were extracted from knitr;
   # They were modified to search only R code chunks and skip other chunks
   # such as python, bash, sql, etc that do not contain R dependencies
   # Inline R code in markdown docs is also skipped
   code <- if (identical(extension, ".R"))
      contents
   else if (identical(extension, ".Rmd"))
      .rs.extractRCode(contents,
                       "^[\t >]*```+\\s*\\{[Rr]\\b.*\\}\\s*$",
                       "^[\t >]*```+\\s*$")
   else if (identical(extension, ".Rnw"))
      .rs.extractRCode(contents,
                       "^\\s*<<(.*)>>=.*$",
                       "^\\s*@\\s*(%+.*|)$")
   else if (identical(extension, ".qmd"))
     .rs.extractRCode(contents,
                      "^[\t >]*```+\\s*\\{[Rr]\\b.*\\}\\s*$",
                      "^[\t >]*```+\\s*$")
   if (is.null(code))
      return(NULL)
   # If Quarto and no R code chunks, don't parse further
   # Rmd may have yaml front matter to parse even if no R chunks
   if (identical(gsub("\n", "", code), .rs.scalar("")) && identical(extension, ".qmd"))
      return(NULL)

   # attempt to parse extracted R code
   parsed <- .rs.tryCatch(parse(text = code, encoding = "UTF-8"))
   if (inherits(parsed, "error")) {

      # call 'Sys.setlocale()' to work around an R issue where flags
      # set during parse can effectively be 'leaked' -- 'Sys.setlocale()'
      # effectively resets those flags. see:
      #
      # https://bugs.r-project.org/bugzilla3/show_bug.cgi?id=17484
      # https://github.com/rstudio/rstudio/issues/3658
      #
      if (getRversion() < "3.5.2")
         Sys.setlocale()

      return(character())

   }

   discoveries <- new.env(parent = emptyenv())

   # for R Markdown docs, scan the YAML header (requires the rmarkdown package and the yaml package,
   # a dependency of rmarkdown)
   if (identical(extension, ".Rmd") &&
       is.null(dynGet("__NameSpacesLoading__", NULL)) &&
       requireNamespace("rmarkdown", quietly = TRUE) &&
       requireNamespace("yaml", quietly = TRUE))
   {
      # extract the front matter from the document; accepts a list of lines and returns a list with
      # $front_matter and $body elements
      partitions <- rmarkdown:::partition_yaml_front_matter(
            strsplit(x = contents, split = "\n", fixed = TRUE)[[1]])

      # did we find some front matter?
      front_matter <- partitions[["front_matter"]]
      if (!is.null(front_matter))
      {
         front <- NULL

         tryCatch({
            front <- yaml::read_yaml(text = front_matter, eval.expr = TRUE)
         }, error = function(e) {
            # ignore errors when reading YAML; it's very possible that the document's YAML will not
            # be correct at all times (e.g. during editing)
         })

         # start with an empty output
         output <- NULL

         if (!is.null(names(front[["output"]])))
         {
            # if the output key has children, it will appear as a list name
            # output:
            #   pkg_name::out_fmt:
            #     foo: bar
            output <- names(front[["output"]])[[1]]
         }
         else if (is.character(front[["output"]]))
         {
            # if the output key doesn't have children, it will appear as a plain character
            #
            # output: pkg_name::out_fmt
            output <- front[["output"]]
         }

         # check for references to an R package in output format
         if (!is.null(output))
         {
            format <- unlist(strsplit(output, "::"))
            if (length(format) > 1)
            {
               discoveries[[format[[1]]]] <- TRUE
            }
         }

         # check for runtime: shiny or parameters (requires the Shiny R package)
         runtime <- front[["runtime"]]
         server <- front[["server"]]
         params  <- front[["params"]]
         if (identical(runtime, "shiny") ||
             identical(runtime, "shinyrmd") ||
             identical(runtime, "shiny_prerendered") ||
             identical(server, "shiny") ||
             (is.list(server) && identical(server[["type"]], "shiny")) ||
             !is.null(params))
         {
            discoveries[["shiny"]] <- TRUE
         }

      }
   }

   handleLibraryRequireCall <- function(node) {

      # make sure this is a call to the 'library' or 'require' function
      if (!is.call(node))
         return(FALSE)

      isLibraryOrRequire <-
         identical(node[[1]], as.name("library")) ||
         identical(node[[1]], as.name("require"))

      if (!isLibraryOrRequire)
         return(FALSE)

      # attempt to match the call
      matched <- .rs.tryCatch(match.call(base::library, node))
      if (inherits(matched, "error"))
         return(FALSE)

      # if the 'package' argument is a character vector of length one, we're done
      isPackageArgumentString <-
         is.character(matched$package) &&
         length(matched$package) == 1

      if (isPackageArgumentString) {
         discoveries[[matched$package]] <<- TRUE
         return(TRUE)
      }

      # if it's a symbol, double check character.only argument
      isSafeSymbolLibraryCall <-
         is.symbol(matched$package) &&
         (is.null(matched$character.only) || identical(matched$character.only, FALSE))

      if (isSafeSymbolLibraryCall) {
         discoveries[[as.character(matched$package)]] <<- TRUE
         return(TRUE)
      }

      FALSE

   }

   handleRequireNamespaceCall <- function(node) {

      if (!is.call(node))
         return(FALSE)

      if (!identical(node[[1]], as.name("requireNamespace")))
         return(FALSE)

      matched <- .rs.tryCatch(match.call(base::requireNamespace, node))
      if (inherits(matched, "error"))
         return(FALSE)

      if (is.character(matched$package) && length(matched$package == 1)) {
         discoveries[[matched$package]] <<- TRUE
         return(TRUE)
      }

      FALSE

   }

   handleColonCall <- function(node) {

      # make sure this is a call to the 'library' or 'require' function
      if (!is.call(node))
         return(FALSE)

      isColonCall <-
         length(node) == 3 &&
         (identical(node[[1]], as.name("::")) || identical(node[[1]], as.name(":::")))

      if (!isColonCall)
         return(FALSE)

      # extract package used. note that one can specify the package as
      # both a symbol and as a character string; e.g. this is legal R code
      #
      #   "dplyr"::"mutate"
      #
      # so guard against such usages
      package <- node[[2L]]
      if (is.symbol(package))
         package <- as.character(package)
      if (!is.character(package) || length(package) != 1)
         return(FALSE)

      # all looks good; add the discovery
      discoveries[[package]] <<- TRUE
      TRUE

   }

   .rs.recursiveWalk(parsed, function(node) {
      handleLibraryRequireCall(node) ||
      handleColonCall(node) ||
      handleRequireNamespaceCall(node)
   })

   # return discovered packages
   ls(envir = discoveries)
})

.rs.addFunction("discoverPackageDependencies", function(id, extension)
{
   # check to see if we have available packages -- if none, bail
   available <- .rs.availablePackages()
   if (is.null(available$value))
      return(character())

   # read the associated source file
   contents <- .rs.readSourceDocument(id)
   if (is.null(contents))
      return(character())

   # parse to find packages
   packages <- .rs.parsePackageDependencies(contents, extension)
   # return early if no R code is parsed
   if (is.null(packages))
      return(character())

   # If file is qmd or rmd, and there is R code, rmarkdown is REQUIRED
   if (identical(extension, ".Rmd") || identical(extension, ".qmd"))
      packages <- c("rmarkdown", packages)
   # keep only packages that are available in an active repository
   packages <- packages[packages %in% rownames(available$value)]

   # figure out which packages aren't actually installed. note that we avoid
   # calling 'installed.packages()' explicitly here as this can be very slow
   # on some NFSes; a plain `list.files()` is fine
   installed <- list.files(.libPaths())
   missing <- setdiff(packages, installed)

   # return that list
   missing

})

# like strsplit, but doesn't omit a trailing last entry as in e.g.
#
#    > strsplit("a.b.", ".", fixed = TRUE)
#    [[1]]
#    [1] "a" "b"
#
# also unlists the string by default (as the most common usage is to
# split a single string)
.rs.addFunction("strsplit", function(x, pattern, ..., simplify = TRUE)
{
   m <- gregexpr(pattern, x, ...)
   matches <- regmatches(x, m, invert = TRUE)
   if (simplify && length(matches) == 1)
      matches[[1]]
   else
      matches
})

.rs.addJsonRpcHandler("replace_comment_header", function(command, path, code)
{
   .rs.scalar(
      paste(
         deparse(
            do.call(
               "substitute",
               args = list(
                  eval(
                     parse(
                        text = paste("quote(", command, ")", sep = "")
                     )
                  ),
                  list(
                     .code = code,
                     .file = path
                  )
               )
            )
         ),
         collapse = ""
      )
   )
})

.rs.addFunction("withCache", function(name, expr)
{
   cache <- .rs.getVar(name)
   if (!is.null(cache))
      return(cache)

   result <- force(expr)
   .rs.setVar(name, result)
   result
})

.rs.addFunction("truncate", function(string, n = 200, marker = "<...>")
{
   if (nchar(string) <= n)
      return(string)

   truncated <- substring(string, 1, n - nchar(marker))
   return(paste(truncated, marker))

})

.rs.addFunction("formatListForDialog", function(list, sep = ", ", max = 50L)
{
   # count index entries until we get too long
   nc <- 0L
   ns <- nchar(sep)
   for (index in seq_along(list)) {
      nc <- nc + ns + nchar(list[[index]])
      if (nc > max)
         break
   }

   # collect items
   n <- length(list)
   items <- list

   # subset the list if we overflowed (index didn't reach end)
   # avoid printing 'and 1 other'; no need to subset in that case
   if (index < n - 1L)
      items <- c(list[1:index], paste("and", n - index, "others"))

   # paste and truncate once more for safety
   text <- paste(items, collapse = sep)
   .rs.truncate(text, n = max * 2L)

})

.rs.addFunction("resolveEnvironment", function(envir)
{
   # if this is already an environment, just return it
   if (is.environment(envir))
      return(envir)

   # if this is a numeric, then assume we want an
   # environment by position on the search path
   if (is.numeric(envir))
      return(as.environment(envir))

   # treat empty strings as request for globalenv
   if (is.null(envir) || identical(envir, ""))
      return(globalenv())

   # if this is the name of something on the search path,
   # then as.environment should suffice
   index <- match(envir, search())
   if (!is.na(index))
      return(as.environment(index))

   # if this is the name of a namespace, retrieve that namespace
   if (substring(envir, 1L, 10L) == "namespace:") {
      package <- substring(envir, 11L)
      return(getNamespace(package))
   }

   # otherwise, treat 'envir' directly as the name of a namespace
   getNamespace(envir)

})

.rs.addFunction("stack", function(mode = "list")
{
   .data <- list()
   storage.mode(.data) <- mode
   
   list(
      
      push = function(...) {
         dots <- list(...)
         for (data in dots) {
            if (is.null(data))
               .data[length(.data) + 1] <<- list(NULL)
            else
               .data[[length(.data) + 1]] <<- data
         }
      },
      
      pop = function() {
         item <- .data[[length(.data)]]
         length(.data) <<- length(.data) - 1
         item
      },
      
      peek = function() {
         .data[[length(.data)]]
      },
      
      contains = function(data) {
         data %in% .data
      },
      
      empty = function() {
         length(.data) == 0
      },
      
      get = function(index) {
         if (index <= length(.data)) .data[[index]]
      },
      
      set = function(index, value) {
         .data[[index]] <<- value
      },
      
      clear = function() {
         .data <<- list()
      },
      
      data = function() {
         .data
      }
      
   )
   
})

.rs.addFunction("isAbsolutePath", function(path)
{
   grepl("^(?:/|~|[a-zA-Z]:[/\\])", path)
})

#
# SessionAutomationRemote.R
#
# Copyright (C) 2024 by Posit Software, PBC
#
# Unless you have received self program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# self program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. self program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# NOTE: The functions created by '.rs.automation.addRemoteFunction()' here
# are given access to a special environment containing 'self', which refers
# to the remote object itself, so that other existing remote methods can be
# used. The underlying client connection can also be accessed via self$client.
#
# This isn't the most idiomatic R code, but it helps ensure that new stateful
# methods can be easily added to the 'remote' instance.

# !diagnostics suppress=client,self
.rs.defineVar("automation.remotePrivateEnv", new.env(parent = .rs.toolsEnv()))
.rs.defineVar("automation.remote", new.env(parent = emptyenv()))
.rs.defineVar("automation.remoteInstance", NULL)

.rs.addFunction("test", function(desc, code)
{
   # Check test markers.
   currentMarkers <- .rs.getVar("automation.currentMarkers")
   requestedMarkers <- .rs.getVar("automation.requestedMarkers")
   .rs.setVar("automation.currentMarkers", NULL)
   
   if (length(requestedMarkers))
   {
      matches <- intersect(currentMarkers, requestedMarkers)
      if (length(matches) == 0L)
      {
         if (interactive())
            message("[i] Skipping test (does not have any matching markers).")
         return(invisible(NULL))
      }
   }
   
   # Reset the session before running this test.
   .rs.automation.remoteInstance$session.reset()
   
   # Now, run the test.
   testthat::test_that(desc, code)
})

.rs.addFunction("automation.newRemote", function(mode = NULL)
{
   # Re-use existing remote if requested.
   reuse <- Sys.getenv("RSTUDIO_AUTOMATION_REUSE_REMOTE", unset = "FALSE")
   if (reuse)
   {
      remote <- .rs.automation.remoteInstance
      if (!is.null(remote))
         return(remote)
   }
      
   # Generate the remote instance.
   mode <- .rs.automation.resolveMode(mode)
   client <- .rs.automation.initialize(mode = mode)
   assign("client", client, envir = .rs.automation.remote)
   assign("self", .rs.automation.remote, envir = .rs.automation.remotePrivateEnv)
   .rs.setVar("automation.remoteInstance", .rs.automation.remote)
   remote <- .rs.automation.remoteInstance
   
   # Return the remote instance.
   remote
})

.rs.addFunction("automation.deleteRemote", function(force = FALSE)
{
   # Avoid deleting remote if requested.
   if (!force)
   {
      reuse <- Sys.getenv("RSTUDIO_AUTOMATION_REUSE_REMOTE", unset = "FALSE")
      if (reuse)
         return(invisible(NULL))
   }
   
   remote <- .rs.getVar("automation.remoteInstance")
   if (is.null(remote))
      return(remote)
   
   remote$session.quit()
   .rs.setVar("automation.remoteInstance", NULL)
})

.rs.addFunction("automation.getRemote", function(mode = NULL)
{
   remote <- .rs.nullCoalesce(.rs.automation.remoteInstance, {
      .rs.automation.newRemote(mode = mode)
   })
   
   .rs.setVar("automation.remoteInstance", remote)
   remote
})

.rs.addFunction("automation.addRemoteFunction", function(name, callback)
{
   environment(callback) <- .rs.automation.remotePrivateEnv
   assign(name, callback, envir = .rs.automation.remote)
})


.rs.automation.addRemoteFunction("dom.elementExists", function(selector)
{
   # Query for the requested node.
   document <- self$client$DOM.getDocument(depth = 0L)
   response <- self$client$DOM.querySelector(document$root$nodeId, selector)
   
   # Check for failure.
   nodeId <- response$nodeId
   nodeId != 0L
})

.rs.automation.addRemoteFunction("dom.querySelector", function(selector)
{
   # Query for the requested node.
   document <- self$client$DOM.getDocument(depth = 0L)
   response <- self$client$DOM.querySelector(document$root$nodeId, selector)
   
   # Check for failure.
   nodeId <- response$nodeId
   if (nodeId == 0L)
      stop("No element matching selector '", selector, "' could be found.")
   
   # Describe the discovered node.
   nodeId
})


.rs.automation.addRemoteFunction("dom.querySelectorAll", function(selector)
{
   # Query for all nodes matching the selector.
   document <- self$client$DOM.getDocument(depth = 0L)
   response <- self$client$DOM.querySelectorAll(document$root$nodeId, selector)
   
   # Check for failure.
   nodeIds <- response$nodeIds
   if (length(nodeIds) == 0L)
      stop("No elements matching selector '", selector, "' could be found.")
   
   # Return the list of discovered nodes.
   nodeIds
})

.rs.automation.addRemoteFunction("dom.clickElement", function(selector = NULL,
                                                              objectId = NULL,
                                                              nodeId = NULL,
                                                              verticalOffset = 0L,
                                                              horizontalOffset = 0L,
                                                              button = "left")
{
   # Resolve jsObject from provided parameters.
   objectId <- .rs.nullCoalesce(objectId, {
      
      # Query for the requested node.
      nodeId <- .rs.nullCoalesce(nodeId, {
         .rs.waitUntil(selector, function()
         {
            self$dom.querySelector(selector)
         }, swallowErrors = TRUE)
      })
      
      # Get a JavaScript object ID associated with this node.
      response <- self$client$DOM.resolveNode(nodeId)
      response$object$objectId
      
   })
   
   
   # Use that object ID to request the object's bounding rectangle.
   code <- "function() {
      return JSON.stringify(this.getBoundingClientRect());
   }"
   
   response <- self$client$Runtime.callFunctionOn(
      functionDeclaration = code,
      objectId = objectId
   )
   
   # Compute coordinates for click action. We'll try to target
   # the center of the requested element.
   domRect <- .rs.fromJSON(response$result$value)
   x <- domRect$x + (domRect$width / 2) + horizontalOffset
   y <- domRect$y + (domRect$height / 2) + verticalOffset
   
   # Use the position of that element to simulate a click.
   self$client$Input.dispatchMouseEvent(
      type = "mousePressed",
      x = x,
      y = y,
      button = button,
      clickCount = 1L
   )
   
   self$client$Input.dispatchMouseEvent(
      type = "mouseReleased",
      x = x,
      y = y,
      button = button,
      clickCount = 1L
   )
})

.rs.automation.addRemoteFunction("editor.getInstance", function()
{
   jsCode <- .rs.heredoc('
      var id = $RStudio.last_focused_editor_id;
      var container = document.getElementById(id);
      container.env.editor
   ')
   
   response <- self$client$Runtime.evaluate(expression = jsCode)
   .rs.automation.wrapJsResponse(self, response)
})


.rs.automation.addRemoteFunction("js.eval", function(jsExpr)
{
   # Implicit return for single-line expressions.
   jsExpr <- strsplit(jsExpr, "\n", fixed = TRUE)[[1L]]
   if (length(jsExpr) == 1L && !.rs.startsWith(jsExpr, "return "))
      jsExpr <- paste("return", jsExpr)
   
   # Build a command that executes the Javascript, and returns as JSON.
   jsStringifyExpr <- sprintf(
      "JSON.stringify((function() { %s })())",
      paste(jsExpr, collapse = "\n")
   )
   
   # Execute it.
   jsResponse <- self$client$Runtime.evaluate(expression = jsStringifyExpr)
   
   # Check for error.
   if (!is.null(jsResponse$exceptionDetails))
      stop(jsResponse$exceptionDetails$exception$description)
   
   # Marshal values back to R.
   .rs.fromJSON(jsResponse$result$value)
})

.rs.automation.addRemoteFunction("js.call", function(objectId, jsFunc)
{
   # Wrap provided code into a function if necessary.
   if (!grepl("^function\\b", jsFunc))
   {
      # Implicit return for single-line expressions.
      lines <- strsplit(jsFunc, "\n", fixed = TRUE)[[1L]]
      if (length(lines) == 1L && !.rs.startsWith(lines, "return "))
         lines <- paste("return", lines)
      
      # Wrap into a function.
      jsFunc <- sprintf("function() { %s }", paste(lines, collapse = "\n"))
   }
   
   # Wrap so that we can return JSON.
   self$client$Runtime.callFunctionOn(
      functionDeclaration = jsFunc,
      objectId = objectId
   )
})

.rs.automation.addRemoteFunction("js.querySelector", function(selector)
{
   response <- .rs.waitUntil(selector, function()
   {
      nodeId <- self$dom.querySelector(selector)
      self$client$DOM.resolveNode(nodeId)
   }, swallowErrors = TRUE)
   
   .rs.automation.wrapJsResponse(self, response)
})

.rs.automation.addRemoteFunction("js.querySelectorAll", function(selector)
{
   response <- .rs.waitUntil(selector, function()
   {
      nodeIds <- self$dom.querySelectorAll(selector)
      lapply(nodeIds, self$client$DOM.resolveNode)
   }, swallowErrors = TRUE)

   .rs.automation.wrapJsResponse(self, response)
})

.rs.automation.addRemoteFunction("keyboard.insertText", function(...)
{
   reShortcut <- "^\\<(.*)\\>$"
   for (input in list(...))
   {
      if (grepl(reShortcut, input, perl = TRUE))
      {
         shortcut <- sub(reShortcut, "\\1", input, perl = TRUE)
         self$keyboard.executeShortcut(shortcut)
      }
      else if (nzchar(input))
      {
         self$client$Input.insertText(input)
      }
   }
})

.rs.automation.addRemoteFunction("modals.click", function(buttonName)
{
   .rs.tryCatch({
      buttonSelector <- sprintf("#rstudio_dlg_%s", buttonName)
      buttonId <- self$dom.querySelector(buttonSelector)
      self$dom.clickElement(objectId = buttonId)
      TRUE
   })
})

.rs.automation.addRemoteFunction("session.quit", function()
{
   # Try to gracefully shut down the browser. We use a timeout
   # so we can close the socket cleanly while the browser window
   # is still alive.
   self$js.eval('setTimeout(function() { window.close(); }, 1000)')
   
   # Close the websocket connection.
   self$client$socket$close()
   
   # Wait until the socket is closed.
   .rs.waitUntil("websocket closed", function()
   {
      self$client$socket$readyState() == 3L
   })
   
   # Kill the running process.
   .rs.automation.agentProcess$kill()
   
   # Wait until it's no longer around.
   alive <- TRUE
   .rs.waitUntil("process stopped", function()
   {
      alive <<- !.rs.automation.agentProcess$is_alive()
   })
   
   invisible(alive)
})

.rs.automation.addRemoteFunction("session.reset", function()
{
   # Clear any popups that might be visible.
   self$keyboard.insertText("<Escape>")
   
   # Clear any text that might be set in the console.
   self$commands.execute("activateConsole")
   self$keyboard.insertText("<Command + A>", "<Backspace>")
   
   # Close any open documents.
   self$console.executeExpr({
      .rs.api.closeAllSourceBuffersWithoutSaving()
      rm(list = ls())
   }, wait = FALSE)
   
   # Clear the console.
   self$keyboard.insertText("<Ctrl + L>")
})

#
# SessionDiagnostics.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

.rs.setVar(
   "r.keywords",
   c(
      "TRUE",
      "FALSE",
      "NA",
      "NA_real_",
      "NA_complex_",
      "NA_integer_",
      "NA_character_",
      "NULL",
      "Inf",
      "else",
      "in"
   )
)

.rs.addFunction("setLintEngine", function(engine)
{
   if (identical(engine, "internal"))
      .rs.setVar("r.lint.engine", .rs.internalLintEngine)
   else if (!is.function(engine))
      stop("'engine' must be a function taking a single argument (file path)")
   else
      .rs.setVar("r.lint.engine", engine)
})

.rs.addFunction("getLintEngine", function()
{
   engine <- .rs.getVar("r.lint.engine")
   if (is.null(engine))
      .rs.internalLintEngine
   else
      engine
})

.rs.addFunction("lint", function(filePath)
{
   engine <- .rs.getLintEngine()
   invisible(engine(filePath))
})

.rs.addFunction("availableRSymbols", function()
{
   unlist(c(
      .rs.objectsOnSearchPath(excludeGlobalEnv = TRUE),
      .rs.getVar("r.keywords")
   ))
})

.rs.addFunction("internalLintEngine", function(filePath)
{
   if (!file.exists(filePath))
      return(list())

   filePath <- .rs.normalizePath(filePath, mustWork = TRUE)
   lint <- .rs.lintRFile(filePath)
   invisible(.rs.showLintMarkers(lint, filePath))
})

.rs.addFunction("lintRFile", function(filePath)
{
   .Call("rs_lintRFile", filePath)
})

.rs.addFunction("showLintMarkers", function(lint, filePath)
{
   markers <- .rs.createMarkersFromLint(lint, filePath)
   .rs.api.sourceMarkers(
      name = "Diagnostics",
      markers = markers,
      basePath = .rs.getProjectDirectory(),
      isDiagnostics = true
   )
})

.rs.addFunction("createMarkersFromLint", function(lint, file) {
   lapply(lint, function(x) {
      list(
         type = x$type,
         file = file,
         line = x$start.row,
         column = x$start.column,
         message = x$message
      )
   })
})

.rs.addFunction("extractRCode", function(content,
                                         reStart,
                                         reEnd)
{
   # This function should be called with content that is already known
   # to be UTF-8 encoded; however, that encoding can be lost when forming
   # this call so bring the encoding back.
   Encoding(content) <- "UTF-8"

   splat <- strsplit(content, "\n", fixed = TRUE)[[1]]
   starts <- grep(reStart, splat, perl = TRUE)
   ends <- grep(reEnd, splat, perl = TRUE)

   # Get start/end pairs
   pairs <- lapply(starts, function(i) {
      following <- ends[ends > i]
      if (!length(following)) return(NULL)
      c(i, following[[1]])
   })

   # Drop NULL
   pairs[unlist(lapply(pairs, is.null))] <- NULL

   new <- character(length(splat))
   for (pair in pairs)
   {
      start <- pair[[1]]
      end <- pair[[2]]

      # Ignore pairs that include 'eval = FALSE'.
      if (grepl("eval\\s*=\\s*F", splat[[start]], perl = TRUE))
         next

      # Ignore pairs that include 'engine=', assuming they're non-R chunks.
      #
      # 'Rscript' chunks would work standalone and hence the linter would not
      # properly understand that it should discard the parse tree generated
      # from prior chunks, so we just don't lint it.
      if (grepl("engine\\s*=", splat[[start]], perl = TRUE))
         next

      # If the chunk end lies immediately after the chunk start, bail
      if (start + 1 == end)
         next

      new[(start + 1):(end - 1)] <- splat[(start + 1):(end - 1)]
   }
   .rs.scalar(paste(new, collapse = "\n"))
})

.rs.addFunction("lintDirectory", function(directory = .rs.getProjectDirectory())
{
   .Call("rs_lintDirectory", directory)
})

.rs.addJsonRpcHandler("analyze_project", function(directory = .rs.getProjectDirectory())
{
   .rs.lintDirectory(directory)
})

#
# SessionJobs.R
#
# Copyright (C) 2022 by Posit Software, PBC
#
# Unless you have received this program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# this program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Helpers --------------------------------------------------------------------

.rs.addFunction("scriptActions", function() {
   list(
     stop = function(id) {
        .Call("rs_stopScriptJob", id, PACKAGE = "(embedding)")
     },
     replay = function(id) {
        .Call("rs_replayScriptJob", id, PACKAGE = "(embedding)")
     }
   )
})

# API functions --------------------------------------------------------------

.rs.addApiFunction("listJobs", function() {
   .Call("rs_listJobs", PACKAGE = "(embedding)")
})

.rs.addApiFunction("addJob", function(name, status = "", progressUnits = 0L,
      actions = NULL, running = FALSE, autoRemove = TRUE, group = "", show = TRUE,
      launcherJob = FALSE, tags = NULL) {

   # validate arguments
   if (missing(name))
      stop("Cannot add a job without a name.")
   if (!is.integer(progressUnits) || progressUnits < 0L || progressUnits > 1000000L)
      stop("progressUnits must be an integer between 1 and 1000000, or 0 to disable progress.")

   # begin tracking job
   .Call("rs_addJob", name, status, progressUnits,
      actions, running, autoRemove, group, show, launcherJob, tags, PACKAGE = "(embedding)")
})

.rs.addApiFunction("removeJob", function(job) {
   if (missing(job))
      stop("Must specify job ID to remove.")
   .Call("rs_removeJob", job, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobProgress", function(job, units) {
   if (missing(job))
      stop("Must specify job ID to set progress for.")
   if (missing(units))
      stop("Must specify number of progress units to set.")
   .Call("rs_setJobProgress", job, units, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("addJobProgress", function(job, units) {
   if (missing(job))
      stop("Must specify job ID to add progress to.")
   if (missing(units))
      stop("Must specify number of progress units to add")
   .Call("rs_addJobProgress", job, units, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobStatus", function(job, status) {
   if (missing(job))
      stop("Must specify job ID to set status for.")
   if (missing(status))
      stop("Must specify job status to update.")
   .Call("rs_setJobStatus", job, status, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("setJobState", function(job, state = c("idle", "running", "succeeded",
                                                          "cancelled", "failed")) {
   if (missing(job))
      stop("Must specify job ID to change state for.")
   state <- match.arg(state)
   .Call("rs_setJobState", job, state, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("addJobOutput", function(job, output, error = FALSE) {
   .Call("rs_addJobOutput", job, output, error, PACKAGE = "(embedding)")
   invisible(NULL)
})

.rs.addApiFunction("runScriptJob", function(path, 
                                            name = NULL,
                                            encoding = "unknown",
                                            workingDir = NULL, 
                                            importEnv = FALSE,
                                            exportEnv = "") {
   if (missing(path))
      stop("Must specify path to R script to run.")
   if (!file.exists(path))
      stop("The R script '", path, "' does not exist.")
   .Call("rs_runScriptJob", path, name, encoding, workingDir, importEnv, exportEnv, 
         PACKAGE = "(embedding)")
})

.rs.addApiFunction("executeJobAction", function(job, action) {
   if (missing(job))
      stop("Must specify job ID to execute action for.")
   .Call("rs_executeJobAction", job, action, PACKAGE = "(embedding)")
})

.rs.addApiFunction("stopJob", function(job) {
   .rs.api.executeJobAction(job, "stop")
})

.rs.addApiFunction("getJobState", function(job) {
   .Call("rs_getJobState", job, PACKAGE = "(embedding)")
})

version <- getRversion()
cat("--- YAML_START ---\n")
cat("versionMajor:", version$major, "\n")
cat("versionMinor:", version$minor, "\n")
cat("versionPatch:", version$patch, "\n")
cat("home:", R.home(), "\n")
cat("libPaths:\n")
for (lib in .libPaths()) {
  cat(paste0('  - ', shQuote(lib)), "\n")
}
cat("packages:\n")
cat("  knitr: ")
if (requireNamespace("knitr", quietly = TRUE)) {
  cat(paste0('\"', as.character(utils::packageVersion("knitr")), '\"'))
} else {
  cat("null")
}
cat("\n")
cat("  rmarkdown: ")
if (requireNamespace("rmarkdown", quietly = TRUE)) {
  cat(paste0('\"', as.character(utils::packageVersion("rmarkdown")), '\"'))
} else {
  cat("null")
}
cat("\n")
cat("--- YAML_END ---\n")

#
# SessionAutomationTargets.R
#
# Copyright (C) 2024 by Posit Software, PBC
#
# Unless you have received self program directly from Posit Software pursuant
# to the terms of a commercial license agreement with Posit Software, then
# self program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. self program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#
#

# Aliases for common DOM element targets that we might want to use.
.rs.setVar("automation.targets", list(
   # NYI
))

#!/usr/bin/env bash
# This script manages RStudio's JupyterLab environment

set -e

setJupyterExecutable() {
   exe=$(grep exe $configFile | sed 's/.*\(exe=\)\(.[^ ]*\).*/\2/')
   if [[ -z "$exe" ]]; then
      exe='/usr/local/bin/jupyter' # use default value
   fi
}

# sets global environment variables JLAB_EXT_NAME, JLAB_EXT_VERSION, and JLAB_EXT_VERSION_STRING
# expects to be passed the path to the jupyter executable
setupEnvironment() {
   local jupyterPath="$1"
   if [ -z "${jupyterPath}" ]; then
      jupyterPath=$(setJupyterExecutable)
   fi

   # set jupyterlab global variables
   local versionOutput
   versionOutput="$("${jupyterPath}" lab --version 2>&1)"

   if [[ "$(echo "$versionOutput" | cut -d. -f1)" -ge 4 ]]; then
      export JLAB_EXT_NAME="pwb_jupyterlab"
      export JLAB_EXT_VERSION="1.0"
   else
      export JLAB_EXT_NAME="workbench_jupyterlab"
      export JLAB_EXT_VERSION="1.1"
   fi
   export JLAB_EXT_VERSION_STRING="${JLAB_EXT_NAME}~=${JLAB_EXT_VERSION}"

   # set jupyter notebook global variables
   export JNOTEBOOK_VERSION="$("${jupyterPath}" notebook --version 2>&1)"
}

# ---------------------------------------------------------------------------------------------
#   Copyright (c) Microsoft Corporation. All rights reserved.
#   Licensed under the MIT License. See License.txt in the project root for license information.
# ---------------------------------------------------------------------------------------------
#
# Visual Studio Code terminal integration for fish
#
# Manual installation:
#
#   (1) Add the following to the end of `$__fish_config_dir/config.fish`:
#
#         string match -q "$TERM_PROGRAM" "vscode"
#         and . (code --locate-shell-integration-path fish)
#
#   (2) Restart fish.

# Don't run in scripts, other terminals, or more than once per session.
status is-interactive
and string match --quiet "$TERM_PROGRAM" "vscode"
and ! set --query VSCODE_SHELL_INTEGRATION
or exit

set --global VSCODE_SHELL_INTEGRATION 1

# Apply any explicit path prefix (see #99878)
if status --is-login; and set -q VSCODE_PATH_PREFIX
	set -gx PATH "$VSCODE_PATH_PREFIX$PATH"
end
set -e VSCODE_PATH_PREFIX

set -g __vsc_applied_env_vars 0
function __vsc_apply_env_vars
	if test $__vsc_applied_env_vars -eq 1;
		return
	end
	set -l __vsc_applied_env_vars 1
	# Apply EnvironmentVariableCollections if needed
	if test -n "$VSCODE_ENV_REPLACE"
		set ITEMS (string split : $VSCODE_ENV_REPLACE)
		for B in $ITEMS
			set split (string split = $B)
			set -gx "$split[1]" (echo -e "$split[2]")
		end
		set -e VSCODE_ENV_REPLACE
	end
	if test -n "$VSCODE_ENV_PREPEND"
		set ITEMS (string split : $VSCODE_ENV_PREPEND)
		for B in $ITEMS
			set split (string split = $B)
			set -gx "$split[1]" (echo -e "$split[2]")"$$split[1]" # avoid -p as it adds a space
		end
		set -e VSCODE_ENV_PREPEND
	end
	if test -n "$VSCODE_ENV_APPEND"
		set ITEMS (string split : $VSCODE_ENV_APPEND)
		for B in $ITEMS
			set split (string split = $B)
			set -gx "$split[1]" "$$split[1]"(echo -e "$split[2]") # avoid -a as it adds a space
		end
		set -e VSCODE_ENV_APPEND
	end
end

# Handle the shell integration nonce
if set -q VSCODE_NONCE
	set -l __vsc_nonce $VSCODE_NONCE
	set -e VSCODE_NONCE
end

# Helper function
function __vsc_esc -d "Emit escape sequences for VS Code shell integration"
	builtin printf "\e]633;%s\a" (string join ";" -- $argv)
end

# Sent right before executing an interactive command.
# Marks the beginning of command output.
function __vsc_cmd_executed --on-event fish_preexec
	__vsc_esc E (__vsc_escape_value "$argv") $__vsc_nonce
	__vsc_esc C

	# Creates a marker to indicate a command was run.
	set --global _vsc_has_cmd
end


# Escape a value for use in the 'P' ("Property") or 'E' ("Command Line") sequences.
# Backslashes are doubled and non-alphanumeric characters are hex encoded.
function __vsc_escape_value
	# Escape backslashes and semi-colons
	echo $argv \
	| string replace --all '\\' '\\\\' \
	| string replace --all ';' '\\x3b' \
	;
end

# Sent right after an interactive command has finished executing.
# Marks the end of command output.
function __vsc_cmd_finished --on-event fish_postexec
	__vsc_esc D $status
end

# Sent when a command line is cleared or reset, but no command was run.
# Marks the cleared line with neither success nor failure.
function __vsc_cmd_clear --on-event fish_cancel
	__vsc_esc D
end

# Preserve the user's existing prompt, to wrap in our escape sequences.
function __preserve_fish_prompt --on-event fish_prompt
	if functions --query fish_prompt
		if functions --query __vsc_fish_prompt
			# Erase the fallback so it can be set to the user's prompt
			functions --erase __vsc_fish_prompt
		end
		functions --copy fish_prompt __vsc_fish_prompt
		functions --erase __preserve_fish_prompt
		# Now __vsc_fish_prompt is guaranteed to be defined
		__init_vscode_shell_integration
	else
		if functions --query __vsc_fish_prompt
			functions --erase __preserve_fish_prompt
			__init_vscode_shell_integration
		else
			# There is no fish_prompt set, so stick with the default
			# Now __vsc_fish_prompt is guaranteed to be defined
			function __vsc_fish_prompt
				echo -n (whoami)@(prompt_hostname) (prompt_pwd) '~> '
			end
		end
	end
end

# Sent whenever a new fish prompt is about to be displayed.
# Updates the current working directory.
function __vsc_update_cwd --on-event fish_prompt
	__vsc_esc P Cwd=(__vsc_escape_value "$PWD")

	# If a command marker exists, remove it.
	# Otherwise, the commandline is empty and no command was run.
	if set --query _vsc_has_cmd
		set --erase _vsc_has_cmd
	else
		__vsc_cmd_clear
	end
end

# Sent at the start of the prompt.
# Marks the beginning of the prompt (and, implicitly, a new line).
function __vsc_fish_prompt_start
	# Applying environment variables is deferred to after config.fish has been
	# evaluated
	__vsc_apply_env_vars
	__vsc_esc A
end

# Sent at the end of the prompt.
# Marks the beginning of the user's command input.
function __vsc_fish_cmd_start
	__vsc_esc B
end

function __vsc_fish_has_mode_prompt -d "Returns true if fish_mode_prompt is defined and not empty"
	functions fish_mode_prompt | string match -rvq '^ *(#|function |end$|$)'
end

# Preserve and wrap fish_mode_prompt (which appears to the left of the regular
# prompt), but only if it's not defined as an empty function (which is the
# officially documented way to disable that feature).
function __init_vscode_shell_integration
	if __vsc_fish_has_mode_prompt
		functions --copy fish_mode_prompt __vsc_fish_mode_prompt

		function fish_mode_prompt
			__vsc_fish_prompt_start
			__vsc_fish_mode_prompt
		end

		function fish_prompt
			__vsc_fish_prompt
			__vsc_fish_cmd_start
		end
	else
		# No fish_mode_prompt, so put everything in fish_prompt.
		function fish_prompt
			__vsc_fish_prompt_start
			__vsc_fish_prompt
			__vsc_fish_cmd_start
		end
	end
end
__preserve_fish_prompt

@echo off
setlocal
set ROOT_DIR=%~dp0..\..\..\..
set VSROOT_DIR=%~dp0..\..
call "%ROOT_DIR%\node.exe" "%VSROOT_DIR%\out\server-cli.js" "code-server" "1.77.3" "704ed70d4fd1c6bd6342c436f1ede30d1cff4710" "code-server.cmd" "--openExternal" %*
endlocal

#!/usr/bin/env sh
#
# Copyright (c) Microsoft Corporation. All rights reserved.
#
ROOT="$(dirname "$(dirname "$(dirname "$(readlink -f "$0")")")")"

APP_NAME="code-server"
VERSION="1.93.0"
COMMIT="38864289bf625c8ce6892e40c6e190c9d2f1d867"
EXEC_NAME="code-server"
CLI_SCRIPT="$ROOT/out/server-cli.js"
"$ROOT/node" "$CLI_SCRIPT" "$APP_NAME" "$VERSION" "$COMMIT" "$EXEC_NAME" "--openExternal" "$@"

<%
// Fields
const fields = listing.fields;

// Image properties
const imageAlign = listing['image-align'] || 'left';
const imageHeight = listing['image-height'];

// Fields that don't have a known place to be displayed in this template
const otherFields = fields.filter(field => {
return !["title", "image", "image-alt", "date", "author", "subtitle", "description", "reading-time", "categories"].includes(field);
});

// Capture the item number for utility functions that need it
const itemNumber = listing.utilities.itemNumber();

// Writes a metadata value
const outputMetadata = (item, field) => {

const readField = (item, field) => {
let value = item[field];
if (field.includes(".") && !field.endsWith(".") && !field.startsWith(".")) {
const fields = field.split(".");
value = item;
for (const deref of fields) {
value = value[deref];
}
}
return value;
}

let value = readField(item, field);
if (value !== undefined) {
print(`<div class="metadata-value listing-${field}">${listing.utilities.outputLink(item, field, value)}</div>`);  
 }
}
%>

<div class="quarto-post image-<%= imageAlign %>" <%= listing.utilities.metadataAttrs(item) %>>
<% if (fields.includes('image')) { %>
<div class="thumbnail">
<a href="<%- item.path %>" class="no-external">
<% if (item.image) { %>
<%= listing.utilities.img(itemNumber, item.image, "thumbnail-image", item['image-alt'], item['image-lazy-loading'] ?? listing['image-lazy-loading']) %>
<% } else { %>
<%= listing.utilities.imgPlaceholder(listing.id, itemNumber, item.outputHref) %>
<% } %>
</a>
</div>
<% } %>
<div class="body">
<% if (fields.includes('title')) { %>
<h3 class="no-anchor listing-title"><a href="<%- item.path %>" class="no-external"><%= item.title %></a></h3>
<div class="listing-subtitle"><a href="<%- item.path %>" class="no-external"><%= item.subtitle %></a></div>
<% } %>
<% if (fields.includes('categories') && item.categories) { %> 
<div class="listing-categories">
<% for (const category of item.categories) { %>
<div class="listing-category" onclick="window.quartoListingCategory('<%=category%>'); return false;"><%= category %></div>
<% } %>
</div>
<% } %> 
<% if (fields.includes('description')) { %>
<div class="delink listing-description"><a href="<%- item.path %>" class="no-external"><%= item.description %></a></div>
<% } %>
</div>
<div class="metadata"><a href="<%- item.path %>" class="no-external">
<% if (fields.includes('date') && item.date) { %><div class="listing-date">`<%= item.date %>`{=html}</div><% } %>
<% if (fields.includes('author') && item.author) { %><div class="listing-author"><%= item.author %></div><% } %>
<% if (fields.includes('reading-time') && item['reading-time']) { %> <div class="listing-reading-time"><%= item['reading-time'] %></div> <% } %>
<% for (const field of otherFields) { %>
<% outputMetadata(item, field) %><% } %></a></div>

</div>
